function [ff,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,q,Gamma,Gam_muG] = ssteadystate(rk,phi, ...
    Fomegabar,mu,gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
    lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw)

addpath('c:\projects\ECB\August2005\Ramsey\models\cee');
if sw ~= 1
    
[pitild,pstar,piw,pitildw,wstar,wplus,mc] = ssstate(infl, ...
    muup,muz,beta,tauk,delta,upsil,iota1,iota2,pibar, ...
    xip,lambdaf,iotaw1,iotaw2,xiw,lambdaw,sigmaL,alpha,epsil);

else
    
    infl=pibar;%when sw=1, then compute steady state for the case, infl=pibar
    pitild=infl;
    pstar=1;
    piw=muz*infl;
    pitildw=infl;
    wstar=1;
    wplus=1;
    mc=1/lambdaf;
    
end

wwstar=(wstar^(lambdaw/(lambdaw-1)));
hk=(1/muz)*(1/wwstar)*(rk/(mc*alpha))^(1/(1-alpha));
Rk=(rk+(1-delta))*infl-1;
s=(1+Rk)/(1+R);
[sigma,omegabar,Gamma,Gam_muG,ix] = getomega(s,Fomegabar,mu);
q=1;

if ix == 0
    kn=1/(1-s*Gam_muG);
    G=Gamma-omegabar*(1-Fomegabar);
    n=we/( 1 - (gam/(infl*muz))*( Rk - R - mu*G*(1+Rk) )*kn - gam*((1+R)/(infl*muz)) );
    k=kn*n;
    h=hk*k;
    I=k*(1-(1-delta)/muz);
    w = mc * (1-alpha) * ((wwstar*hk*muz)^(-alpha)) ;
    d=mu*G*(1+Rk)*k/(infl*muz);
    if sw == 1
        phi=((k/muz)^alpha)*(h^(1-alpha))*(1-1/lambdaf);
    end
    yz=(pstar^(lambdaf/(lambdaf-1))) * ((k/muz)^alpha) * ((wwstar*h)^(1-alpha)) - phi;
    c = yz - bigtheta*((1-gam)/gam)*(n-we) - I - d;
    lambdaz=(muz-b*beta)/(c*(muz-b));
    f0=1-xiw*((pitildw/infl)^(1/(1-lambdaw)));
    ffnum=1-beta*xiw*((pitildw/infl)^(1/(1-lambdaw)));
    ffden=1-beta*xiw*((pitildw/infl)^((1+sigmaL)*lambdaw/(1-lambdaw)));
    f1=(f0/(1-xiw))^(lambdaw*(1+sigmaL)-1);
    W=(wwstar^sigmaL)*f1*ffnum/ffden;
    hh=(lambdaz*w/(W*lambdaw*psiL))^(1/sigmaL);
    if n > 0 & k > 0 & h > 0 & I > 0 & w > 0 & c > 0 & hh > 0
        ff=h-hh;
    else
        ff=10000;
    end
else
    ff=10000;
end

