function [rk,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,R,Fp,Kp,Fw,Kw,ucz,q,Gamma,Gam_muG] = steadystate(lambdaf, ...
    infl,muz,beta,delta,Fomegabar,mu,alpha,gam,sigmaL,psiL,lambdaw,we,bigtheta,b,phi, ...
    muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil)

sw=0;
if phi == 0;%in this case, solve for phi assuming inflation = pibar
    sw=1;
    infl=pibar;
end

addpath('c:\projects\ecb\august2005\euroarea_code')
R=infl*muz/beta-1;
rkk=[muz/beta-(1-delta)+.00001:.001:0.08];

rk=rkk(1);
[ffold] = ssteadystate(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
    bigtheta,we,beta,psiL,sigmaL, ...
    lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw);
ix=0;  
fx(1)=ffold;
for ii = 2:length(rkk)
    rk=rkk(ii);
    [ff] = ssteadystate(rk,phi,Fomegabar,mu,gam,delta,infl,R,muz,lambdaf, ...
        bigtheta,we,beta,psiL,sigmaL, ...
        lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw);
    
    if ff > 0 & ffold < 0
        
        ix=ix+1;
        I(ix)=ii;
        
    end
    ffold=ff;
    fx(ii)=ff;
end

if ix > 1
    error('fatal (steadystate) found more than one steady state')
end
if ix == 0
    dbstop in steadystate at 43

    error('fatal (steadystate) failed to bracket a steady state')
end
rk1=rkk(I(ix)-1);
rk2=rkk(I(ix));

opt=optimset('diagnostics','on','LevenbergMarquardt','on','TolX',1e-16,'TolFun',1e-16);
[rkopt,fval,exitflag,output] =   fzero(@ssteadystate,[rk1,rk2],opt,phi,Fomegabar,mu, ...
    gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
    lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw);
if abs(fval ) > .1e-9 | abs(imag(rkopt))>.1e-10 | exitflag <= 0
    error('fatal (steadystate) failed to find steady state')
end

rk=rkopt;

[ff,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
        pitildw,wstar,wplus,Rk,q,Gamma,Gam_muG] = ssteadystate(rk,phi,Fomegabar,mu, ...
    gam,delta,infl,R,muz,lambdaf,bigtheta,we,beta,psiL,sigmaL, ...
    lambdaw,alpha,b,muup,tauk,upsil,iota1,iota2,pibar,xip,iotaw1,iotaw2,xiw,epsil,sw);

%uzc, Fp, Kp, g, Fw, Kw, x
g=0;
zeta=1;
zetac=1;
ucz=(muz-b*beta)*zetac/(c*(muz-b));
taul=0;
psik=0;
psil=0;
epsil=1;
upsil=1;
tauc=0;

[Fp,Kp,Fw,Kw] = sssstate(lambdaz,yz,pitild,infl,lambdaf,beta,xip,mc,zetac, ...
    wstar,lambdaw,h,taul,muz,sigmaL,xiw,pitildw,piw,zeta);

x=infl*muz-1;

%do a check, to verify the steady state equations are satisfied.
[err] = checksteady_ceebgg(mc,rk,w,R,h,k,wstar,Rk,q,infl, ...
    piw,ucz,I,pstar,lambdaz,yz,Fp,Kp,g,c,Fw,Kw,wplus,pitild,pitildw, ...
    alpha,psik,psil,epsil,muz,upsil,lambdaw,lambdaf,muup,tauk,delta, ...
    b,beta,zetac,x,xip,xiw,tauc,taul,sigmaL,zeta,phi,Gamma,omegabar, ...
    Fomegabar,mu,gam,we,n,bigtheta,Gam_muG,psiL,sw);


if max(abs(err)) > .1e-9
    error('fatal (steadystate) failed to find a steady state for cee&bgg model')
end