
// Model with Taylor rule

// Variables
var piU, sU, rkU, iU, uU, omegabarU, RkXU, nU, qU,
      vlU, evU, mbU, RXU, uzcU, lambdazU, mU, RaXU, cU, wU,
      hU, kbarU, ReXU, xU, dmU, RmXU, m3U, btotU, pstarU, wstarU,
      FpXU, FwXU, wplusU, Util, Welf, lambdafU, pitargetU, xbU, muupU, chiiU, gU, muzstarU, gammaU, epsilU,
      sigmaU, zetacU, zetaiU, tauoU;

varexo e_xpU e_lambdafU, e_pitargetU, e_xbU, e_muupU, e_chiiU, e_gU, e_muzstarU, e_gammaU, e_epsilU, e_sigmaU, e_zetacU, e_zetaiU, e_tauoU;

// Steady-state values:
parameters std1_xpU piUU, sUU, rkUU, iUU, uUU, omegabarUU, RkXUU, nUU, qUU, vlUU, evUU, mbUU, RXUU, uzcUU, lambdazUU, mUU, RaXUU, cUU, wUU, hUU, kbarUU, ReXUU, xUU, dmUU, RmXUU, m3UU, btotUU, pstarUU, wstarUU, FpXUU, FwXUU, wplusUU, UtilU, WelfU, lambdafUU, pitargetUU, xbUU, muupUU, chiiUU, gUU, muzstarUU, gammaUU, epsilUU, sigmaUU, zetacUU, zetaiUU, tauoUU;

parameters rho1_lambdafU, rho1_pitargetU, rho1_xbU, rho1_muupU, rho1_chiiU, rho1_gU, rho1_muzstarU, rho1_gammaU, rho1_epsilU, rho1_sigmaU, rho1_zetacU, rho1_zetaiU, rho1_tauoU;

parameters std1_lambdafU, std1_pitargetU, std1_xbU, std1_muupU, std1_chiiU, std1_gU, std1_muzstarU, std1_gammaU, std1_epsilU, std1_sigmaU, std1_zetacU, std1_zetaiU, std1_tauoU;



//PARAMETERS

parameters lambdawUU, sigmaLXUU, thetaUU, vUU, betaUU, xiwUU, HdouprXUU, sigmaqUU, bUU,
      psiLXUU, iotaw1UU, iotamuUU, muUU, weUU, bigthetaUU, sigmaaUU, SdouprXUU, zetaUU, muzstarUU,
      upsilUU, alphaUU, psikUU, psilUU, deltaUU, xipUU, iota1UU, ksiUU, chorseUU, etagUU,
      taukUU, taulUU, taucUU, taudUU, tauUU, aptilUU, aytilUU, amtilUU, actilUU, rhotilUU,
      phiUU, pibarUU, nbeta;

load parameters_ea.mat;


nbeta= betaUU;
UtilU = 0;
WelfU = (1+nbeta)*UtilU;


model;

// Welfare
Util = zetacU*(log(cU*muzstarU-bUU*cU(-1))-zetaUU*psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU)-vUU/(1-sigmaqUU)*((1+taucUU)*piU*cU*muzstarU/(mbU(-1)*mU^(thetaUU*(1-chiiU))*(1-mU)^((1-chiiU)*(1-thetaUU))*dmU(-1)^chiiU))^(1-sigmaqUU)-(exp(sqrt(HdouprXUU/2)*(mU*(1+xU(-1))/mU(-1)-piUU*muzstarUU))+exp(-sqrt(HdouprXUU/2)*(mU*(1+xU(-1))/mU(-1)-piUU*muzstarUU))-2));
Welf = Util + nbeta*Welf(+1);


// Equations


-sU+((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU;
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )/(uU*kbarU(-1)))^(1-alphaUU) ) )-sU;
lambdazU*zetacU*qU*( -( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) )*( zetaiU*iU*muzstarU*upsilUU/iU(-1) )+1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ) )-(lambdazU/muupU)*zetacU+betaUU*zetacU(+1)*lambdazU(+1)*qU(+1)*( ( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU(+1)*iU(+1)*muzstarU(+1)*upsilUU/iU )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU(+1)*iU(+1)*muzstarU(+1)*upsilUU/iU )-muzstarUU*upsilUU)) )*(( zetaiU(+1)*iU(+1)*muzstarU(+1)*upsilUU/iU )^2) )/(muzstarU(+1)*upsilUU);
 rkU - tauoU*rkUU*exp(sigmaaUU*(uU-1));
(1-( normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU )-sigmaU)+omegabarU(+1)*(1-normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU ))) ))*( (1+RkXU(+1))/(1+ReXU) )+( (1-( normcdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU) ))/(1-( normcdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU) )-muUU*omegabarU(+1)*( normpdf((log(omegabarU(+1))+sigmaU^2/2)/sigmaU)/omegabarU(+1)/sigmaU )) )*(( (1+RkXU(+1))/(1+ReXU) )*( (1-muUU)*normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU )-sigmaU)+omegabarU(+1)*(1-normcdf(( (log(omegabarU(+1))+sigmaU^2/2)/sigmaU ))) )-1);
(qU(-1)*kbarU(-1)*(1+RkXU)*( (1-muUU)*normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))+omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ))) )/(nU(-1)*(1+ReXU(-1))))-(qU(-1)*kbarU(-1)/nU(-1))+1;
-nU+(gammaU/(piU*muzstarU))*(RkXU-ReXU(-1)-( ( normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))+omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ))) )-( (1-muUU)*normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))+omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ))) ) )*(1+RkXU))*kbarU(-1)*qU(-1)+weUU+gammaU*(1+ReXU(-1))*nU(-1)/(piU*muzstarU);
RkXU - ( ( (1-taukUU)*(uU*rkU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilUU*qU(-1)) + taukUU*deltaUU - 1);
-evU+((1-tauUU)*(mbU(-1)/(piU*muzstarU))*(1-mU)-tauUU*(psilUU*wU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )+psikUU*rkU*kbarU(-1)*uU/(muzstarU*upsilUU)))/ ((1-vlU)*((uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU)*(( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU)));
 RXU*( (1-alphaUU)*ksiUU*xbU*(( evU^(1-ksiUU) ))*((kbarU(-1)*uU/(muzstarU*upsilUU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )))^alphaUU) )/(1+tauUU*( (1-ksiUU)*xbU*( (evU^(-ksiUU)) ) ))-(1+psilUU*RXU)*wU;
 xbU*( ( (evU^(-ksiUU)) ) )*( (1-tauUU)*(mbU(-1)/(piU*muzstarU))*(1-mU)-tauUU*( psilUU*wU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )+psikUU*rkU*kbarU(-1)*uU/(muzstarU*upsilUU) ) )-(( (mbU(-1)/(piU*muzstarU))*(1-mU+chorseUU*dmU(-1)) )+( psilUU*wU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )+psikUU*rkU*kbarU(-1)*uU/(muzstarU*upsilUU) ));
 RaXU-(((1-tauUU)*( (1-ksiUU)*xbU*( (evU^(-ksiUU)) ) )-1)/(tauUU*( (1-ksiUU)*xbU*( (evU^(-ksiUU)) ) )+1))*RXU;
 uzcU-(muzstarU*zetacU/(cU*muzstarU-bUU*cU(-1)))+bUU*betaUU*zetacU(+1)/(cU(+1)*muzstarU(+1)-bUU*cU);
 -zetacU*lambdazU+(betaUU*zetacU(+1)*lambdazU(+1)/(muzstarU(+1)*piU(+1)))*(1+(1-taudUU)*ReXU);
 ( zetacU*vUU*( (1+taucUU)*cU*((1/mU)^((1-chiiU)*thetaUU)) * ((1/(1-mU))^((1-chiiU)*(1-thetaUU))) * ((1/dmU(-1))^chiiU)    )^(1-sigmaqUU) )*((thetaUU*(1-chiiU)/mU)-(1-chiiU)*(1-thetaUU)/(1-mU))*(((piU*muzstarU)/mbU(-1))^(2-sigmaqUU)) - zetacU*lambdazU*(1-taudUU)*RaXU -zetacU*( ( sqrt(HdouprXUU/2) )*exp(( sqrt(HdouprXUU/2) )*(( piU(-1)*muzstarU(-1)*mbU(-1)*mU/(mbU(-2)*mU(-1)) )-muzstarUU*piUU))-( sqrt(HdouprXUU/2) )*exp(-( sqrt(HdouprXUU/2) )*(( piU(-1)*muzstarU(-1)*mbU(-1)*mU/(mbU(-2)*mU(-1)) )-muzstarUU*piUU)) )*muzstarU*piU(-1)*piU*muzstarU(-1)/(mbU(-2)*mU(-1)) +betaUU*zetacU(+1)*( ( sqrt(HdouprXUU/2) )*exp(( sqrt(HdouprXUU/2) )*(( piU*muzstarU*mbU*mU(+1)/(mbU(-1)*mU) )-muzstarUU*piUU)) - ( sqrt(HdouprXUU/2) )*exp(-( sqrt(HdouprXUU/2) )*(( piU*muzstarU*mbU*mU(+1)/(mbU(-1)*mU) )-muzstarUU*piUU)) )*((muzstarU*piU)^2)*mbU*mU(+1)/((mbU(-1)*mU)^2);
 (  ( zetacU(+1)*vUU*( (1+taucUU)*cU(+1) * ((1/mU(+1))^((1-chiiU(+1))*thetaUU)) * ((1/(1-mU(+1)))^((1-chiiU(+1))*(1-thetaUU))) * (1/dmU)^chiiU(+1) )^(1-sigmaqUU) )*betaUU*(1-thetaUU)*(1-chiiU(+1))*(mbU^(sigmaqUU-2))*((piU(+1)*muzstarU(+1))^(1-sigmaqUU))/(1-mU(+1))  ) +(betaUU*zetacU(+1)*lambdazU(+1)/(piU(+1)*muzstarU(+1)))*(1+(1-taudUU)*RaXU(+1)) - zetacU*lambdazU;
uzcU-(( zetacU*vUU*( (1+taucUU)*cU*((1/mU)^((1-chiiU)*thetaUU)) * ((1/(1-mU))^((1-chiiU)*(1-thetaUU))) * ((1/dmU(-1))^chiiU)    )^(1-sigmaqUU) )/cU)*((piU*muzstarU/mbU(-1))^(1-sigmaqUU))-zetacU*(1+taucUU)*lambdazU;
( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * vlU * ( (uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) )-gU-cU-iU/muupU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU )*kbarU(-1)/(muzstarU*upsilUU)-( ( ( normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))+omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ))) )-( (1-muUU)*normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) )-sigmaU(-1))+omegabarU*(1-normcdf(( (log(omegabarU)+sigmaU(-1)^2/2)/sigmaU(-1) ))) ) )*(1+RkXU)*qU(-1)*kbarU(-1)/(muzstarU*piU) )-bigthetaUU*(1-gammaU)*(nU-weUU)/gammaU;
kbarU-(1-deltaUU)*(kbarU(-1)/(muzstarU*upsilUU))-(1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ))*iU;
mbU-mbU(-1)*(1+xU)/(piU*muzstarU);
// Monetary Policy Rule 
 log(ReXU)-log(ReXUU) - rhotilUU*(log(ReXU(-1)) -log(ReXUU)) -(1/ReXUU)*(1-rhotilUU)*piUU*( log(pitargetU) -log(piUU) ) - (1/ReXUU)*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)) - log(pitargetU)) - (1/(4*ReXUU))*(1-rhotilUU)*aytilUU*( cUU/( (cUU+iUU)/(1-etagUU) )*log(cU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iU)-iUU/( (cUU+iUU)/(1-etagUU) )*log(muupU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gU)  - (cUU/( (cUU+iUU)/(1-etagUU) )*log(cUU)+iUU/( (cUU+iUU)/(1-etagUU) )*log(iUU)+gUU/( (cUU+iUU)/(1-etagUU) )*log(gUU)) ) - (1/ReXUU)*(1-rhotilUU)*amtilUU*muzstarUU*piUU*( log(m3U)-log(m3U(-1))+log(muzstarU)+log(piU)  -log(muzstarUU*piUU) )  - (1/ReXUU)*(1-rhotilUU)*actilUU*muzstarUU*( log(btotU)-log(btotU(-1))+log(muzstarU)  -log(muzstarUU)) - (1/(400*ReXUU))*(e_xpU);
 zetacU(+1)*lambdazU(+1)/(muzstarU(+1)*piU(+1))*(ReXU-RmXU - chorseUU*RXU(+1)/(( (1-ksiUU)*xbU(+1)*evU(+1)^(-ksiUU) )*tauUU+1));
 (betaUU*chiiU(+1)*( zetacU(+1)*vUU*( (1+taucUU)*cU(+1) * ((1/mU(+1))^((1-chiiU(+1))*thetaUU)) * ((1/(1-mU(+1)))^((1-chiiU(+1))*(1-thetaUU))) * (1/dmU)^chiiU(+1) )^(1-sigmaqUU) )*((1/mbU)^(2-sigmaqUU))*((piU(+1)*muzstarU(+1))^(1-sigmaqUU))/dmU) + betaUU*zetacU(+1)*lambdazU(+1)*(1+(1-taudUU)*RmXU)/(piU(+1)*muzstarU(+1)) - zetacU*lambdazU;
 m3U - (mbU(-1)/(piU*muzstarU))*(1+dmU(-1)) - psilUU*wU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) ) - psikUU*rkU*uU*kbarU(-1)/(muzstarU*upsilUU) ;
 btotU -psilUU*wU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) ) -psikUU*rkU*uU*kbarU(-1)/(muzstarU*upsilUU) - (qU(-1)*kbarU(-1)-nU(-1))/(piU*muzstarU);
 pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) ) ^ lambdafU ) + xipUU*(((( (pitargetU^iota1UU) * (piU(-1)^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU)*pstarU(-1))^( lambdafU / (1-lambdafU) )) )^(1/( lambdafU / (1-lambdafU) ));
  wstarU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ lambdawUU ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wstarU(-1))^( lambdawUU/(1-lambdawUU) ) ) )^(1/( lambdawUU/(1-lambdawUU) )) );
  zetacU*lambdazU*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * vlU * ( (uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) ) + ( (( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1)) ^ (1/(1-lambdafU(+1))) ) * betaUU * xipUU * FpXU(+1) - FpXU;
 zetacU*lambdafU*lambdazU*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * vlU * ( (uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU ) )*sU + betaUU * xipUU *  ( (( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1)) ^ (lambdafU(+1)/(1-lambdafU(+1))) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (pitargetU(+1)^iota1UU) * (piU^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU(+1))^(1/(1-lambdafU(+1))) ) / (1-xipUU) ) )^(1-lambdafU(+1))) ) - ( FpXU* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^(1-iota1UU)) * pibarUU^(1-iota1UU-(1-iota1UU)) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) );
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1)))*hU*(1-taulUU)*lambdazU/lambdawUU) + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawUU))) * ( (( (pitargetU(+1)^iotaw1UU) * (piU^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )^(1/(1-lambdawUU))) / piU(+1) ) * ( (1/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) ^ (lambdawUU/(1-lambdawUU)) ) * (muzstarU(+1)^(iotamuUU/(1-lambdawUU)-1)) * FwXU(+1) - FwXU;
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1))*hU)^(1+sigmaLXUU))*zetaUU + betaUU * xiwUU * (( (( (pitargetU(+1)^iotaw1UU) * (piU^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU(+1)^iotamuUU) )  ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))) * ( ( ( (1 - xiwUU * ( ( (( (pitargetU(+1)^iotaw1UU) * (piU^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU(+1)*muzstarU(+1)*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU(+1)^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU(+1) * FwXU(+1)/psiLXUU ) - ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )   ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU   * FwXU/psiLXUU );
 wplusU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )^(lambdawUU*(1+sigmaLXUU)) ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^(1-iotaw1UU)) * (pibarUU^(1-iotaw1UU-(1-iotaw1UU))) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wplusU(-1))^( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) ) ) )^(1/( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) )) );




// Shock Equations
// Equations take the form: x = x_ *(1+e_x) + rho_x*(x(-1) - x_),
// where x_ is steady-state value, and e_x is iid shock with stderror std_x

lambdafU = lambdafUU* ( 1 + e_lambdafU) + rho1_lambdafU * ( lambdafU(-1) - lambdafUU );
pitargetU = pitargetUU* ( 1 + e_pitargetU) + rho1_pitargetU * ( pitargetU(-1) - pitargetUU );
xbU = xbUU* ( 1 + e_xbU) + rho1_xbU * ( xbU(-1) - xbUU );
muupU = muupUU* ( 1 + e_muupU) + rho1_muupU * ( muupU(-1) - muupUU );
chiiU = chiiUU* ( 1 + e_chiiU) + rho1_chiiU * ( chiiU(-1) - chiiUU );
gU = gUU* ( 1 + e_gU) + rho1_gU * ( gU(-1) - gUU );
muzstarU = muzstarUU* ( 1 + e_muzstarU) + rho1_muzstarU * ( muzstarU(-1) - muzstarUU );
gammaU = gammaUU* ( 1 + e_gammaU) + rho1_gammaU * ( gammaU(-1) - gammaUU );
epsilU = epsilUU* ( 1 + e_epsilU) + rho1_epsilU * ( epsilU(-1) - epsilUU );
sigmaU = sigmaUU* ( 1 + e_sigmaU) + rho1_sigmaU * ( sigmaU(-1) - sigmaUU );
zetacU = zetacUU* ( 1 + e_zetacU) + rho1_zetacU * ( zetacU(-1) - zetacUU );
zetaiU = zetaiUU* ( 1 + e_zetaiU) + rho1_zetaiU * ( zetaiU(-1) - zetaiUU );
tauoU = tauoUU* ( 1 + e_tauoU) + rho1_tauoU * ( tauoU(-1) - tauoUU );


end;

// Initial values, coinciding with steady-state values
initval;
piU = piUU;
sU = sUU;
rkU = rkUU;
iU = iUU;
uU = uUU;
omegabarU = omegabarUU;
RkXU = RkXUU;
nU = nUU;
qU = qUU;
vlU = vlUU;
evU = evUU;
mbU = mbUU;
RXU = RXUU;
uzcU = uzcUU;
lambdazU = lambdazUU;
mU = mUU;
RaXU = RaXUU;
cU = cUU;
wU = wUU;
hU = hUU;
kbarU = kbarUU;
ReXU = ReXUU;
xU = xUU;
dmU = dmUU;
RmXU = RmXUU;
m3U = m3UU;
btotU = btotUU;
pstarU = pstarUU;
wstarU = wstarUU;
FpXU = FpXUU;
FwXU = FwXUU;
wplusU = wplusUU;
Util = UtilU;
Welf = WelfU;
lambdafU = lambdafUU;
pitargetU = pitargetUU;
xbU = xbUU;
muupU = muupUU;
chiiU = chiiUU;
gU = gUU;
muzstarU = muzstarUU;
gammaU = gammaUU;
epsilU = epsilUU;
sigmaU = sigmaUU;
zetacU = zetacUU;
zetaiU = zetaiUU;
tauoU = tauoUU;
end;

shocks; 
var e_xpU; stderr std1_xpU;
var e_lambdafU; stderr std1_lambdafU;
var e_pitargetU; stderr std1_pitargetU;
var e_xbU; stderr std1_xbU;
var e_muupU; stderr std1_muupU;
var e_chiiU; stderr std1_chiiU;
var e_gU; stderr std1_gU;
var e_muzstarU; stderr std1_muzstarU;
var e_gammaU; stderr std1_gammaU;
var e_epsilU; stderr std1_epsilU;
var e_sigmaU; stderr std1_sigmaU;
var e_zetacU; stderr std1_zetacU;
var e_zetaiU; stderr std1_zetaiU;
var e_tauoU; stderr std1_tauoU;
end;

check;
steady;

//options_.loglinear=1;
stoch_simul(order=1,nocorr,nomoments,irf=0) ;
