
//DECLARATIONS.

// Variables of the Economy with frictions
// Endogenous variables
var 
// Exogenous variables
var 


// Stochastic Exogenous Shocks

varexo 
//PARAMETERS

parameters 
y  = (c+i)/(1-etag);

model;           

// Model Equations in the Economy with Frictions

// Welfare

lp1=hp1*(wstarp1 ^ (lambdaw/(lambdaw-1)) );
l0=h0*(wstar0 ^ (lambdaw/(lambdaw-1)) );
lm1=hm1*(wstarm1 ^ (lambdaw/(lambdaw-1)) );
Yz0 = (pstar0^(lambdaf0/(lambdaf0-1))) * ( epsil0 * (( u0*kbar0/(muzstar0*upsil))^alpha ) * ( l0^(1-alpha) ) - phi);

// marginal cost
-s0+((1-alpha)^(alpha-1)*alpha^(-alpha))*((tauo0*rk*exp(sigmaa*(u0-1))*(1+psik0*R0))^alpha)*((w0*(1+psil0*R0))^(1-alpha))/epsil0;
   
// second efficiency condition for intermediate good firm:
tauo0*rk*exp(sigmaa*(u0-1))*(1+psik0*R0)/( alpha*epsil0*( (upsil*muzstar0*l0/(u0*kbar0))^(1-alpha) ) )-s0;

I0Im1=zetai0*i0*muzstar0*upsil/im1;
A=sqrt(Sdoupr/2);
S0=exp(A*(I0Im1-muzstar*upsil))+exp(-A*(I0Im1-muzstar*upsil))-2;
dS0=A*exp(A*(I0Im1-muzstar*upsil))-A*exp(-A*(I0Im1-muzstar*upsil));
F10=-dS0*I0Im1+1-S0;
Ip1I0=zetaip1*ip1*muzstarp1*upsil/i0;
dSp1=A*exp(A*(Ip1I0-muzstar*upsil))-A*exp(-A*(Ip1I0-muzstar*upsil));
F2p1=dSp1*(Ip1I0^2);

// efficiency condition for capital producers

lambdaz0*zetac0*q0*F10-(lambdaz0/muup0)*zetac0+beta*zetacp1*lambdazp1*qp1*F2p1/(muzstarp1*upsil);



%
a0=rk*(exp(sigmaa*(u0-1))-1)/sigmaa;
ap1=rk*(exp(sigmaa*(up1-1))-1)/sigmaa;
%definition of rate of return on capital

Rk0 - ( ( (1-taukm1)*(u0*rk0-tauo0*a0)+(1-delta)*q0)*pi0/(upsil*qm1) + taukm1*delta - 1);


//  marginal utility of consumption (net of MIUF considerations)

(zetac0*(1+tauc0))*lambdaz0-(muzstar0*zetac0/(c0*muzstar0-b*cm1))+b*beta*zetacp1/(cp1*muzstarp1-b*c0);

// first order condition for base

(beta*zetacp1*lambdazp1/(pip1*muzstarp1))*(1+Rp1) - zetac0*lambdaz0;

// resource constraint

Yz0-g0-c0-i0/muup0-tauo0*a0*kbar0/(muzstar0*upsil);    

kbarp1-(1-delta)*(kbar0/(muzstar0*upsil))-(1-S0)*i0;

// monetary policy rule

Re0=Rm1;
Rep1=R0;
Re=R;

// Monetary Policy Rule
// equation 23

log(Rep1)-log(Re) - rhotil*(log(Re0) -log(Re)) -(1/Re)*(1-rhotil)*pi*( log(pitarget0) -log(pi) ) - (1/Re)*(1-rhotil)*aptil*pi*(log(pip1) - log(pitarget0)) - (1/(4*Re))*(1-rhotil)*aytil*( c/y*log(c0)+i/y*log(i0)-i/y*log(muup0)+g/y*log(g0)  - (c/y*log(c)+i/y*log(i)+g/y*log(g)) ) - (1/Re)*(1-rhotil)*amtil*muzstar*pi*( log(m30)-log(m3m1)+log(muzstar0)+log(pi0)  -log(muzstar*pi) )  - (1/(400*Re))*xp0;

// intertemporal Euler equation for capital
-zetac0*lambdaz0+lambdazp1*zetacp1*(beta/(pip1*muzstarp1))*(1+Rkp1);

pit0  = (pitarget0^iota1) * (pim1^iota2) * pibar^(1-iota1-iota2) ;
pitp1 = (pitargetp1^iota1) * (pi0^iota2) * pibar^(1-iota1-iota2) ;

a0   = ( (1 - xip*(pit0/pi0)^(1/(1-lambdaf0)) ) / (1-xip) );
ap1  = ( (1 - xip*(pitp1/pip1)^(1/(1-lambdafp1)) ) / (1-xip) );
aa0  = a0 ^ lambdaf0;
pow  = lambdaf0 / (1-lambdaf0);

// the following equations, (32) - (38), correspond to (31)-(37) in 'Dale'
// manuscript.
// dynamic equation for price distortions
pstar0 - ((1-xip)*aa0 + xip*(((pit0/pi0)*pstarm1)^pow) )^(1/pow);

ptwage0 = (pitarget0^iotaw1) * (pim1^iotaw2) * (pibar^(1-iotaw1-iotaw2));
ptwagep1 = (pitargetp1^iotaw1) * (pi0^iotaw2) * (pibar^(1-iotaw1-iotaw2));

piw0   = pi0*muzstar0*w0/wm1;
piwp1  = pip1*muzstarp1*wp1/w0;
cc0    = (ptwage0/piw0) * (muzstar^(1-iotamu)) * (muzstar0^iotamu);
ccp1   = (ptwagep1/piwp1) * (muzstar^(1-iotamu)) * (muzstarp1^iotamu);
b0     = (1 - xiw * ( cc0 ^ (1/(1-lambdaw)) ) ) / (1-xiw) ;
bp1    = (1 - xiw * ( ccp1 ^ (1/(1-lambdaw)) ) ) / (1-xiw) ;
bb0    = b0 ^ lambdaw;
poww   = lambdaw/(1-lambdaw);

// dynamic equation for wage distortions
wstar0 - ( ((1-xiw)*bb0 + xiw*( (cc0*wstarm1)^poww ) )^(1/poww) );

Kp0    =  Fp0* (a0^(1-lambdaf0));
Kpp1   =  Fpp1* (ap1^(1-lambdafp1));

Kw0    =  ( b0   ^ (1-lambdaw*(1+sigmaL)) ) * w0   * Fw0/psiL;
Kwp1   =  ( bp1 ^ (1-lambdaw*(1+sigmaL)) ) * wp1 * Fwp1/psiL;

zetac0*lambdaz0*Yz0 + ( (pitp1/pip1) ^ (1/(1-lambdafp1)) ) * beta * xip * Fpp1 - Fp0;

zetac0*lambdaf0*lambdaz0*Yz0*s0 + beta * xip *  ( (pitp1/pip1) ^ (lambdafp1/(1-lambdafp1)) ) * Kpp1 - Kp0;

zetac0*((wstar0^(lambdaw/(lambdaw-1)))*h0*(1-taul0)*lambdaz0/lambdaw) ...
    + beta * xiw * (muzstar^((1-iotamu)/(1-lambdaw))) ...
    * ( (ptwagep1^(1/(1-lambdaw))) / pip1 ) * ( (1/piwp1) ^ (lambdaw/(1-lambdaw)) ) ... 
    * (muzstarp1^(iotamu/(1-lambdaw)-1)) * Fwp1 - Fw0;

zetac0*((wstar0^(lambdaw/(lambdaw-1))*h0)^(1+sigmaL))*zeta0 + beta * xiw * ...
        (( (ptwagep1/piwp1) * (muzstar^(1-iotamu)) * (muzstarp1^iotamu) )  ...
        ^ (lambdaw*(1+sigmaL)/(1-lambdaw))) * Kwp1 - Kw0;

powww  = lambdaw*(1+sigmaL)/(1-lambdaw);
b0     = (1 - xiw * ( cc0 ^ (1/(1-lambdaw)) ) ) / (1-xiw) ;
bb0    = b0^(lambdaw*(1+sigmaL));
ff(38)= wplus0 - ( ((1-xiw)*bb0 + xiw*( (cc0*wplusm1)^powww ) )^(1/powww) );


//Welfare


// Exogenous Disturbances
// Auxiliary variables used for determining mean-preserving spreads


end;


//INITIAL VALUES.
initval;

lA = log(ABar);
lB = log(BBar);
lG = log(GBar);
lI = log(IBar);
lL = log(LBar);

lTaxp = lTaxpBar;
lTaxw = lTaxwBar;

lY = log(YBar);

linfl = log(inflBar);
lwinfl = log(inflBar);
vbleq = 1;
logu=0;
au = 0;

zepsA =  0; 
zepsB =  0;
zepsG =  0;
zepsI =  0;
zepsL =  0;
zepsTp = 0;
zepsTw = 0;
zepsP = 0;
zepsQ = 0;
zepsW = 0;

etaP=0;
letaP=0;
etaQ=0;
letaQ=0;
etaW=0;
letaW=0;

lwindexa = gamw*log(inflBar);
lpindexa = gamp*log(inflBar);

lx0 = log(((1 - xip*(inflBar^((gamp-1)*(1-epp))))/(1-xip))^(1/(1-epp)));
lwx0 = log(((1 - xiw*(inflBar^((gamp-1)*(1-epw))))/(1-xiw))^(1/(1-epw)));
lDisp = log(((1-xip)*(exp(lx0)^(-epp)))/(1-xip*inflBar^((1-gamp)*epp)));
lDispw = log(((1-xiw)*(exp(lwx0)^(-epw*(1+chi))))/(1-xiw*inflBar^((1-gamw)*epp*(1+chi))));

lMC = lx0 + log(1-bet*xip*inflBar^(1+epp)) + log((epp-1)/epp) - (lTaxp + log(1-bet*xip*inflBar^(epp+gamp)));
lrk = log((bet^(-1)) - (1.0 - tau));

lK = log(alph) + lY + lMC - lrk;
lN = (lY - lA - alph*(lK) + lDisp)/(1-alph);

lG = log(GBar);
lC = lY + log(1 - (tau*alph/exp(lrk))*exp(lMC) - exp(lG-lY) - au*exp(lK));
lCtil = log((1-theta)*exp(lC));
lUc = log((exp(lCtil)^(-sig))*(1 - (1-exthabit)*bet*theta));
lwr = log((((1-alph)*exp(lY-lN)*exp(lMC))/(intBar)^(nirc)));
z2 =  exp(lMC)*exp(lY)*(exp(lUc))/(1-bet*xip*(inflBar^(1+epp)));
z1 = z2 *(epp/(epp-1))*exp(lTaxp)/exp(lx0);

zw1 = exp(lN)*exp(lwr)*(exp(lUc))/(1-bet*xiw*exp(lwindexa)*(inflBar^(epw-1))) ;
zw2 = chi0*exp(lL)*((exp(lN))^(1+chi))/(1- bet*xiw*(inflBar^(epw*(1+chi))));
linvest = lK + log(tau);
lRint = -log(bet);
lInt = log(inflBar) - log(bet); 
Util = (exp(lCtil)^(1-sig))/(1-sig) - exp(lDispw)*chi0*(((exp(lN))^(1+chi))/(1+chi));   
Welf = Util/(1-bet);


lCtilpm = lCtil;
lUcpm = lUc;

//periodloss=0;
//adhocloss=0;

// Frictionless Economy

lYf = log(YBar);
vbleqf = 1;
loguf=0;
auf = 0;
lrkf = log((bet^(-1)) - (1.0 - tau));

lKf = log(alph*(exp(lYf)*exp(lMC))/exp(lrkf));
lNf = (lYf - lA - alph*(lKf))/(1-alph);

lCf = lYf + log(1 - (tau*alph/exp(lrkf))*exp(lMC) - exp(lG-lYf) - auf*exp(lKf));
lCtilf = log((1-theta)*exp(lCf));
lUcf = log((exp(lCtilf)^(-sig))*(1 - (1-exthabit)*bet*theta));
lwrf = log((((1-alph)*exp(lYf-lNf)*exp(lMC))/(intBar)^(nirc)));
linvestf = lKf + log(tau);
lRint = -log(bet);
Utilf = (exp(lCtilf)^(1-sig))/(1-sig) - chi0*(((exp(lNf))^(1+chi))/(1+chi));   
Welff = Utilf/(1-bet);


lIntf=lInt;
lRintf=lRint;
lYgap = lY - lYf;
lYgapf = 0;

linflf = log(inflBar);
lwinflf = log(inflBar);

epsA=0;
epsB=0;
epsG=0;
epsI=0;
epsL=0;
epsTp=0;
epsTw=0;

zlA=0; 
zlB=0; 
zlG=0; 
zlI=0; 
zlL=0; 
zlTp=0; 
zlTw=0; 

zlP=0; 
zlQ=0; 
zlW=0; 

zmpsA=0; 
zmpsB=0; 
zmpsG=0; 
zmpsI=0; 
zmpsL=0; 
zmpsTp=0; 
zmpsTw=0;
zmpsP=0;
zmpsQ=0;
zmpsW=0;

end;

