
% cd('C:\RESEARCH\FALL 2005\DAVID\CAPITAL\RAMSEY'); run_ramsey_bank
% 
%  NOTE: Andy has set up the code such that the following requirements must be met
%        1) the string 
%                       // Endogenous variables
%           must occur before the var statement that declare the endogenous variables
%        2) the string
%                       // Exogenous variables 
%           must occur beforethe var statement that declares the exogenous variables
%        3) The monetary policy must be identified by the string
%                      // monetary policy rule
%        4) There must be a period utility function defined and it must be named Util
%        5) There must be a recursive definition Welf = Util + nbeta*Welf(+1);
%        6) There must be a parameter nbeta defined. This is the discount factor, you cannot give it 
%           a different name.

%1. change add path
%2. type (this step is only interesting if you want impulse responses in
%    system with exogenous policy rule).
%    dynare newDNK; %this produces impulse responses under the Taylor
%    rule in the newDNK.mod file (dynare will translate this into a MATLAB
%    *.m file and then execute that file).
%3. run
%   getramsey.m; % given the setting for infilename and outfilename below, this creates two files, 
%   one is newDNK_OUT.mod, the dynare code for the Ramsey condition.
%4. run
%   setparams; % this computes steady state value of lagrangian
%   multipliers. This is not necessary.
%5. open newDNK_OUT.mod, then put steady state multiplier values in the file
%    right after parameters. Also, move the variable names into first var
%    statement (remove commas).
% lmult1_SS=0;
% lmult2_SS=0;
% lmult3_SS=0;
% lmult4_SS=0;
% lmult5_SS=0;
% lmult6_SS=0;
% lmult7_SS=0;
% lmult8_SS=0;
% lmult9_SS=0;
% lmult10_SS=0;
% lmult11_SS=0;
% lmult12_SS=0;
% lmult13_SS=0;
% lmult14_SS=0;
% lmult15_SS=0;
% lmult16_SS=0;
% lmult17_SS=0; 
%
%Then, set the initial values of the multipliers after the initval statement:
% lmult1=lmult1_SS;
% lmult2=lmult2_SS;
% lmult3=lmult3_SS;
% lmult4=lmult4_SS;
% lmult5=lmult5_SS;
% lmult6=lmult6_SS;
% lmult7=lmult7_SS;
% lmult8=lmult8_SS;
% lmult9=lmult9_SS;
% lmult10=lmult10_SS;
% lmult11=lmult11_SS;
% lmult12=lmult12_SS;
% lmult13=lmult13_SS;
% lmult14=lmult14_SS;
% lmult15=lmult15_SS;
% lmult16=lmult16_SS;
% lmult17=lmult17_SS; 

%6. type
%   dynare newDNK_OUT;% this produces impulse responses under Ramsey
%   policy. This works by default with second order approximations. To convert to
%   first order, parameter needs to be inserted in the argument list of
%   stoch_simul, called by newDNK_OUT.mod.

%addpath
%rmpath('C:\dynare3-64\matlab');
addpath('C:\dynarev3\matlab');
addpath('c:\projects\ecb\august2005\euroarea_code');
%addpath('C:\dynare_v3.05\matlab');
addpath('C:\projects\ecb\August2005\Ippei\Get_Ramsey');

%when you run Dynare, you must have only one var statement
%when you give a Dynare program to Andy Levin's code, must have the
%exogenous shocks (not their innovations) specified in a separate var
%statement. The var statement corresponding to exogenous shocks 
%should be preceded by // Exogenous variables
%when the output from Andy's code arrives, must consolidate the
%two var statements

%dynare newDNK


infilename  = 'newDNK';
outfilename = 'newDNK_OUT';
%written by Andy Levin and coauthors:
get_ramsey