// Endogenous variables 
var piU, sU, rkU, iU, uU, RkXU, qU, RXU, uzcU, cU, wU, hU, kbarU, pstarU, wstarU, FpXU, FwXU, wplusU, Util, Welf; 
 
// Exogenous variables 
var epsilU, U1, U2, U3, U4, U; 
 
varexo xU SIGNAL PATRIOT; 
 
// Usually, parameters have UU extension, and variables, U. Shocks that are not used have U extension and are parameters 
//PARAMETERS 
parameters lambdawUU, sigmaLXUU, betaUU, xiwUU, bUU, psiLXUU, iotaw1UU, iotaw2UU, iotamuUU, 
      sigmaaUU, SdouprXUU, zetaUU, muzstarUU, upsilUU, alphaUU, psikUU, psilUU, deltaUU, xipUU, 
      iota1UU, iota2UU, taukUU, taulUU, taucUU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,     
      xUU,muupUU,lambdafUU,zetacUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,iUU,piUU,gUU,yUU,rkUU,nbeta, 
      lambdafU, pitargetU, muupU, gU, muzstarU, zetacU, zetaiU, tauoU, rhoU, zetaU; 
 
  
// %---Household 
lambdawUU     =   1.05; 
sigmaLXUU      =   1; 
zetaUU        =   1.000;  
betaUU        =   1.00401002003506^(-0.25);  
nbeta         =   1.00401002003506^(-0.25);  
xiwUU         =   0.82; 
bUU           =   .56; 
psiLXUU        =   2.05219106563472;   
zetacUU       =   1; 
iotaw1UU      =   0.72; 
iotamuUU      =   0.9166; 
tauoUU        =   1; 
// %----- Capital Producer 
sigmaaUU      =   25; 
SdouprXUU      =   11; 
etaiUU        =   2;  
muupUU        =   1;  
zetaiUU       =   1; 
// %---- Goods Producers 
muzstarUU     =   1.015^(.25); 
upsilUU       =   1.002^(.25); 
lambdafUU     =   1.2; 
alphaUU       =   0.36; 
psikUU        =   0.92; 
psilUU        =   0.92; 
deltaUU       =   0.02; 
epsilUU       =   1; 
xipUU         =   0.82; 
iota1UU       =   0.69; 
// %---- Taxes and government consumption 
etagUU        =   0.23; 
taukUU        =   .28; 
taulUU        =   .45; 
taucUU        =   0.2; 
// %---- Monetary Policy 
xUU           =   0.00832; 
// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy 
pibarUU       =   1; 
aptilUU       =  1.6104 ; 
aytilUU       =  0.1862 ; 
rhotilUU      =  0.8754 ; 
rhoU          = 0.9; 
 
// following is a call to the steady state 
[qUU,piUU,RkXUU,rkUU,RXUU,pstarUU,wstarUU,wplusUU,kbarUU,hUU,lambdazUU,cUU,yUU,gUU,iUU,FpXUU,KpXUU,FwXUU,KwXUU, ... 
    uzcUU,sUU,phiUU,wUU,uUU] = nobanknoentrss(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
    1-iota1UU,xipUU,lambdafUU,iotaw1UU,1-iotaw1UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
    lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 
 
// shock variables not used are set to constants 
pitargetUU=(1+xUU)/muzstarUU; 
lambdafU=lambdafUU; 
pitargetU=pitargetUU; 
muupU=muupUU; 
gU=gUU; 
muzstarU=muzstarUU; 
zetacU=zetacUU; 
zetaiU=zetaiUU; 
tauoU=tauoUU; 
zetaU=zetaUU; 
iota2UU=1-iota1UU; 
iotaw2UU=1-iotaw1UU; 
 
var lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15,  lmult16,  lmult17; 
  
parameters lmult1_SS,  lmult2_SS,  lmult3_SS,  lmult4_SS,  lmult5_SS,   
           lmult6_SS,  lmult7_SS,  lmult8_SS,  lmult9_SS,  lmult10_SS,   
           lmult11_SS,  lmult12_SS,  lmult13_SS,  lmult14_SS,  lmult15_SS,   
           lmult16_SS,  lmult17_SS; 
  
model; 
// Welfare 
 
Util = zetacU*(log(cU*muzstarU-bUU*cU(-1))-zetaU*psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU)); 
Welf = Util + nbeta*Welf(+1); 
 
// Monetary Policy Rule 
zetacU*muzstarU/(cU*muzstarU-bUU*cU(-1))-nbeta*zetacU*bUU/(cU(+1)*muzstarU-bUU*cU)+lmult6*(zetacU*muzstarU^2/(cU*muzstarU-bUU*cU(-1))^2+bUU^2*betaUU*zetacU/(cU(+1)*muzstarU-bUU*cU)^2)-1/nbeta*lmult6(-1)*bUU*betaUU*zetacU/(cU*muzstarU-bUU*cU(-1))^2*muzstarU-nbeta*lmult6(+1)*muzstarU*zetacU/(cU(+1)*muzstarU-bUU*cU)^2*bUU-lmult8; 
-lmult13+1/nbeta*lmult13(-1)*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))*betaUU*xipUU-lmult14*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)+1/nbeta*lmult14(-1)*betaUU*xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(lambdafU/(1-lambdafU))*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU); 
-lmult15+1/nbeta*lmult15(-1)*betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/piU*(1/piU/muzstarU/wU*wU(-1))^(lambdawUU/(1-lambdawUU))*muzstarU^(iotamuUU/(1-lambdawUU)-1)-lmult16*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU/psiLXUU+1/nbeta*lmult16(-1)*betaUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU/psiLXUU; 
-zetacU*zetaU*psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*hU^(1+sigmaLXUU)/hU-lmult2*rkU*(1+psikUU*RXU)/alphaUU/epsilU/((upsilUU*muzstarU*hU*wstarU^(lambdawUU/(lambdawUU-1))/uU/kbarU(-1))^(1-alphaUU))*(1-alphaUU)/hU+lmult8*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult13*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult14*lambdafU*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU*sU+lmult15*wstarU^(lambdawUU/(lambdawUU-1))*(1-taulUU)*uzcU/(1+taucUU)/lambdawUU+lmult16*zetacU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)/hU*zetaUU; 
lmult3*(uzcU/(1+taucUU)*qU*((-1/2*SdouprXUU*zetaiU*muzstarU*upsilUU/iU(-1)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-1/2*SdouprXUU*zetaiU*muzstarU*upsilUU/iU(-1)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU*iU*muzstarU*upsilUU/iU(-1)+(-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU*muzstarU*upsilUU/iU(-1)-1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*muzstarU*upsilUU/iU(-1)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*muzstarU*upsilUU/iU(-1)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))+betaUU*uzcU(+1)/(1+taucUU)*qU(+1)*(-1/2*SdouprXUU*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))-1/2*SdouprXUU*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))*zetaiU^2*iU(+1)^2*muzstarU*upsilUU/iU^2-2*betaUU*uzcU(+1)/(1+taucUU)*qU(+1)*(1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))*zetaiU^2*iU(+1)^2*muzstarU*upsilUU/iU^3)+1/nbeta*lmult3(-1)*(betaUU*uzcU/(1+taucUU)*qU*(1/2*SdouprXUU*zetaiU*muzstarU*upsilUU/iU(-1)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+1/2*SdouprXUU*zetaiU*muzstarU*upsilUU/iU(-1)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU^2*iU^2*muzstarU*upsilUU/iU(-1)^2+2*betaUU*uzcU/(1+taucUU)*qU*(1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU^2*iU*muzstarU*upsilUU/iU(-1)^2)+nbeta*lmult3(+1)*uzcU(+1)/(1+taucUU)*qU(+1)*((1/2*SdouprXUU*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))+1/2*SdouprXUU*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))*zetaiU*iU(+1)*muzstarU*upsilUU/iU-(-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2+1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))-lmult8/muupU+lmult9*((1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*muzstarU*upsilUU/iU(-1)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*muzstarU*upsilUU/iU(-1)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*iU-3+exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))+nbeta*lmult9(+1)*(-1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*zetaiU*iU(+1)*muzstarU*upsilUU/iU^2*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU(+1)*muzstarU*upsilUU/iU-muzstarUU*upsilUU)))*iU(+1); 
nbeta*lmult2(+1)*rkU(+1)*(1+psikUU*RXU(+1))/alphaUU/epsilU(+1)/((upsilUU*muzstarU*hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/uU(+1)/kbarU)^(1-alphaUU))*(1-alphaUU)/kbarU+nbeta*lmult8(+1)*(pstarU(+1)^(lambdafU/(lambdafU-1))*epsilU(+1)*(uU(+1)*kbarU/upsilUU/muzstarU)^alphaUU*alphaUU/kbarU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-tauoU*rkUU*(exp(sigmaaUU*(uU(+1)-1))-1)/sigmaaUU/muzstarU/upsilUU)+lmult9+nbeta*lmult9(+1)*(-1+deltaUU)/muzstarU/upsilUU+nbeta*lmult13(+1)*uzcU(+1)/(1+taucUU)*pstarU(+1)^(lambdafU/(lambdafU-1))*epsilU(+1)*(uU(+1)*kbarU/upsilUU/muzstarU)^alphaUU*alphaUU/kbarU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)+nbeta*lmult14(+1)*lambdafU*uzcU(+1)/(1+taucUU)*pstarU(+1)^(lambdafU/(lambdafU-1))*epsilU(+1)*(uU(+1)*kbarU/upsilUU/muzstarU)^alphaUU*alphaUU/kbarU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sU(+1); 
lmult5*(-(1-taukUU)*(uU*rkU-tauoU*rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU)-(1-deltaUU)*qU)/upsilUU/qU(-1)-1/nbeta*lmult7(-1)*betaUU*uzcU/(1+taucUU)/piU^2/muzstarU*(1+RXU)-1/nbeta*lmult10(-1)*betaUU*uzcU/(1+taucUU)/piU^2/muzstarU*(1+RkXU)-lmult11*((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU*pstarU(-1))^(lambdafU/(1-lambdafU)))^(1/lambdafU*(1-lambdafU))/lambdafU*(1-lambdafU)*((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^lambdafU*lambdafU*xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))/(1-lambdafU)/piU/(1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU*pstarU(-1))^(lambdafU/(1-lambdafU))*lambdafU/(1-lambdafU)/piU)/((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU*pstarU(-1))^(lambdafU/(1-lambdafU)))-nbeta*lmult11(+1)*((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU)))^(1/lambdafU*(1-lambdafU))/lambdafU*(1-lambdafU)*((-1+xipUU)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^lambdafU*lambdafU*xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU))/(1-lambdafU)*iota2UU/piU/(1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))+xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU))*lambdafU/(1-lambdafU)*iota2UU/piU)/((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU)))-lmult12*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^(1/lambdawUU*(1-lambdawUU))/lambdawUU*(1-lambdawUU)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))^(1/lambdawUU*(1-lambdawUU))/lambdawUU*(1-lambdawUU)*((-1+xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))+lmult13*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU))/(1-lambdafU)*iota2UU/piU*betaUU*xipUU*FpXU(+1)-1/nbeta*lmult13(-1)*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))/(1-lambdafU)/piU*betaUU*xipUU*FpXU+lmult14*(betaUU*xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(lambdafU/(1-lambdafU))*lambdafU/(1-lambdafU)*iota2UU/piU*FpXU(+1)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)-betaUU*xipUU^2*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(lambdafU/(1-lambdafU))*FpXU(+1)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU))*iota2UU/piU/(1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))-FpXU*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)*xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))/piU/(1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))))+1/nbeta*lmult14(-1)*(-betaUU*xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(lambdafU/(1-lambdafU))*lambdafU/(1-lambdafU)/piU*FpXU*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)+betaUU*xipUU^2*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(lambdafU/(1-lambdafU))*FpXU*((1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))/piU/(1-xipUU*(pitargetU^iota1UU*piU(-1)^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU)^(1/(1-lambdafU))))+nbeta*lmult14(+1)*FpXU(+1)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^(1-lambdafU)*xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU))*iota2UU/piU/(1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))+lmult15*betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/piU(+1)*(1/piU(+1)/muzstarU/wU(+1)*wU)^(lambdawUU/(1-lambdawUU))*muzstarU^(iotamuUU/(1-lambdawUU)-1)*FwXU(+1)+1/nbeta*lmult15(-1)*(-betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/piU^2*(1/piU/muzstarU/wU*wU(-1))^(lambdawUU/(1-lambdawUU))*muzstarU^(iotamuUU/(1-lambdawUU)-1)*FwXU-betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/piU^2*(1/piU/muzstarU/wU*wU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*muzstarU^(iotamuUU/(1-lambdawUU)-1)*FwXU)+lmult16*(betaUU*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU(+1)*FwXU(+1)/psiLXUU-betaUU*xiwUU^2*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU(+1)*FwXU(+1)/psiLXUU-((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU*FwXU/psiLXUU)+1/nbeta*lmult16(-1)*(-betaUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU*FwXU/psiLXUU+betaUU*xiwUU^2*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU*FwXU/psiLXUU)+nbeta*lmult16(+1)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU(+1)*FwXU(+1)/psiLXUU-lmult17*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^(1/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU))/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult17(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^(1/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU))/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU)*((-1+xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
lmult8*pstarU^(lambdafU/(lambdafU-1))*lambdafU/(lambdafU-1)/pstarU*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult11-nbeta*lmult11(+1)*((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU)))^(1/lambdafU*(1-lambdafU))*xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU))/pstarU/((1-xipUU)*((1-xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1))^(1/(1-lambdafU)))/(1-xipUU))^lambdafU+xipUU*(pitargetU^iota1UU*piU^iota2UU*pibarUU^(1-iota1UU-iota2UU)/piU(+1)*pstarU)^(lambdafU/(1-lambdafU)))+lmult13*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*lambdafU/(lambdafU-1)/pstarU*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult14*lambdafU^2*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))/(lambdafU-1)/pstarU*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU; 
lmult3*uzcU/(1+taucUU)*((-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU*iU*muzstarU*upsilUU/iU(-1)+3-exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))+1/nbeta*lmult3(-1)*betaUU*uzcU/(1+taucUU)*(1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU^2*iU^2*muzstarU*upsilUU/iU(-1)^2+lmult5*(-1+deltaUU)*piU/upsilUU/qU(-1)+nbeta*lmult5(+1)*((1-taukUU)*(uU(+1)*rkU(+1)-tauoU*rkUU*(exp(sigmaaUU*(uU(+1)-1))-1)/sigmaaUU)+(1-deltaUU)*qU(+1))*piU(+1)/upsilUU/qU^2; 
lmult1*(1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU)*(rkU*(1+psikUU*RXU))^alphaUU*alphaUU/rkU*(wU*(1+psilUU*RXU))^(1-alphaUU)/epsilU+lmult2*(1+psikUU*RXU)/alphaUU/epsilU/((upsilUU*muzstarU*hU*wstarU^(lambdawUU/(lambdawUU-1))/uU/kbarU(-1))^(1-alphaUU))+lmult4+lmult5*(-1+taukUU)*uU*piU/upsilUU/qU(-1); 
lmult5+1/nbeta*lmult10(-1)*betaUU*uzcU/(1+taucUU)/piU/muzstarU; 
lmult1*((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU)*(rkU*(1+psikUU*RXU))^alphaUU*alphaUU*psikUU/(1+psikUU*RXU)*(wU*(1+psilUU*RXU))^(1-alphaUU)/epsilU+(1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU)*(rkU*(1+psikUU*RXU))^alphaUU*(wU*(1+psilUU*RXU))^(1-alphaUU)*(1-alphaUU)*psilUU/(1+psilUU*RXU)/epsilU)+lmult2*rkU*psikUU/alphaUU/epsilU/((upsilUU*muzstarU*hU*wstarU^(lambdawUU/(lambdawUU-1))/uU/kbarU(-1))^(1-alphaUU))+1/nbeta*lmult7(-1)*betaUU*uzcU/(1+taucUU)/piU/muzstarU; 
-lmult1-lmult2+lmult14*lambdafU*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmult2*rkU*(1+psikUU*RXU)/alphaUU/epsilU/((upsilUU*muzstarU*hU*wstarU^(lambdawUU/(lambdawUU-1))/uU/kbarU(-1))^(1-alphaUU))*(1-alphaUU)/uU-lmult4*tauoU*rkUU*sigmaaUU*exp(sigmaaUU*(uU-1))+lmult5*(-1+taukUU)*(rkU-tauoU*rkUU*exp(sigmaaUU*(uU-1)))*piU/upsilUU/qU(-1)+lmult8*(pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*alphaUU/uU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-tauoU*rkUU*exp(sigmaaUU*(uU-1))*kbarU(-1)/upsilUU/muzstarU)+lmult13*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*alphaUU/uU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)+lmult14*lambdafU*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*alphaUU/uU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sU; 
lmult3*(1/(1+taucUU)*qU*((-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))+1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU*iU*muzstarU*upsilUU/iU(-1)+3-exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))-1/(1+taucUU)/muupU)+1/nbeta*lmult3(-1)*betaUU/(1+taucUU)*qU*(1/2*2^(1/2)*SdouprXUU^(1/2)*exp(1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU))-1/2*2^(1/2)*SdouprXUU^(1/2)*exp(-1/2*2^(1/2)*SdouprXUU^(1/2)*(zetaiU*iU*muzstarU*upsilUU/iU(-1)-muzstarUU*upsilUU)))*zetaiU^2*iU^2*muzstarU*upsilUU/iU(-1)^2+lmult6-lmult7/(1+taucUU)+1/nbeta*lmult7(-1)*betaUU/(1+taucUU)/piU/muzstarU*(1+RXU)-lmult10/(1+taucUU)+1/nbeta*lmult10(-1)*betaUU/(1+taucUU)/piU/muzstarU*(1+RkXU)+lmult13/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult14*lambdafU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*(epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU+lmult15*hU*wstarU^(lambdawUU/(lambdawUU-1))*(1-taulUU)/(1+taucUU)/lambdawUU; 
zetacU*zetaU*psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wplusU*hU^(1+sigmaLXUU)+lmult17-nbeta*lmult17(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^(1/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU))*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wplusU/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
-zetacU*zetaU*psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wstarU*hU^(1+sigmaLXUU)-lmult2*rkU*(1+psikUU*RXU)/alphaUU/epsilU/((upsilUU*muzstarU*hU*wstarU^(lambdawUU/(lambdawUU-1))/uU/kbarU(-1))^(1-alphaUU))*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU+lmult8*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU+lmult12-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))^(1/lambdawUU*(1-lambdawUU))*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU))/wstarU/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))+lmult13*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU+lmult14*lambdafU*uzcU/(1+taucUU)*pstarU^(lambdafU/(lambdafU-1))*epsilU*(uU*kbarU(-1)/upsilUU/muzstarU)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU*sU+lmult15*hU*wstarU^(lambdawUU/(lambdawUU-1))/(lambdawUU-1)/wstarU*(1-taulUU)*uzcU/(1+taucUU)+lmult16*zetacU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*lambdawUU*(1+sigmaLXUU)/(lambdawUU-1)/wstarU*zetaUU; 
lmult1*(1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU)*(rkU*(1+psikUU*RXU))^alphaUU*(wU*(1+psilUU*RXU))^(1-alphaUU)*(1-alphaUU)/wU/epsilU-lmult12*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^(1/lambdawUU*(1-lambdawUU))/lambdawUU*(1-lambdawUU)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))^(1/lambdawUU*(1-lambdawUU))/lambdawUU*(1-lambdawUU)*((-1+xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wstarU)^(lambdawUU/(1-lambdawUU)))+lmult15*betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/piU(+1)*(1/piU(+1)/muzstarU/wU(+1)*wU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU*muzstarU^(iotamuUU/(1-lambdawUU)-1)*FwXU(+1)-1/nbeta*lmult15(-1)*betaUU*xiwUU*muzstarUU^((1-iotamuUU)/(1-lambdawUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU))^(1/(1-lambdawUU))/piU*(1/piU/muzstarU/wU*wU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU*muzstarU^(iotamuUU/(1-lambdawUU)-1)*FwXU+lmult16*(betaUU*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU(+1)*FwXU(+1)/psiLXUU-betaUU*xiwUU^2*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU(+1)*FwXU(+1)/psiLXUU-((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*FwXU/psiLXUU-((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+1/nbeta*lmult16(-1)*(-betaUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU+betaUU*xiwUU^2*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*FwXU/psiLXUU+betaUU*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+nbeta*lmult16(+1)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))*wU(+1)*FwXU(+1)/psiLXUU-lmult17*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^(1/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU))/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU(-1)^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU/muzstarU/wU*wU(-1)*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU(-1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult17(+1)*((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^(1/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU))/lambdawUU/(1+sigmaLXUU)*(1-lambdawUU)*((-1+xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(pitargetU^iotaw1UU*piU^iotaw2UU*pibarUU^(1-iotaw1UU-iotaw2UU)/piU(+1)/muzstarU/wU(+1)*wU*muzstarUU^(1-iotamuUU)*muzstarU^iotamuUU*wplusU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
 
 
// Other Equations 
 
 
-sU+((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU; 
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )/(uU*kbarU(-1)))^(1-alphaUU) ) )-sU; 
( uzcU/(zetacU*(1+taucUU)) )*zetacU*qU*( -( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) )*( zetaiU*iU*muzstarU*upsilUU/iU(-1) )+1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ) )-(( uzcU/(zetacU*(1+taucUU)) )/muupU)*zetacU+betaUU*zetacU*( uzcU(+1)/(zetacU*(1+taucUU)) )*qU(+1)*( ( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )-muzstarUU*upsilUU)) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )^2) )/(muzstarU*upsilUU); 
 rkU - tauoU*rkUU*exp(sigmaaUU*(uU-1)); 
RkXU - ( ( (1-taukUU)*(uU*rkU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilUU*qU(-1)) + taukUU*deltaUU - 1); 
 uzcU-(muzstarU*zetacU/(cU*muzstarU-bUU*cU(-1)))+bUU*betaUU*zetacU/(cU(+1)*muzstarU-bUU*cU); 
 (betaUU*zetacU*( uzcU(+1)/(zetacU*(1+taucUU)) )/(piU(+1)*muzstarU))*(1+RXU(+1)) - zetacU*( uzcU/(zetacU*(1+taucUU)) ); 
( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) )-gU-cU-iU/muupU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU )*kbarU(-1)/(muzstarU*upsilUU); 
kbarU-(1-deltaUU)*(kbarU(-1)/(muzstarU*upsilUU))-(1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ))*iU; 
 
-zetacU*( uzcU/(zetacU*(1+taucUU)) )+( uzcU(+1)/(zetacU*(1+taucUU)) )*zetacU*(betaUU/(piU(+1)*muzstarU))*(1+RkXU(+1)); 
 pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) ) ^ lambdafU ) + xipUU*(((( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)*pstarU(-1))^( lambdafU / (1-lambdafU) )) )^(1/( lambdafU / (1-lambdafU) )); 
  wstarU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ lambdawUU ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wstarU(-1))^( lambdawUU/(1-lambdawUU) ) ) )^(1/( lambdawUU/(1-lambdawUU) )) ); 
  zetacU*( uzcU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) ) + ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (1/(1-lambdafU)) ) * betaUU * xipUU * FpXU(+1) - FpXU; 
 zetacU*lambdafU*( uzcU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) )*sU + betaUU * xipUU *  ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (lambdafU/(1-lambdafU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1))^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) ) - ( FpXU* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) ); 
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1)))*hU*(1-taulUU)*( uzcU/(zetacU*(1+taucUU)) )/lambdawUU) + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawUU))) * ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )^(1/(1-lambdawUU))) / piU(+1) ) * ( (1/( piU(+1)*muzstarU*wU(+1)/wU )) ^ (lambdawUU/(1-lambdawUU)) ) * (muzstarU^(iotamuUU/(1-lambdawUU)-1)) * FwXU(+1) - FwXU; 
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1))*hU)^(1+sigmaLXUU))*zetaUU + betaUU * xiwUU * (( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )  ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))) * ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU(+1) * FwXU(+1)/psiLXUU ) - ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )   ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU   * FwXU/psiLXUU ); 
 wplusU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )^(lambdawUU*(1+sigmaLXUU)) ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wplusU(-1))^( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) ) ) )^(1/( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) )) ); 
 
log(epsilU) = rhoU*log(epsilU(-1))+U4+PATRIOT; 
U = SIGNAL; 
U1 = U(-1); 
U2 = U(-2); 
U3 = U(-3); 
U4 = U(-4); 
 
end; 
 
 
initval; 
qU=qUU; 
uU=uUU; 
piU=piUU; 
RkXU=RkXUU; 
rkU=rkUU; 
RXU=RXUU; 
pstarU=pstarUU; 
wstarU=wstarUU; 
wplusU=wplusUU; 
kbarU=kbarUU; 
hU=hUU; 
cU=cUU; 
iU=iUU; 
FpXU=FpXUU; 
FwXU=FwXUU; 
uzcU=uzcUU; 
sU=sUU; 
wU=wUU; 
Util=0; 
Welf=0; 
epsilU=epsilUU; 
U=0; 
U1=0; 
U2=0; 
U3=0; 
U4=0; 
lmult1 = lmult1_SS; 
lmult2 = lmult2_SS; 
lmult3 = lmult3_SS; 
lmult4 = lmult4_SS; 
lmult5 = lmult5_SS; 
lmult6 = lmult6_SS; 
lmult7 = lmult7_SS; 
lmult8 = lmult8_SS; 
lmult9 = lmult9_SS; 
lmult10 = lmult10_SS; 
lmult11 = lmult11_SS; 
lmult12 = lmult12_SS; 
lmult13 = lmult13_SS; 
lmult14 = lmult14_SS; 
lmult15 = lmult15_SS; 
lmult16 = lmult16_SS; 
lmult17 = lmult17_SS; 
end; 
 
shocks; 
var SIGNAL; 
stderr 0.1; 
var PATRIOT; 
stderr 0.1; 
end; 
 
steady; 
 
// options_.loglinear=1; (supposedly, this lets you compute log-linear approximations...but it does not 
//    seem to work well, perhaps because some shocks have mean zero and it's doing a log-linear approximation 
//    on them. 
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=20); 
stoch_simul(order=1,irf=20) cU iU qU hU piU wstarU RXU epsilU; 
 
 
cimp=cU_SIGNAL; 
himp=hU_SIGNAL; 
iimp=iU_SIGNAL; 
qimp=qU_SIGNAL; 
piimp=piU_SIGNAL; 
Rimp=RXU_SIGNAL; 
Epsimp=epsilU_SIGNAL; 
   
for ii = 5:20  
    cimp(ii)=cimp(ii)-cU_PATRIOT(ii-4); 
    himp(ii)=himp(ii)-hU_PATRIOT(ii-4); 
    iimp(ii)=iimp(ii)-iU_PATRIOT(ii-4); 
    qimp(ii)=qimp(ii)-qU_PATRIOT(ii-4); 
    piimp(ii)=piimp(ii)-piU_PATRIOT(ii-4); 
    Rimp(ii)=Rimp(ii)-RXU_PATRIOT(ii-4); 
    Epsimp(ii)=Epsimp(ii)-epsilU_PATRIOT(ii-4); 
end  
 
figure 
subplot(331) 
plot(piimp) 
title('Inflation') 
subplot(332) 
plot(himp) 
title('Hours worked') 
subplot(333) 
plot(Rimp) 
title('Interest Rate') 
subplot(334) 
plot(Epsimp) 
title('Technology') 
subplot(335) 
plot(qimp) 
title('Price of capital') 
subplot(336) 
plot(cimp) 
title('consumption') 
subplot(337) 
plot(iimp) 
title('investment') 
 
