function [rkUU, nUU, kUU, hUU, iUU, wUU, dUU, cUU, lambdazUU, yzUU, sigmaUU, omegabarUU, phiUU, mcUU, pitildUU, pstarUU, piwUU,  ...
        pitildwUU, wstarUU, wplusUU, RkXUU, RXUU, FpXUU, KpXUU, FwXUU, KwXUU, uczUU, qUU, GammaXUU, Gam_muGXUU, ...
        lambdafUU, inflUU, muzstarUU, betaUU, deltaUU, FomegabarXUU, muUU, alphaUU, gammaUU, sigmaLXUU, ...
            psiLXUU, lambdawUU, weUU, bigthetaUU, bUU, muupUU, taukUU, upsilUU, iota1UU, iota2UU, ...
            pibarUU, xipUU, iotaw1UU, iotaw2UU, xiwUU, epsilUU,rhoUU,xUU,rhotilUU,aptilUU,aytilUU,SdouprXUU,sigmaaUU] = getsteadyexogm
    

%this routine loads up the parameters and steady state of the model
%with exogenous monetary policy rule.
%if gss = 1, it computes the steady state and saves the parameters
%if gss = 0, it loads model parameters and previously computed steady
%state. In this case, it verifies that the loaded steady state really is
%a steady state.

%
gss=0;
if gss == 1 
    params
    infl=(1+xUU)/muzstarUU;
    tic
    %we need to first compute phi. This is set to a value which implies
    %steady state profits are zero in the case, pibar=steady state
    %inflation 
    phi=0;%by setting phi=0, you trigger the steadystate.m into computing phi so that profits are zero in steady state
    [rk,n,k,h,I,w,d,c,lambdaz,yz,sigma,omegabar,phi,mc,pitild,pstar,piw, ...
            pitildw,wstar,wplus,Rk,R,Fp,Kp,Fw,Kw,ucz,q,Gamma,Gam_muG] = steadystate(lambdafUU,infl, ...
        muzstarUU,betaUU,deltaUU,FomegabarXUU,muUU,alphaUU,gammaUU,sigmaLXUU, ...
        psiLXUU,lambdawUU,weUU,bigthetaUU,bUU,phi, ...
        muupUU,taukUU,upsilUU,iota1UU,iota2UU,pibarUU,xipUU,iotaw1UU,iotaw2UU, ...
        xiwUU,epsilUU);
    toc
    
    %now use the value of phi just computed to calculate state state in the
    %case when steady state inflation is potentially different from pibar
    tic
    [rkUU,nUU,kUU,hUU,iUU,wUU,dUU,cUU,lambdazUU,yzUU,sigmaUU,omegabarUU,phiUU,mcUU,pitildUU,pstarUU,piwUU, ...
            pitildwUU,wstarUU,wplusUU,RkXUU,RXUU,FpXUU,KpXUU,FwXUU,KwXUU,uczUU,qUU,GammaXUU,Gam_muGXUU] = steadystate(lambdafUU,infl, ...
        muzstarUU,betaUU,deltaUU,FomegabarXUU,muUU,alphaUU,gammaUU,sigmaLXUU, ...
        psiLXUU,lambdawUU,weUU,bigthetaUU,bUU,phi, ...
        muupUU,taukUU,upsilUU,iota1UU,iota2UU,pibarUU,xipUU,iotaw1UU,iotaw2UU, ...
        xiwUU,epsilUU);
    toc
    
    ss(1)=lambdafUU;
    ss(2)=infl;
    ss(3)=muzstarUU;
    ss(4)=betaUU;
    ss(5)=deltaUU;
    ss(6)=FomegabarXUU;
    ss(7)=muUU;
    ss(8)=alphaUU;
    ss(9)=gammaUU;
    ss(10)=sigmaLXUU;
    ss(11)=psiLXUU;
    ss(12)=lambdawUU;
    ss(13)=weUU;
    ss(14)=bigthetaUU;
    ss(15)=bUU;
    ss(16)=phi;
    ss(17)=muupUU;
    ss(18)=taukUU;
    ss(19)=upsilUU;
    ss(20)=iota1UU;
    ss(21)=iota2UU;
    ss(22)=pibarUU;
    ss(23)=xipUU;
    ss(24)=iotaw1UU;
    ss(25)=iotaw2UU;
    ss(26)=xiwUU;
    ss(27)=epsilUU;
    
    save ceebgg_exogm rkUU nUU kUU hUU iUU wUU dUU cUU lambdazUU yzUU sigmaUU omegabarUU phiUU mcUU pitildUU pstarUU piwUU  ...
        pitildwUU wstarUU wplusUU RkXUU RXUU FpXUU KpXUU FwXUU KwXUU uczUU qUU GammaXUU Gam_muGXUU ss;
    
elseif gss == 0
    
    params 
    
    gUU=0;    
    
    load ceebgg_exogm rkUU nUU kUU hUU iUU wUU dUU cUU lambdazUU yzUU sigmaUU omegabarUU phiUU mcUU pitildUU pstarUU piwUU  ...
        pitildwUU wstarUU wplusUU RkXUU RXUU FpXUU KpXUU FwXUU KwXUU uczUU qUU GammaXUU Gam_muGXUU ss;
    
    phiUU=ss(16);%the value of phi was endogenously determined
    
    par=[lambdafUU, (1+xUU)/muzstarUU, muzstarUU, betaUU, deltaUU, FomegabarXUU, muUU, alphaUU, gammaUU, sigmaLXUU, ...
            psiLXUU, lambdawUU, weUU, bigthetaUU, bUU, phiUU, muupUU, taukUU, upsilUU, iota1UU, iota2UU, ...
            pibarUU, xipUU, iotaw1UU, iotaw2UU, xiwUU, epsilUU];    
    
    %verify that the parameter read in from params coincide with the ones
    %used to compute the steady state
    if max(abs(ss-par)) > .1e-12
        error('fatal (getsteadyexogm) loaded parameters do not correspond to the ones used to compute the steady state')
    end
    
    %verify that the steady state just loaded in satisfies the steady state
    %equilibrium conditions
    sw=0;
    [err] = checksteady_ceebgg(mcUU,rkUU,wUU,RXUU,hUU,kUU,wstarUU,RkXUU,qUU,(1+xUU)/muzstarUU, ...
    piwUU,uczUU,iUU,pstarUU,lambdazUU,yzUU,FpXUU,KpXUU,gUU,cUU,FwXUU,KwXUU,wplusUU,pitildUU,pitildwUU, ...
    alphaUU,psikUU,psilUU,epsilUU,muzstarUU,upsilUU,lambdawUU,lambdafUU,muupUU,taukUU,deltaUU, ...
    bUU,betaUU,zetacUU,xUU,xipUU,xiwUU,taucUU,taulUU,sigmaLXUU,zetaUU,phiUU,GammaXUU,omegabarUU, ...
    FomegabarXUU,muUU,gammaUU,weUU,nUU,bigthetaUU,Gam_muGXUU,psiLXUU,sw);
     
    if max(abs(err)) > .1e-9
        error('fatal (getsteadyexogm) loaded steady state does not satisfy steady state conditions')
    end
    
end

inflUU=(1+xUU)/muzstarUU;