%-------------------------------------------------------------------------
%    Set parameter values for US 
%-------------------------------------------------------------------------

% NOTE: priors related to the following parameters are set in 'set_params_priors.m'

% Warning: Not ALL parameters are set in this file.
% parameters related to time series representation of shocks (and their respective priors) are set in parametersstoch_us.m
% *taumat...the vector that indicates what shocks are not observed in partial equations, is set in makealphabeta
% *checkB contains taup, a list of variables not observed in partial information equations 
% *checkB also contains part, a list of the partial information equations

%NOTE: Parameters changed for the boom-bust paper simulations: sigmaa,
%upsil, taxes and etag.

%--- Household
lambdaw     =   1.05;                 % CEE page 22. Euro area: same
%l           =   0.09043076545480;                    
sigmaL      =   1;                    % CEE page 21. Euro area: same
zeta        =   1.000;                % ??. Euro area: same
theta       =   0.77;%0.785; %0.7960172; %0.81; %Euro area:0.745 
v           =   0.001; %Euro area: 0.002;   
beta        =   1.01358^(-0.25);%1.00623^(-0.25);  %Euro area: 1.0133^(-0.25)
xiw         =   0.812;                  % CEE page 42
Hdoupr      =   0;%0.0101; 
sigmaq      =   -7; %Euro area: same 
b           =   .63;   %CEE page 42. Euro area: 0.56
psiL        =   61.82056721029309; %Euro area: same
m           =   0.75; %0.757;%The ratio for the US is 0.755; %Euro area: 0.69;
chii        =   0.55;%0.53; %0.5143123; %0.4851; % Euro area: 0.4851; It governs the sostituibility between Dm and more liquid asset in the utility function
duration1   =   40; %duration of the long bond (number of quarters)
duration2   =   8;
term        =   1; %term premium shock
zetac       =   1; %consumption preference shock
iotaw1      =   0.871; %0.885;%degree of indexation to inflation target
iotaw2      =   1-iotaw1;;%degree of indexation to past inflation
iotamu      =   0.822;%degree of indexation of wage to stochastic productivity growth


%--- Entrepreneur
Fomegabar   =   0.013; %0.01441993; %0.025;  %0.008; % BGG page 33 (.03). Euro area: same
sigma       =   0.33123064253832;  %variance of shock omega. Euro area: same
mu          =   0.33;%0.26;%0.2609152; %0.14;     %0.12;   % BGG page 33 (.12), monitoring cost. Euro area: 0.0938 
gamma       =   1-0.0238; %1-0.025;%0.9215234; %1-0.027; %1-0.0272;     % BGG page 33 1-0.0272; 1 - "death rate". Euro area: same
we          =   0.009;  %0.001;                 % ??. Euro area: same                
bigtheta    =   0.1;%0.12;%0.0918328; %0.09; %0.09; % ?? Euro area: same
tauo        =   1; %0.05;

%--- Capital Producer
sigmaa      =   15.1; %1000;%    % Euro area: 0.2
Sdoupr      =   12.3;      % elasticity in dynamic specification of adjustment costs %ACEL page 49  7.69
etai        =   1;      %elasticity in static speification of adjustment costs
muup        =   1;  %investment specific shock
zetai       =   1;  %shock to the marginal efficiency of investment

%--- Goods Producers
muzstar     =   1.0136^(.25);          % Euro area:1.015^(.25);
upsil       =   1.0132^(.25); %1;%  %trend in relative price of consumption. Euro area:1.002^(.25);
phi = 0.24530898644140;
rk = 0.058572; %0.06; %0.0729; %rk=0.04195; great depression paper %rk=0.041225; euro area paper with m=0.7; %rk=0.04625; with delta=0.025 %rk=0.04124; with delta =0.02
lambdaf     =   1.2;                  % Euro area: same 
alpha       =   0.3987246; %0.36;% From ACEL. Euro area: same.
psik        =   0.45;%Euro area: 1; % ??, fraction of k services financed in advance. 
psil        =   0.45;%Euro area: 1;??, fraction of l services financed in advance. 
delta       =   0.025; %0.02540868; %0.025;              % Euro area: 0.02
epsil       =   1;
xip         =   0.631;              % Euro area: 0.767
iota1       =   0.158;
iota2       =   1-iota1;


%--- Banks
ksi         =   0.94145141467876;
xb          =   1.153432323688070e+002;
chorse      =  0.088; %0.083; %0.07247163; % 0.15; %0.1
rhobank     =   0; %-40;
%R           =   0.0073; %0.00715530831117;
vl          =   (1-0.0095);% For the US the fraction of non-FIRE work hours over total hours is (1-0.059). Euro area:.99271; 
vk          =   (1-0.0095);%(1-0.059);%0.99271; 

%--- Taxes and government consumption
etag        =   0.2043; %0;%           % ??
tauk        =   0.32;%0;%.366;                 
taul        =   .241;%0;%           
tauc        =   0.047; %0;       
taud        =   0;%.0; %it has been removed in euro area model
taut = taud;                   % ??   

%--- Monetary Policy
tau         =   0.01; %0.09;  %reserve requirement. For the US the official rate (not effective) is 0.09. Euro area: 0.02
x           =   0.009152;%0.00805;%0.01357; %0.0131; %in the US base money growth over 1959-2003 is 0.0131 quarterly (5.4 annually)
pibar       =   1;%wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy
xp          =   0;

aptil       =  1.5;%1.95;%1.01;%1.59; %0.5 coefficent on inflation in Taylor rule
aytil       =  0.125;%0.178; %0;%0.285; %0.5 coefficient on output in Taylor rule
amtil       =  0;%0.035; %0.1 %coefficient on nominal M3 growth in Taylor rule
actil       =  0;%0.035;%0.25;  %0.01; %0.02; %coefficient on real credit growth in Taylor rule
rhotil      =  0.814; %0.2;%0.839; %interest rate smoothing parameter in Taylor rule

