// Endogenous variables  
// var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, lambdazU, iU, qU, gapU, Util, Welf;  
var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, lambdazU, iU, qU, gapU, Util, Welf, epsilU, Ux, 
    lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11,  lmult12,  lmult13,  lmult14,   
    lmult15; 
    
// Exogenous variables  
// var epsilU Ux;  
  
varexo SIGNAL epx;  
  
//PARAMETERS  
parameters sigmaLXUU, betaUU, psiLXUU, zetaUU, alphaUU, deltaUU, xipUU,  
      iota1UU, iota2UU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,      
      xUU,lambdafUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,piUU,hUU,kUU,pstarUU,FpXUU,UtilUU,WelfUU,nbeta,  
      rhoUU, bet, xiwUU, lambdawUU, sigmaLXUU, iotaw2UU, wplusUU, wstarUU, FwXUU, wUU, iUU, qUU, lambdazUU, bUU, etaUU, muzstarUU;   
  
   
// %---Household  
lambdawUU     =   1.05;  
sigmaLXUU      =   1;  
zetaUU        =   1.000;   
betaUU        =   0.99;    
nbeta         =   betaUU;  
bUU           =   0.63;   
psiLXUU        =   109.8157082828666;    
zetacUU       =   1;  
iotaw1UU      =   0.0;  
iotaw2UU      =   0.13;  
iotamuUU      =   0;  
tauoUU        =   1;  
xiwUU         =   0.83;  
// %----- Capital Producer 
SdouprXUU      =   5.1;  
etaUU         =   1/SdouprXUU;  
muupUU        =   1;  
// %---- Goods Producers  
muzstarUU     =   1.0136^(.25);  
upsilUU       =   1;   
lambdafUU     =   1.2;  
alphaUU       =   0.3987246;  
psikUU        =   0;  
psilUU        =   0;  
deltaUU       =   0.025;  
epsilUU       =   1;  
xipUU         =   0.75;  
iota1UU       =   0.0;  
iota2UU       =   0.6;  
// %---- Taxes and government consumption  
etagUU        =   0;  
taukUU        =   0;  
taulUU        =   0;  
taucUU        =   0;  
// %---- Monetary Policy  
xUU           =   0.009152;  
  
// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy  
pibarUU       =  (1+xUU)/muzstarUU;  
aptilUU       =  1.95 ;  
aytilUU       =  0.18 ;  
rhotilUU      =  0.81 ;  
rhoUU         =  0.8;  
  
  
  
   

  
parameters lmult1U,  lmult2U,  lmult3U,  lmult4U,  lmult5U,   
           lmult6U,  lmult7U,  lmult8U,  lmult9U,  lmult10U,   
           lmult11U,  lmult12U,  lmult13U,  lmult14U,  lmult15U; 
ssnew  
model;  
  
// Welfare and utility  
  
Util = log(cU-bUU*cU(-1))-psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU);   
  
Welf = Util + nbeta*Welf(+1);  
  
// Policymaker's First-Order Conditions 
1/(cU-bUU*cU(-1))-nbeta*bUU/(cU(+1)-bUU*cU)+lmult3+lmult15*(1/50*2534^(1/2)/(4518834387485017/4503599627370496*cU-bUU*cU(-1))^2+bUU^2*betaUU/(4518834387485017/4503599627370496*cU(+1)-bUU*cU)^2)-4518834387485017/4503599627370496/nbeta*lmult15(-1)*bUU*betaUU/(4518834387485017/4503599627370496*cU-bUU*cU(-1))^2-4518834387485017/4503599627370496*nbeta*lmult15(+1)/(4518834387485017/4503599627370496*cU(+1)-bUU*cU)^2*bUU; 
-lmult7+1/nbeta*lmult7(-1)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))*betaUU*xipUU-lmult8*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+1/nbeta*lmult8(-1)*betaUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU); 
-lmult10+1/nbeta*lmult10(-1)*betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))/piU-lmult11*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-(1+sigmaLXUU)*lambdawUU)*wU/psiLXUU+1/nbeta*lmult11(-1)*betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^((1+sigmaLXUU)*lambdawUU/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-(1+sigmaLXUU)*lambdawUU)*wU/psiLXUU; 
lmult14; 
-psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU)/hU-lmult1/(1-alphaUU)/epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU*alphaUU/hU*wU+2244208114798821/2251799813685248/nbeta*lmult2(-1)*lambdazU*betaUU/qU(-1)*alphaUU*epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*(1-alphaUU)/hU*sU-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult7*lambdazU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult8*lambdazU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU*sU+lmult10*lambdazU*wstarU^(lambdawUU/(lambdawUU-1))/lambdawUU+lmult11*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)/hU; 
lmult3+lmult4*(-1+1/100*2534^(1/2)/etaUU*(iU/iU(-1)-1)^2+1/50*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU/iU(-1))-1/50*nbeta*lmult4(+1)*2534^(1/2)/etaUU*(iU(+1)/iU-1)*iU(+1)^2/iU^2+lmult13*(lambdazU*qU*(-1/25*2534^(1/2)/etaUU*(iU/iU(-1)-1)/iU(-1)-1/50*2534^(1/2)/etaUU/iU(-1)^2*iU)-1/50*betaUU*lambdazU(+1)*qU(+1)*2534^(1/2)/etaUU*iU(+1)^3/iU^4-1/25*betaUU*lambdazU(+1)*qU(+1)*2534^(1/2)/etaUU*(iU(+1)/iU-1)*iU(+1)^2/iU^3)+1/nbeta*lmult13(-1)*(1/50*lambdazU*betaUU*qU*2534^(1/2)/etaUU/iU(-1)^3*iU^2+1/25*lambdazU*betaUU*qU*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU/iU(-1)^2)+nbeta*lmult13(+1)*lambdazU(+1)*qU(+1)*(1/25*2534^(1/2)/etaUU*(iU(+1)/iU-1)*iU(+1)/iU^2+1/50*2534^(1/2)/etaUU*iU(+1)^2/iU^3); 
nbeta*lmult1(+1)/(1-alphaUU)/epsilU(+1)*(4518834387485017/4503599627370496*hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/kU)^alphaUU*alphaUU/kU*wU(+1)-2244208114798821/2251799813685248*lmult2*lambdazU(+1)*betaUU/qU*alphaUU*epsilU(+1)*(4518834387485017/4503599627370496*hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/kU)^(1-alphaUU)*(1-alphaUU)/kU*sU(+1)-nbeta*lmult3(+1)*pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*(2244208114798821/2251799813685248*kU)^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)+lmult4+nbeta*lmult4(+1)*(-2244208114798821/2251799813685248+2244208114798821/2251799813685248*deltaUU)+nbeta*lmult7(+1)*lambdazU(+1)*pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*(2244208114798821/2251799813685248*kU)^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)+nbeta*lmult8(+1)*lambdazU(+1)*lambdafUU*pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*(2244208114798821/2251799813685248*kU)^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sU(+1); 
-lmult2+2244208114798821/2251799813685248/nbeta*lmult2(-1)*betaUU/qU(-1)*(alphaUU*epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*sU+qU*(1-deltaUU))+lmult7*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult8*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU-lmult9+2244208114798821/2251799813685248/nbeta*lmult9(-1)*betaUU*(1+RXU(-1))/piU+lmult10*hU*wstarU^(lambdawUU/(lambdawUU-1))/lambdawUU+lmult13*(qU*(1-1/100*2534^(1/2)/etaUU*(iU/iU(-1)-1)^2-1/50*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU/iU(-1))-1)+1/50/nbeta*lmult13(-1)*betaUU*qU*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU^2/iU(-1)^2+lmult15; 
lmult5*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))+nbeta*lmult5(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))-lmult6*((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/(1-lambdafUU)/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU)/((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU)))-nbeta*lmult6(+1)*((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((-1+xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU)/((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))+lmult7*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU*betaUU*xipUU*FpXU(+1)-1/nbeta*lmult7(-1)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/(1-lambdafUU)/piU*betaUU*xipUU*FpXU+lmult8*(betaUU*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)-betaUU*xipUU^2*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(lambdafUU/(1-lambdafUU))*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))-FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))))+1/nbeta*lmult8(-1)*(-betaUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU*FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+betaUU*xipUU^2*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))))+nbeta*lmult8(+1)*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))-2244208114798821/2251799813685248/nbeta*lmult9(-1)*lambdazU*betaUU*(1+RXU(-1))/piU^2+lmult10*betaUU*xiwUU*FwXU(+1)*(piU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU*(piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))/piU(+1)+1/nbeta*lmult10(-1)*(betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/piU^2-betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))/piU^2)+lmult11*(betaUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU(+1)*wU(+1)/psiLXUU-betaUU*xiwUU^2*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU*wU/psiLXUU)+1/nbeta*lmult11(-1)*(-betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU*wU/psiLXUU+betaUU*xiwUU^2*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU*wU/psiLXUU)+nbeta*lmult11(+1)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-lmult12*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult6-nbeta*lmult6(+1)*((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU))/pstarU/((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))+lmult7*lambdazU*pstarU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult8*lambdazU*lambdafUU^2*pstarU^(lambdafUU/(lambdafUU-1))/(lambdafUU-1)/pstarU*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU-lmult14*pstarU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU*wstarU^(lambdawUU*(1-alphaUU)/(lambdawUU-1)); 
-2244208114798821/2251799813685248*lmult2*lambdazU(+1)*betaUU/qU^2*(alphaUU*epsilU(+1)*(4518834387485017/4503599627370496*hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/kU)^(1-alphaUU)*sU(+1)+qU(+1)*(1-deltaUU))+2244208114798821/2251799813685248/nbeta*lmult2(-1)*lambdazU*betaUU/qU(-1)*(1-deltaUU)+lmult13*lambdazU*(1-1/100*2534^(1/2)/etaUU*(iU/iU(-1)-1)^2-1/50*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU/iU(-1))+1/50/nbeta*lmult13(-1)*lambdazU*betaUU*2534^(1/2)/etaUU*(iU/iU(-1)-1)*iU^2/iU(-1)^2; 
2244208114798821/2251799813685248*lmult9*lambdazU(+1)*betaUU/piU(+1); 
lmult1+2244208114798821/2251799813685248/nbeta*lmult2(-1)*lambdazU*betaUU/qU(-1)*alphaUU*epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)+lmult8*lambdazU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wplusU*hU^(1+sigmaLXUU)+lmult12-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wplusU/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
-psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wstarU*hU^(1+sigmaLXUU)-lmult1/(1-alphaUU)/epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU*alphaUU*lambdawUU/(lambdawUU-1)/wstarU*wU+2244208114798821/2251799813685248/nbeta*lmult2(-1)*lambdazU*betaUU/qU(-1)*alphaUU*epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU*sU-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU-lmult5+nbeta*lmult5(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))/wstarU/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))+lmult7*lambdazU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU+lmult8*lambdazU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*(2244208114798821/2251799813685248*kU(-1))^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU*sU+lmult10*hU*lambdazU*wstarU^(lambdawUU/(lambdawUU-1))/(lambdawUU-1)/wstarU+lmult11*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)*lambdawUU/(lambdawUU-1)/wstarU-lmult14*pstarU^(lambdafUU/(lambdafUU-1))*wstarU^(lambdawUU*(1-alphaUU)/(lambdawUU-1))*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU; 
-lmult1/(1-alphaUU)/epsilU*(4518834387485017/4503599627370496*hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU+lmult5*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))+nbeta*lmult5(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))-lmult10*betaUU*xiwUU*FwXU(+1)*(piU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU/piU(+1)+1/nbeta*lmult10(-1)*betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU/piU+lmult11*(betaUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU(+1)*wU(+1)/psiLXUU-betaUU*xiwUU^2*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+1/nbeta*lmult11(-1)*(-betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU+betaUU*xiwUU^2*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU/psiLXUU+betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+nbeta*lmult11(+1)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-lmult12*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult12(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
 
// marginal cost (eq2p)  
sU - (1/(1-alphaUU))*(1/epsilU)*(( muzstarUU*hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) /kU(-1))^alphaUU)*wU;  
  
// intertemporal Euler equation (aapp)  
-lambdazU + (lambdazU(+1)*betaUU/(muzstarUU*qU))*(alphaUU*epsilU(+1)*(muzstarUU * hU(+1)*(wstarU(+1) ^ (lambdawUU/(lambdawUU-1))) /kU)^(1-alphaUU)*sU(+1) + qU(+1)*(1-deltaUU) );  
  
// resource constraint (resource)  
cU + iU - (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1)/muzstarUU )^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU);  
  
// capital accumulation equation (capital)  
kU - ((1-deltaUU)/muzstarUU)*kU(-1) - (1 - (muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2)*iU;  
  
// wstar equation (eq32)  
( (1-xiwUU)*( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^lambdawUU )  
   + xiwUU*( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) * wstarU(-1)) ^ (lambdawUU/(1-lambdawUU)) )^ ((1-lambdawUU)/lambdawUU) - wstarU;  
   
// p-star equation (cc)  
pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) ) ^ lambdafUU ) + xipUU*(((( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)*pstarU(-1))^( lambdafUU / (1-lambdafUU) )) )^(1/( lambdafUU / (1-lambdafUU) ));  
  
// Fp equation (ddp)  
(lambdazU)*(pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1)/muzstarUU )^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU) + (piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*betaUU*xipUU*FpXU(+1) - FpXU;  
  
// Kp equation (substituted out in terms of Fp) (eep)  
(lambdazU)*lambdafUU* (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU* (kU(-1)/muzstarUU)^alphaUU* ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU) - phiUU) * sU  + betaUU * xipUU * ( ( piU^iota2UU * pibarUU^(1-iota2UU) /piU(+1)) ^ (lambdafUU/(1-lambdafUU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (piU^iota2UU) * pibarUU^(1-iota2UU) )/piU(+1))^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ) - ( FpXU* (( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) );  
  
// equation defining the nominal rate of interest (nominal)  
-lambdazU + betaUU*lambdazU(+1)*(1+RXU)/(muzstarUU*piU(+1));  
  
// Fw equation (eq35)  
hU*lambdazU*(wstarU ^ (lambdawUU/(lambdawUU-1)))/(lambdawUU) + betaUU*xiwUU*FwXU(+1)*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) )^(1/(1-lambdawUU)) * (piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))/piU(+1) - FwXU;  
  
// Kw equation (eq36)  
(((wstarU ^ (lambdawUU/(lambdawUU-1)))*hU)^(1+sigmaLXUU)) + betaUU*xiwUU*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))   
* ( (( 1 - xiwUU * ( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU(+1)*wU(+1)/psiLXUU  
- ( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU*wU/psiLXUU;  
  
// wplus equation (wplus) 
wplusU - (   (1 - xiwUU) * ( (1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/(wU*piU))^(1/(1-lambdawUU)))/(1-xiwUU) ) ^ (lambdawUU*(1+sigmaLXUU))  
+ xiwUU * ( wplusU(-1) * wU(-1) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw2UU)) / (wU*piU) ) ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))  )^( (1-lambdawUU)/(lambdawUU*(1+sigmaLXUU)) ); 
  
// investment equation (invest)  
lambdazU*qU*(1-(muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2-(muzstarUU^2/etaUU)*(iU/iU(-1)-1)*iU/iU(-1)) - lambdazU + betaUU*lambdazU(+1)*qU(+1)*(muzstarUU^2/etaUU)*(iU(+1)/iU-1)*(iU(+1)/iU)^2;  
 
// gap 
gapU - pstarU^(lambdafUU/(lambdafUU-1)) * wstarU^(lambdawUU*(1-alphaUU)/(lambdawUU-1)); 
  
// lambdaz (lamz)  
lambdazU - muzstarUU/(muzstarUU*cU-bUU*cU(-1)) + bUU*betaUU/(muzstarUU*cU(+1)-bUU*cU);  
  
  
// law of motion of exogenous shock 
log(epsilU) = rhoUU*log(epsilU(-1))+ Ux(-12) + epx; 
Ux = SIGNAL; 
  
end;  
  
  
initval;  
gapU=1; 
wplusU=wplusUU;  
wstarU=wstarUU;  
wU=wUU;  
FwXU=FwXUU;  
qU=qUU;  
iU=iUU;  
lambdazU=lambdazUU;  
sU=sUU;  
piU=piUU;  
pstarU=pstarUU;  
kU=kUU;  
hU=hUU;  
cU=cUU;  
FpXU=FpXUU;  
Util=0;  
Welf=0;  
RXU=RXUU;  
epsilU=epsilUU;  
Ux=0; 
lmult1 = lmult1U; 
lmult2 = lmult2U; 
lmult3 = lmult3U; 
lmult4 = lmult4U; 
lmult5 = lmult5U; 
lmult6 = lmult6U; 
lmult7 = lmult7U; 
lmult8 = lmult8U; 
lmult9 = lmult9U; 
lmult10 = lmult10U; 
lmult11 = lmult11U; 
lmult12 = lmult12U; 
lmult13 = lmult13U; 
lmult14 = lmult14U; 
lmult15 = lmult15U; 
end;  
  
shocks;  
var SIGNAL;  
stderr 1;  
var epx;  
stderr 0.0001;  
end;  
  
steady;  
  
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=100);  
stoch_simul(order=1,irf=100) cU hU piU kU epsilU RXU sU qU iU wU gapU; 
 
cimp=cU_SIGNAL; 
himp=hU_SIGNAL; 
iimp=iU_SIGNAL; 
qimp=qU_SIGNAL; 
piimp=piU_SIGNAL; 
Rimp=RXU_SIGNAL; 
Epsimp=epsilU_SIGNAL; 
simp=sU_SIGNAL; 
kimp=kU_SIGNAL; 
wimp=wU_SIGNAL; 
gapimp=gapU_SIGNAL; 
   
for ii = 13:24  
    cimp(ii)=cimp(ii)-cU_epx(ii-12); 
    himp(ii)=himp(ii)-hU_epx(ii-12); 
    iimp(ii)=iimp(ii)-iU_epx(ii-12); 
    qimp(ii)=qimp(ii)-qU_epx(ii-12); 
    piimp(ii)=piimp(ii)-piU_epx(ii-12); 
    Rimp(ii)=Rimp(ii)-RXU_epx(ii-12); 
    wimp(ii)=wimp(ii)-wU_epx(ii-12); 
    gapimp(ii)=gapimp(ii)-gapU_epx(ii-12); 
    Epsimp(ii)=Epsimp(ii)-epsilU_epx(ii-12); 
end  
 
pltt 
str=['\xi_{w} = ',num2str(xiwUU),'  \xi_{p} = ',num2str(xipUU),'  \lambda_{f} = ',num2str(lambdafUU),'  \lambda_{w} = ',num2str(lambdawUU),' \iota_{w,2} = ',num2str(iotaw2UU)]; 
hout=suptitle(str); 
 
%dr_algo=0, perturbation approach a la Schmitt-Grohe-Uribe  
%order = 2, second order approximation, default  
%irf, # of periods for impulse responses  
%variables next to parentheses means these are the variables you want  
