// Endogenous variables 
var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, rrU, lambdazU, iU, yU, qU, gapU, gaphouseU, gapfirmU, piwU, Util, Welf; 
// var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, rrU, lambdazU, iU, yU, qU, gapU, gaphouseU, gapfirmU, piwU, Util, Welf, epsilU, Ux,
 
// Exogenous variables 
var epsilU Ux; 
 
varexo SIGNAL epx; 
 
//PARAMETERS 
parameters sigmaLXUU, betaUU, psiLXUU, zetaUU, alphaUU, deltaUU, xipUU, 
      iota1UU, iota2UU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,     
      xUU,lambdafUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,piUU,hUU,kUU,pstarUU,FpXUU,UtilUU,WelfUU,nbeta, 
      rhoUU, bet, xiwUU, lambdawUU, sigmaLXUU, iotaw2UU, wplusUU, wstarUU, FwXUU, wUU, iUU, qUU, lambdazUU, bUU, etaUU, muzstarUU;
 
params
 
 
// following is a call to the steady state 
 
[piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU,FwXUU,wstarUU,wplusUU,wUU,qUU,lambdazUU,iUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
    iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
    lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 
 
 
  
model; 
 
// Welfare and utility 
 
Util = log(cU*muzstarUU-bUU*cU(-1))-psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU);

Welf = Util + nbeta*Welf(+1); 
 
// Monetary Policy Rule
log(RXU) = (1-rhotilUU)*log(RXUU) + rhotilUU*log(RXU(-1)) + (1/RXUU)*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)) - log(piUU)) + (1/(400*RXUU))*xp; 

// marginal cost in terms of wage rate (eq2p) 
sU - (1/(1-alphaUU))*(1/epsilU)*(( muzstarUU*hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) /kU(-1))^alphaUU)*wU; 
 
// lambdaz (lamz) 
lambdazU - muzstarUU/(muzstarUU*cU-bUU*cU(-1)) + bUU*betaUU/(muzstarUU*cU(+1)-bUU*cU); 
 
// intertemporal Euler equation (aapp) 
-lambdazU + (lambdazU(+1)*betaUU/(muzstarUU*qU))*(alphaUU*epsilU(+1)*(muzstarUU * hU(+1)*(wstarU(+1) ^ (lambdawUU/(lambdawUU-1))) /kU)^(1-alphaUU)*sU(+1) + qU(+1)*(1-deltaUU) ); 
 
// investment equation (invest) 
lambdazU*qU*(1-(muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2-(muzstarUU^2/etaUU)*(iU/iU(-1)-1)*iU/iU(-1)) - lambdazU + betaUU*lambdazU(+1)*qU(+1)*(muzstarUU^2/etaUU)*(iU(+1)/iU-1)*(iU(+1)/iU)^2; 

// resource constraint (resource) 
cU + iU - (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1)/muzstarUU )^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU); 
 
// capital accumulation equation (capital) 
kU - ((1-deltaUU)/muzstarUU)*kU(-1) - (1 - (muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2)*iU; 
 
// equation defining the nominal rate of interest (nominal) 
-lambdazU + betaUU*lambdazU(+1)*(1+RXU)/(muzstarUU*piU(+1)); 

// ex ante real rate of interest
rrU-(1+RXU)/piU(+1);

// 7 sticky price/wage equations...

// p-star equation (cc) 
pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) ) ^ lambdafUU ) + xipUU*(((( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)*pstarU(-1))^( lambdafUU / (1-lambdafUU) )) )^(1/( lambdafUU / (1-lambdafUU) )); 
 
// Fp equation (ddp) 
(lambdazU)*(pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1)/muzstarUU )^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU) +
     (piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*betaUU*xipUU*FpXU(+1) - FpXU; 
 
// Kp equation (substituted out in terms of Fp) (eep) 
(lambdazU)*lambdafUU* (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU* (kU(-1)/muzstarUU)^alphaUU* ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU) - phiUU) * sU  + betaUU * xipUU * ( ( piU^iota2UU * pibarUU^(1-iota2UU) /piU(+1)) ^ (lambdafUU/(1-lambdafUU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (piU^iota2UU) * pibarUU^(1-iota2UU) )/piU(+1))^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ) - ( FpXU* (( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ); 
 
// wstar equation (eq32) 
( (1-xiwUU)*( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^lambdawUU ) 
   + xiwUU*( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) * wstarU(-1)) ^ (lambdawUU/(1-lambdawUU)) )^ ((1-lambdawUU)/lambdawUU) - wstarU; 
  
// Fw equation (eq35) 
hU*lambdazU*(wstarU ^ (lambdawUU/(lambdawUU-1)))/(lambdawUU) 
   + betaUU*xiwUU*FwXU(+1)*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) )^(1/(1-lambdawUU)) * (piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))/piU(+1) 
   - FwXU; 
 
// Kw equation (eq36) 
(((wstarU ^ (lambdawUU/(lambdawUU-1)))*hU)^(1+sigmaLXUU)) 
+ betaUU*xiwUU*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))  
* ( (( 1 - xiwUU * ( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU(+1)*wU(+1)/psiLXUU 
- ( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU*wU/psiLXUU; 
 
// wplus equation (wplus)
wplusU - (   (1 - xiwUU) * ( (1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/(wU*piU))^(1/(1-lambdawUU)))/(1-xiwUU) ) ^ (lambdawUU*(1+sigmaLXUU)) 
+ xiwUU * ( wplusU(-1) * wU(-1) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw2UU)) / (wU*piU) ) ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))  )^( (1-lambdawUU)/(lambdawUU*(1+sigmaLXUU)) );

// other stuff...

// this is the 'inefficiency gap' or the labor wedge: marginal product of labor divided by (-ul/lambdaz)
gapU=lambdazU*(pstarU^(lambdafUU/(lambdafUU-1)))*(1-alphaUU)*epsilU*(kU(-1)/muzstarUU )^alphaUU*((wstarU^(lambdawUU/(lambdawUU-1))))^(1-alphaUU)*(hU^(-alphaUU))
             /( psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^sigmaLXUU  );
             
// firm inefficiency gap, marginal product of labor divided by real wage, = s.
gapfirmU-1/sU;

// household inefficiency gap, real wage divided by marginal rate of substitution between consumption and leisure
gaphouseU=wU*lambdazU/ ( psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(sigmaLXUU)  );
 
// nominal wage growth
piwU - wU*muzstarUU*piU/wU(-1);

// definition of output
yU-cU-iU;
 
// law of motion of exogenous shock
log(epsilU) = rhoUU*log(epsilU(-1))+ Ux(-12) + epx;
Ux = SIGNAL;
 
end; 
 
 
initval; 
yU=cUU+iUU;
rrU=(1+RXUU)/piUU;
gapU=lambdafUU*lambdawUU;
gapfirmU=lambdafUU;
gaphouseU=lambdawUU;
wplusU=wplusUU; 
wstarU=wstarUU; 
wU=wUU; 
FwXU=FwXUU; 
qU=qUU; 
iU=iUU; 
lambdazU=lambdazUU; 
sU=sUU; 
piU=piUU; 
pstarU=pstarUU; 
kU=kUU; 
hU=hUU; 
cU=cUU; 
FpXU=FpXUU; 
Util=0; 
Welf=0; 
RXU=RXUU; 
epsilU=epsilUU; 
Ux=0;
piwU=muzstarUU*piUU;
end; 
 
shocks; 
var SIGNAL; 
stderr 1; 
var epx; 
stderr 1; 
end; 
 
steady; 
 
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=100); 
stoch_simul(order=1,irf=24) cU hU piU kU epsilU RXU sU qU iU wU gapU gaphouseU gapfirmU piwU rrU yU;

cimp=cU_SIGNAL;
himp=hU_SIGNAL;
iimp=iU_SIGNAL;
qimp=qU_SIGNAL;
piimp=piU_SIGNAL;
Rimp=RXU_SIGNAL;
Epsimp=epsilU_SIGNAL;
simp=sU_SIGNAL;
kimp=kU_SIGNAL;
wimp=wU_SIGNAL;
yimp=yU_SIGNAL;
piwimp=piwU_SIGNAL;
rrimp=rrU_SIGNAL;
gapimp=gapU_SIGNAL;
gapfirmimp=gapfirmU_SIGNAL;
gaphouseimp=gaphouseU_SIGNAL;  
for ii = 13:24 
    cimp(ii)=cimp(ii)-cU_epx(ii-12);
    himp(ii)=himp(ii)-hU_epx(ii-12);
    iimp(ii)=iimp(ii)-iU_epx(ii-12);
    qimp(ii)=qimp(ii)-qU_epx(ii-12);
    piimp(ii)=piimp(ii)-piU_epx(ii-12);
    Rimp(ii)=Rimp(ii)-RXU_epx(ii-12);
    wimp(ii)=wimp(ii)-wU_epx(ii-12);
    yimp(ii)=yimp(ii)-yU_epx(ii-12);
    simp(ii)=simp(ii)-sU_epx(ii-12);
    piwimp(ii)=piwimp(ii)-piwU_epx(ii-12);
    rrimp(ii)=rrimp(ii)-rrU_epx(ii-12);
    gapimp(ii)=gapimp(ii)-gapU_epx(ii-12);
    gapfirmimp(ii)=gapfirmimp(ii)-gapfirmU_epx(ii-12);
    gaphouseimp(ii)=gaphouseimp(ii)-gaphouseU_epx(ii-12);
    Epsimp(ii)=Epsimp(ii)-epsilU_epx(ii-12);
end 

bUUU=bUU;
SdouprXUUU=SdouprXUU;
betaUUU=betaUU;
deltaUUU=deltaUU;
alphaUUU=alphaUU;
sigmaLXUUU=sigmaLXUU;
rhoUUU=rhoUU;
muzstarUUU=muzstarUU;
psiLXUUU=psiLXUU;


cram=cimp;
hram=himp;
iram=iimp;
qram=qimp;
piram=piimp;
Rram=Rimp;
wram=wimp;
yram=yimp;
sram=simp;
gapram=gapimp;
gaphouseram=gaphouseimp;
gapfirmram=gapfirmimp;
Epsram=Epsimp;
piwram=piwimp;
rrram=rrimp;

save newkeynesian yram rrram cram hram iram qram piram Rram wram gapram gaphouseram gapfirmram Epsram piwram sram bUUU SdouprXUUU betaUUU deltaUUU alphaUUU psiLXUUU sigmaLXUUU rhoUUU muzstarUUU;

pltt
str=['\xi_{w} = ',num2str(xiwUU),'  \xi_{p} = ',num2str(xipUU),'  \lambda_{f} = ',num2str(lambdafUU),'  \lambda_{w} = ',num2str(lambdawUU),' \iota_{w,2} = ',num2str(iotaw2UU)];
hout=suptitle(str);

%dr_algo=0, perturbation approach a la Schmitt-Grohe-Uribe 
%order = 2, second order approximation, default 
%irf, # of periods for impulse responses 
%variables next to parentheses means these are the variables you want 
