 
 
 
// Endogenous variables 
// var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, Util, Welf; 
var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, wstarU, FwXU, wU, Util, Welf, epsilU,
    lmult1,  lmult2,  lmult3,  lmult4,  lmult5,  lmult6,  lmult7,   
    lmult8,  lmult9,  lmult10,  lmult11; 
 
// Exogenous variables 
// var epsilU; 
 
varexo xp epx; 
 
//PARAMETERS 
parameters sigmaLXUU, betaUU, psiLXUU, zetaUU, alphaUU, deltaUU, xipUU, 
      iota1UU, iota2UU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,     
      xUU,lambdafUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,piUU,hUU,kUU,pstarUU,FpXUU,UtilUU,WelfUU,nbeta, 
      rhoUU, bet, xiwUU, lambdawUU, sigmaLXUU, iotaw2UU, wplusUU, wstarUU, FwXUU, wUU;  
 
  
// %---Household 
lambdawUU     =   1.05; 
sigmaLXUU      =   1; 
zetaUU        =   1.000;  
betaUU        =   0.99;   
nbeta         =   betaUU; 
bUU           =   0;  
psiLXUU        =   109.8157082828666;   
zetacUU       =   1; 
iotaw1UU      =   0.0; 
iotaw2UU      =   0.13; 
iotamuUU      =   0; 
tauoUU        =   1; 
xiwUU         =   0.83; 
// %----- Capital Producer 
sigmaaUU      =   12.3; 
SdouprXUU      =   5.1; 
etaiUU        =   2;  
muupUU        =   1;  
zetaiUU       =   1; 
// %---- Goods Producers 
muzstarUU     =   1; 
upsilUU       =   1;  
lambdafUU     =   1.2; 
alphaUU       =   0.3987246; 
psikUU        =   0; 
psilUU        =   0; 
deltaUU       =   0.025; 
epsilUU       =   1; 
xipUU         =   0.75; 
iota1UU       =   0.0; 
iota2UU       =   0.6; 
// %---- Taxes and government consumption 
etagUU        =   0; 
taukUU        =   0; 
taulUU        =   0; 
taucUU        =   0; 
// %---- Monetary Policy 
xUU           =   0.009152; 
 
// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy 
pibarUU       =  (1+xUU)/muzstarUU; 
aptilUU       =  1.95 ; 
aytilUU       =  0.18 ; 
rhotilUU      =  0.81 ; 
rhoUU         =  0.8; 
 
 
 
// following is a call to the steady state 
 
 
parameters lmult1_SS,  lmult2_SS,  lmult3_SS,  lmult4_SS,  lmult5_SS,   
           lmult6_SS,  lmult7_SS,  lmult8_SS,  lmult9_SS,  lmult10_SS,   
           lmult11_SS; 
ssnew

model; 
 
// Welfare and utility 
 
Util = log(cU)-psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU);  
 
Welf = Util + nbeta*Welf(+1); 
 
// Policymaker's First-Order Conditions 
1/cU+lmult2/cU^2-1/nbeta*lmult2(-1)*betaUU/cU^2*(alphaUU*epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*sU+1-deltaUU)+lmult3-lmult6/cU^2*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)-lmult7/cU^2*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU+lmult8/cU^2-1/nbeta*lmult8(-1)*betaUU*(1+RXU(-1))/piU/cU^2-lmult9*hU*wstarU^(lambdawUU/(lambdawUU-1))/lambdawUU/cU^2; 
-lmult6+1/nbeta*lmult6(-1)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))*betaUU*xipUU-lmult7*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+1/nbeta*lmult7(-1)*betaUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU); 
-lmult9+1/nbeta*lmult9(-1)*betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))/piU-lmult10*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU/psiLXUU+1/nbeta*lmult10(-1)*betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU/psiLXUU; 
-psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*hU^(1+sigmaLXUU)/hU-lmult1/(1-alphaUU)/epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU*alphaUU/hU*wU+1/nbeta*lmult2(-1)*betaUU/cU*alphaUU*epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*(1-alphaUU)/hU*sU-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult6/cU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU+lmult7/cU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU*sU+lmult9*wstarU^(lambdawUU/(lambdawUU-1))/lambdawUU/cU+lmult10*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)/hU; 
nbeta*lmult1(+1)/(1-alphaUU)/epsilU(+1)*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/kU)^alphaUU*alphaUU/kU*wU(+1)-lmult2*betaUU/cU(+1)*alphaUU*epsilU(+1)*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1))/kU)^(1-alphaUU)*(1-alphaUU)/kU*sU(+1)+lmult3+nbeta*lmult3(+1)*(-1+deltaUU-pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*kU^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU))+nbeta*lmult6(+1)/cU(+1)*pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*kU^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)+nbeta*lmult7(+1)/cU(+1)*lambdafUU*pstarU(+1)^(lambdafUU/(lambdafUU-1))*epsilU(+1)*kU^alphaUU*alphaUU/kU*(hU(+1)*wstarU(+1)^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sU(+1); 
lmult4*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))+nbeta*lmult4(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))-lmult5*((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/(1-lambdafUU)/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU)/((1-xipUU)*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU*pstarU(-1))^(lambdafUU/(1-lambdafUU)))-nbeta*lmult5(+1)*((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((-1+xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU)/((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))+lmult6*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU*betaUU*xipUU*FpXU(+1)-1/nbeta*lmult6(-1)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/(1-lambdafUU)/piU*betaUU*xipUU*FpXU+lmult7*(betaUU*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)-betaUU*xipUU^2*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(lambdafUU/(1-lambdafUU))*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))-FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))))+1/nbeta*lmult7(-1)*(-betaUU*xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU*FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+betaUU*xipUU^2*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(lambdafUU/(1-lambdafUU))*FpXU*((1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))/piU/(1-xipUU*(piU(-1)^iota2UU*pibarUU^(1-iota2UU)/piU)^(1/(1-lambdafUU))))+nbeta*lmult7(+1)*FpXU(+1)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*iota2UU/piU/(1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))-1/nbeta*lmult8(-1)*betaUU*(1+RXU(-1))/piU^2/cU+lmult9*betaUU*xiwUU*FwXU(+1)*(piU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU*(piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))/piU(+1)+1/nbeta*lmult9(-1)*(betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/piU^2-betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))/piU^2)+lmult10*(betaUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU(+1)*wU(+1)/psiLXUU-betaUU*xiwUU^2*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU*wU/psiLXUU)+1/nbeta*lmult10(-1)*(-betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU*wU/psiLXUU+betaUU*xiwUU^2*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU*wU/psiLXUU)+nbeta*lmult10(+1)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-lmult11*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU))/(1-lambdawUU)/piU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))-xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult11(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult5-nbeta*lmult5(+1)*((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))*xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU))/pstarU/((1-xipUU)*((1-xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1)*pstarU)^(lambdafUU/(1-lambdafUU)))+lmult6/cU*pstarU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)+lmult7/cU*lambdafUU^2*pstarU^(lambdafUU/(lambdafUU-1))/(lambdafUU-1)/pstarU*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU; 
lmult8*betaUU/piU(+1)/cU(+1); 
lmult1+1/nbeta*lmult2(-1)*betaUU/cU*alphaUU*epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)+lmult7/cU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*(epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wplusU*hU^(1+sigmaLXUU)+lmult11*(1-((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU))/wplusU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))))-nbeta*lmult11(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wplusU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wplusU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
-psiLXUU*(wstarU/wplusU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wstarU*hU^(1+sigmaLXUU)-lmult1/(1-alphaUU)/epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU*alphaUU*lambdawUU/(lambdawUU-1)/wstarU*wU+1/nbeta*lmult2(-1)*betaUU/cU*alphaUU*epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU*sU-lmult3*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU-lmult4+nbeta*lmult4(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))/wstarU/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))+lmult6/cU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU+lmult7/cU*lambdafUU*pstarU^(lambdafUU/(lambdafUU-1))*epsilU*kU(-1)^alphaUU*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU*sU+lmult9*hU*wstarU^(lambdawUU/(lambdawUU-1))/(lambdawUU-1)/wstarU/cU+lmult10*(hU*wstarU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*lambdawUU*(1+sigmaLXUU)/(lambdawUU-1)/wstarU; 
-lmult1/(1-alphaUU)/epsilU*(hU*wstarU^(lambdawUU/(lambdawUU-1))/kU(-1))^alphaUU+lmult4*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU*wstarU(-1))^(lambdawUU/(1-lambdawUU)))+nbeta*lmult4(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU)/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1)*wstarU)^(lambdawUU/(1-lambdawUU)))-lmult9*betaUU*xiwUU*FwXU(+1)*(piU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU/piU(+1)+1/nbeta*lmult9(-1)*betaUU*xiwUU*FwXU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU*wU/wU(-1))^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU/piU+lmult10*(betaUU*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU(+1)*wU(+1)/psiLXUU-betaUU*xiwUU^2*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU/psiLXUU-((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+1/nbeta*lmult10(-1)*(-betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU+betaUU*xiwUU^2*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))*FwXU/psiLXUU+betaUU*xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wU(-1)/piU/wU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU/psiLXUU)+nbeta*lmult10(+1)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU))/(1-lambdawUU)/wU/(1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wU/piU(+1)/wU(+1))^(1/(1-lambdawUU)))*FwXU(+1)*wU(+1)/psiLXUU+lmult11*((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wU/((1-xiwUU)*((1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/wplusU/piU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU(-1)*wU(-1)*piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)/piU/wU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*lmult11(+1)*((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wU/((1-xiwUU)*((1-xiwUU*(piU^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU/wplusU(+1)/piU(+1))^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU*wU*piU^iotaw2UU*pibarUU^(1-iotaw2UU)/piU(+1)/wU(+1))^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
 
// marginal cost (eq2p) 
sU - (1/(1-alphaUU))*(1/epsilU)*(( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) /kU(-1))^alphaUU)*wU; 
 
// intertemporal Euler equation (aap) 
-1/cU + (betaUU/cU(+1))*(alphaUU*epsilU(+1)*( hU(+1)*(wstarU(+1) ^ (lambdawUU/(lambdawUU-1))) /kU)^(1-alphaUU)*sU(+1)+1-deltaUU); 
 
// resource constraint (bbp) 
cU + kU - (1-deltaUU)*kU(-1) - (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1))^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU); 
 
// wstar equation (eq32) 
( (1-xiwUU)*( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^lambdawUU ) 
   + xiwUU*( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) * wstarU(-1)) ^ (lambdawUU/(1-lambdawUU)) )^ ((1-lambdawUU)/lambdawUU) - wstarU; 
  
// p-star equation (cc) 
pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) ) ^ lambdafUU ) + xipUU*(((( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)*pstarU(-1))^( lambdafUU / (1-lambdafUU) )) )^(1/( lambdafUU / (1-lambdafUU) )); 
 
// Fp equation (ddp) 
(1/cU)*(pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1))^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU) + (piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*betaUU*xipUU*FpXU(+1) - FpXU; 
 
// Kp equation (substituted out in terms of Fp) (eep) 
(1/cU)*lambdafUU* (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU* kU(-1)^alphaUU* ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU) - phiUU) * sU  + betaUU * xipUU * ( ( piU^iota2UU * pibarUU^(1-iota2UU) /piU(+1)) ^ (lambdafUU/(1-lambdafUU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (piU^iota2UU) * pibarUU^(1-iota2UU) )/piU(+1))^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ) - ( FpXU* (( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ); 
 
// equation defining the nominal rate of interest 
-1/cU + betaUU*(1+RXU)/(piU(+1)*cU(+1)); 
 
// Fw equation (eq35) 
hU*(wstarU ^ (lambdawUU/(lambdawUU-1)))/(lambdawUU*cU) + betaUU*xiwUU*FwXU(+1)*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) )^(1/(1-lambdawUU)) * (piU(+1)*wU(+1)/wU)^(lambdawUU/(lambdawUU-1))/piU(+1) - FwXU; 
 
// Kw equation (eq36) 
(((wstarU ^ (lambdawUU/(lambdawUU-1)))*hU)^(1+sigmaLXUU)) + betaUU*xiwUU*( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))  
* ( (( 1 - xiwUU * ( piU^iotaw2UU*pibarUU^(1-iotaw2UU) * wU/(piU(+1)*wU(+1)) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU(+1)*wU(+1)/psiLXUU 
- ( (( 1 - xiwUU * ( piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU) * wU(-1)/(piU*wU) )^(1/(1-lambdawUU)) )/( 1 - xiwUU) )^(1-lambdawUU*(1+sigmaLXUU)) ) * FwXU*wU/psiLXUU; 
 
// wplus equation (wplus) 
wplusU - (   (1 - xiwUU) * ( (1-xiwUU*(piU(-1)^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU(-1)/(wplusU*piU))^(1/(1-lambdawUU)))/(1-xiwUU) ) ^ (lambdawUU*(1+sigmaLXUU))  
+ xiwUU * ( wplusU(-1) * wU(-1) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw2UU)) / (wU*piU) ) ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))  )^( (1-lambdawUU)/(lambdawUU*(1+sigmaLXUU)) ); 
 
 
// law of motion of exogenous shock 
log(epsilU) = rhoUU*log(epsilU(-1))+ epx; 
 
end; 
 
 
initval; 
wplusU=wplusUU; 
wstarU=wstarUU; 
wU=wUU; 
FwXU=FwXUU; 
sU=sUU; 
piU=piUU; 
pstarU=pstarUU; 
kU=kUU; 
hU=hUU; 
cU=cUU; 
FpXU=FpXUU; 
Util=0; 
Welf=0; 
RXU=RXUU; 
epsilU=epsilUU; 
lmult1 = lmult1_SS; 
lmult2 = lmult2_SS; 
lmult3 = lmult3_SS; 
lmult4 = lmult4_SS; 
lmult5 = lmult5_SS; 
lmult6 = lmult6_SS; 
lmult7 = lmult7_SS; 
lmult8 = lmult8_SS; 
lmult9 = lmult9_SS; 
lmult10 = lmult10_SS; 
lmult11 = lmult11_SS; 
end; 
 
shocks; 
var xp; 
stderr 1; 
var epx; 
stderr 1; 
end; 
 
steady; 
 
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=100); 
stoch_simul(order=1,irf=100) cU hU piU kU epsilU; 
%dr_algo=0, perturbation approach a la Schmitt-Grohe-Uribe 
%order = 2, second order approximation, default 
%irf, # of periods for impulse responses 
%variables next to parentheses means these are the variables you want 
