% Coefficients defining linear system for obtaining steady states of LM variables 

global cU_SS epsilU_SS FpXU_SS FwXU_SS hU_SS kU_SS piU_SS pstarU_SS ... 
       RXU_SS sU_SS wplusU_SS wstarU_SS wU_SS; 
  
global lmult1_SS lmult2_SS lmult3_SS lmult4_SS lmult5_SS lmult6_SS ... 
       lmult7_SS lmult8_SS lmult9_SS lmult10_SS lmult11_SS; 
  
lmss_mat = zeros(12,11); 
lmss_vec = zeros(12,1); 
lmss_vec(1) = 1/cU_SS; 
lmss_mat(1,1) = 0; 
lmss_mat(1,2) = 1/cU_SS^2-1/nbeta*betaUU/cU_SS^2*(alphaUU*epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^(1-alphaUU)*sU_SS+1-deltaUU); 
lmss_mat(1,3) = 1; 
lmss_mat(1,4) = 0; 
lmss_mat(1,5) = 0; 
lmss_mat(1,6) = -1/cU_SS^2*pstarU_SS^(lambdafUU/(lambdafUU-1))*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(1,7) = -1/cU_SS^2*lambdafUU*pstarU_SS^(lambdafUU/(lambdafUU-1))*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU_SS; 
lmss_mat(1,8) = 1/cU_SS^2-1/nbeta*betaUU*(1+RXU_SS)/piU_SS/cU_SS^2; 
lmss_mat(1,9) = -hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/lambdawUU/cU_SS^2; 
lmss_mat(1,10) = 0; 
lmss_mat(1,11) = 0; 
lmss_vec(2) = 0; 
lmss_mat(2,1) = 0; 
lmss_mat(2,2) = 0; 
lmss_mat(2,3) = 0; 
lmss_mat(2,4) = 0; 
lmss_mat(2,5) = 0; 
lmss_mat(2,6) = -1+1/nbeta*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))*betaUU*xipUU; 
lmss_mat(2,7) = -((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+1/nbeta*betaUU*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(lambdafUU/(1-lambdafUU))*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU); 
lmss_mat(2,8) = 0; 
lmss_mat(2,9) = 0; 
lmss_mat(2,10) = 0; 
lmss_mat(2,11) = 0; 
lmss_vec(3) = 0; 
lmss_mat(3,1) = 0; 
lmss_mat(3,2) = 0; 
lmss_mat(3,3) = 0; 
lmss_mat(3,4) = 0; 
lmss_mat(3,5) = 0; 
lmss_mat(3,6) = 0; 
lmss_mat(3,7) = 0; 
lmss_mat(3,8) = 0; 
lmss_mat(3,9) = -1+1/nbeta*betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))/piU_SS; 
lmss_mat(3,10) = -((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU_SS/psiLXUU+1/nbeta*betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wU_SS/psiLXUU; 
lmss_mat(3,11) = 0; 
lmss_vec(4) = -psiLXUU*(wstarU_SS/wplusU_SS)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*hU_SS^(1+sigmaLXUU)/hU_SS; 
lmss_mat(4,1) = -1/(1-alphaUU)/epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^alphaUU*alphaUU/hU_SS*wU_SS; 
lmss_mat(4,2) = 1/nbeta*betaUU/cU_SS*alphaUU*epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^(1-alphaUU)*(1-alphaUU)/hU_SS*sU_SS; 
lmss_mat(4,3) = -pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU_SS; 
lmss_mat(4,4) = 0; 
lmss_mat(4,5) = 0; 
lmss_mat(4,6) = 1/cU_SS*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU_SS; 
lmss_mat(4,7) = 1/cU_SS*lambdafUU*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hU_SS*sU_SS; 
lmss_mat(4,8) = 0; 
lmss_mat(4,9) = wstarU_SS^(lambdawUU/(lambdawUU-1))/lambdawUU/cU_SS; 
lmss_mat(4,10) = (hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)/hU_SS; 
lmss_mat(4,11) = 0; 
lmss_vec(5) = 0; 
lmss_mat(5,1) = nbeta/(1-alphaUU)/epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^alphaUU*alphaUU/kU_SS*wU_SS; 
lmss_mat(5,2) = -betaUU/cU_SS*alphaUU*epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^(1-alphaUU)*(1-alphaUU)/kU_SS*sU_SS; 
lmss_mat(5,3) = 1+nbeta*(-1+deltaUU-pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*alphaUU/kU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)); 
lmss_mat(5,4) = 0; 
lmss_mat(5,5) = 0; 
lmss_mat(5,6) = nbeta/cU_SS*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*alphaUU/kU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU); 
lmss_mat(5,7) = nbeta/cU_SS*lambdafUU*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*alphaUU/kU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sU_SS; 
lmss_mat(5,8) = 0; 
lmss_mat(5,9) = 0; 
lmss_mat(5,10) = 0; 
lmss_mat(5,11) = 0; 
lmss_vec(6) = 0; 
lmss_mat(6,1) = 0; 
lmss_mat(6,2) = 0; 
lmss_mat(6,3) = 0; 
lmss_mat(6,4) = ((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/piU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))+nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*iotaw2UU/piU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(6,5) = -((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/(1-lambdafUU)/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU_SS)/((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU)))-nbeta*((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((-1+xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU_SS)/((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(6,6) = (piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piU_SS*betaUU*xipUU*FpXU_SS-1/nbeta*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/(1-lambdafUU)/piU_SS*betaUU*xipUU*FpXU_SS; 
lmss_mat(6,7) = betaUU*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piU_SS*FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)-betaUU*xipUU^2*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(lambdafUU/(1-lambdafUU))*FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))*iota2UU/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))-FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))+1/nbeta*(-betaUU*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piU_SS*FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+betaUU*xipUU^2*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(lambdafUU/(1-lambdafUU))*FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))))+nbeta*FpXU_SS*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))*iota2UU/piU_SS/(1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU))); 
lmss_mat(6,8) = -1/nbeta*betaUU*(1+RXU_SS)/piU_SS^2/cU_SS; 
lmss_mat(6,9) = betaUU*xiwUU*FwXU_SS*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU_SS*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))/piU_SS+1/nbeta*(betaUU*xiwUU*FwXU_SS*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/piU_SS^2-betaUU*xiwUU*FwXU_SS*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))/piU_SS^2); 
lmss_mat(6,10) = betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU_SS*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS*wU_SS/psiLXUU-betaUU*xiwUU^2*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU-((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU+1/nbeta*(-betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU_SS*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS*wU_SS/psiLXUU+betaUU*xiwUU^2*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU)+nbeta*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU; 
lmss_mat(6,11) = -((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))-xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
lmss_vec(7) = 0; 
lmss_mat(7,1) = 0; 
lmss_mat(7,2) = 0; 
lmss_mat(7,3) = -pstarU_SS^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU_SS*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(7,4) = 0; 
lmss_mat(7,5) = 1-nbeta*((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))*xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU))/pstarU_SS/((1-xipUU)*((1-xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piU_SS^iota2UU*pibarUU^(1-iota2UU)/piU_SS*pstarU_SS)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(7,6) = 1/cU_SS*pstarU_SS^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarU_SS*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(7,7) = 1/cU_SS*lambdafUU^2*pstarU_SS^(lambdafUU/(lambdafUU-1))/(lambdafUU-1)/pstarU_SS*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sU_SS; 
lmss_mat(7,8) = 0; 
lmss_mat(7,9) = 0; 
lmss_mat(7,10) = 0; 
lmss_mat(7,11) = 0; 
lmss_vec(8) = 0; 
lmss_mat(8,1) = 0; 
lmss_mat(8,2) = 0; 
lmss_mat(8,3) = 0; 
lmss_mat(8,4) = 0; 
lmss_mat(8,5) = 0; 
lmss_mat(8,6) = 0; 
lmss_mat(8,7) = 0; 
lmss_mat(8,8) = betaUU/piU_SS/cU_SS; 
lmss_mat(8,9) = 0; 
lmss_mat(8,10) = 0; 
lmss_mat(8,11) = 0; 
lmss_vec(9) = 0; 
lmss_mat(9,1) = 1; 
lmss_mat(9,2) = 1/nbeta*betaUU/cU_SS*alphaUU*epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^(1-alphaUU); 
lmss_mat(9,3) = 0; 
lmss_mat(9,4) = 0; 
lmss_mat(9,5) = 0; 
lmss_mat(9,6) = 0; 
lmss_mat(9,7) = 1/cU_SS*lambdafUU*pstarU_SS^(lambdafUU/(lambdafUU-1))*(epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(9,8) = 0; 
lmss_mat(9,9) = 0; 
lmss_mat(9,10) = 0; 
lmss_mat(9,11) = 0; 
lmss_vec(10) = psiLXUU*(wstarU_SS/wplusU_SS)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wplusU_SS*hU_SS^(1+sigmaLXUU); 
lmss_mat(10,1) = 0; 
lmss_mat(10,2) = 0; 
lmss_mat(10,3) = 0; 
lmss_mat(10,4) = 0; 
lmss_mat(10,5) = 0; 
lmss_mat(10,6) = 0; 
lmss_mat(10,7) = 0; 
lmss_mat(10,8) = 0; 
lmss_mat(10,9) = 0; 
lmss_mat(10,10) = 0; 
lmss_mat(10,11) = 1-((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU))/wplusU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/wplusU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wplusU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
lmss_vec(11) = -psiLXUU*(wstarU_SS/wplusU_SS)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wstarU_SS*hU_SS^(1+sigmaLXUU); 
lmss_mat(11,1) = -1/(1-alphaUU)/epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^alphaUU*alphaUU*lambdawUU/(lambdawUU-1)/wstarU_SS*wU_SS; 
lmss_mat(11,2) = 1/nbeta*betaUU/cU_SS*alphaUU*epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU_SS*sU_SS; 
lmss_mat(11,3) = -pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU_SS; 
lmss_mat(11,4) = -1+nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))/wstarU_SS/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(11,5) = 0; 
lmss_mat(11,6) = 1/cU_SS*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU_SS; 
lmss_mat(11,7) = 1/cU_SS*lambdafUU*pstarU_SS^(lambdafUU/(lambdafUU-1))*epsilU_SS*kU_SS^alphaUU*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarU_SS*sU_SS; 
lmss_mat(11,8) = 0; 
lmss_mat(11,9) = hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/(lambdawUU-1)/wstarU_SS/cU_SS; 
lmss_mat(11,10) = (hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*lambdawUU*(1+sigmaLXUU)/(lambdawUU-1)/wstarU_SS; 
lmss_mat(11,11) = 0; 
lmss_vec(12) = 0; 
lmss_mat(12,1) = -1/(1-alphaUU)/epsilU_SS*(hU_SS*wstarU_SS^(lambdawUU/(lambdawUU-1))/kU_SS)^alphaUU; 
lmss_mat(12,2) = 0; 
lmss_mat(12,3) = 0; 
lmss_mat(12,4) = ((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/wU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))+nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/wU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wU_SS)/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS*wstarU_SS)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(12,5) = 0; 
lmss_mat(12,6) = 0; 
lmss_mat(12,7) = 0; 
lmss_mat(12,8) = 0; 
lmss_mat(12,9) = -betaUU*xiwUU*FwXU_SS*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU_SS/piU_SS+1/nbeta*betaUU*xiwUU*FwXU_SS*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piU_SS*wU_SS/wU_SS)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wU_SS/piU_SS; 
lmss_mat(12,10) = betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wU_SS*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS*wU_SS/psiLXUU-betaUU*xiwUU^2*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/wU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU-((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS/psiLXUU-((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS/psiLXUU+1/nbeta*(-betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS/psiLXUU+betaUU*xiwUU^2*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS/psiLXUU+betaUU*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXU_SS/psiLXUU)+nbeta*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU))/(1-lambdawUU)/wU_SS/(1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wU_SS/piU_SS/wU_SS)^(1/(1-lambdawUU)))*FwXU_SS*wU_SS/psiLXUU; 
lmss_mat(12,11) = ((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wU_SS/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wU_SS/((1-xiwUU)*((1-xiwUU*(piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)*wplusU_SS/wplusU_SS/piU_SS)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusU_SS*wU_SS*piU_SS^iotaw2UU*pibarUU^(1-iotaw2UU)/piU_SS/wU_SS)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 

lmss_vals = -lmss_mat \ lmss_vec; 
errcheck = max(abs(lmss_mat*lmss_vals + lmss_vec)); 
if errcheck > 1e-08, 
  disp('Warning: steady states of lagrange multipliers cannot be accurately determined'); 
  disp(['         errcheck = ',num2str(errcheck,12)]); 
end; 

  lmult1_SS = lmss_vals(1); 
  lmult2_SS = lmss_vals(2); 
  lmult3_SS = lmss_vals(3); 
  lmult4_SS = lmss_vals(4); 
  lmult5_SS = lmss_vals(5); 
  lmult6_SS = lmss_vals(6); 
  lmult7_SS = lmss_vals(7); 
  lmult8_SS = lmss_vals(8); 
  lmult9_SS = lmss_vals(9); 
  lmult10_SS = lmss_vals(10); 
  lmult11_SS = lmss_vals(11); 
