// Endogenous variables 
var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, rkU, RkXU, wstarU, FwXU, wU, lambdazU, iU, qU, gapU, gaphouseU, gapfirmU, piwU, Util, Welf; 
// var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, wplusU, rkU, RkXU, wstarU, FwXU, wU, lambdazU, iU, qU, gapU, gaphouseU, gapfirmU, piwU, Util, Welf, epsilU, Ux; 
 
// Exogenous variables 
var epsilU Ux; 
 
varexo SIGNAL epx; 
 
//PARAMETERS 
parameters sigmaLXUU, betaUU, psiLXUU, zetaUU, alphaUU, deltaUU, xipUU, 
      iota1UU, iota2UU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,yzUU,RkXUU,rkUU,     
      xUU,lambdafUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,piUU,hUU,kUU,pstarUU,FpXUU,UtilUU,WelfUU,nbeta, 
      rhoUU, bet, xiwUU, lambdawUU, sigmaLXUU, iotaw2UU, wplusUU, wstarUU, FwXUU, wUU, iUU, qUU, lambdazUU, bUU, etaUU, muzstarUU      
      ,lambdafU, muzstarU, zetacU, uU, pitargetU, iotaw1UU, iotamuUU, taucUU, upsilUU, taulUU, psikUU, psilUU, taukUU, tauoU, tauoUU,
      sigmaaUU,SdouprXUU,zetaiU,muupUU,muupU;
 
params
 
 
// following is a call to the steady state 
 
[piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU,FwXUU,wstarUU,wplusUU,wUU,qUU,lambdazUU,iUU,yzUU,RkXUU,rkUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
    iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
    lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 
 
// following must go before the ssnew statement 
pitargetUU=pibarUU; 
muupU=muupUU;
iota1UU=0; 
iotaw1UU=0; 
lambdafU=lambdafUU; 
muzstarU=muzstarUU;
pitargetU=pitargetUU;
zetacU=1;
zetaiU=1;
tauoU=tauoUU; 
uU=1; 
  
model; 
 
// Welfare and utility 
 
Util = log(cU*muzstarUU-bUU*cU(-1))-psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU);

Welf = Util + nbeta*Welf(+1); 
 
// Monetary Policy Rule
log(RXU) = (1-rhotilUU)*log(RXUU) + rhotilUU*log(RXU(-1)) + (1/RXUU)*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)) - log(piUU)) + (1/(400*RXUU))*xp; 

// eq2 marginal cost in terms of both factor costs
-sU+((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU;

// eq3  marginal cost in terms of rental rate of capital
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )/(uU*kU(-1)))^(1-alphaUU) ) )-sU;
 
// eq24 household capital accumulation
-zetacU*( lambdazU/(zetacU*(1+taucUU)) )+( lambdazU(+1)/(zetacU*(1+taucUU)) )*zetacU*(betaUU/(piU(+1)*muzstarU))*(1+RkXU(+1));

// eq9 definition of rate of return on capital 
RkXU - ( ( (1-taukUU)*(uU*rkU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilUU*qU(-1)) + taukUU*deltaUU - 1);

// lambdaz (lamz) 
lambdazU - muzstarUU/(muzstarUU*cU-bUU*cU(-1)) + bUU*betaUU/(muzstarUU*cU(+1)-bUU*cU); 
 
// investment equation (invest) 
lambdazU*qU*(1-(muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2-(muzstarUU^2/etaUU)*(iU/iU(-1)-1)*iU/iU(-1)) - lambdazU + betaUU*lambdazU(+1)*qU(+1)*(muzstarUU^2/etaUU)*(iU(+1)/iU-1)*(iU(+1)/iU)^2; 

// resource constraint (resource) 
cU + iU - (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1)/muzstarUU )^alphaUU  * ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1))) )^(1-alphaUU)  - phiUU); 

// capital accumulation equation (capital) 
kU - ((1-deltaUU)/muzstarUU)*kU(-1) - (1 - (muzstarUU^2/(2*etaUU))*(iU/iU(-1)-1)^2)*iU; 
 
//  eq17 money decision 
 (betaUU*zetacU*( lambdazU(+1)/(zetacU*(1+taucUU)) )/(piU(+1)*muzstarU))*(1+RXU) - zetacU*( lambdazU/(zetacU*(1+taucUU)) );

// 7 sticky price/wage equations...

// eq31 p-star equation 
 pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) ) ^ lambdafU ) + xipUU*(((( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)*pstarU(-1))^( lambdafU / (1-lambdafU) )) )^(1/( lambdafU / (1-lambdafU) )); 
  
// eq32 w-star equation 
  wstarU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ lambdawUU ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wstarU(-1))^( lambdawUU/(1-lambdawUU) ) ) )^(1/( lambdawUU/(1-lambdawUU) )) ); 
   
// eq33  Fp equation 
  zetacU*( lambdazU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) ) + ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (1/(1-lambdafU)) ) * betaUU * xipUU * FpXU(+1) - FpXU; 
 
// eq34  Kp equation 
 zetacU*lambdafU*( lambdazU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) )*sU + betaUU * xipUU *  ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (lambdafU/(1-lambdafU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1))^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) ) - ( FpXU* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) ); 
 
// eq35 Fw equation 
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1)))*hU*(1-taulUU)*( lambdazU/(zetacU*(1+taucUU)) )/lambdawUU) + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawUU))) * ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )^(1/(1-lambdawUU))) / piU(+1) ) * ( (1/( piU(+1)*muzstarU*wU(+1)/wU )) ^ (lambdawUU/(1-lambdawUU)) ) * (muzstarU^(iotamuUU/(1-lambdawUU)-1)) * FwXU(+1) - FwXU; 
 
// eq36 Kw equation 
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1))*hU)^(1+sigmaLXUU))*zetaUU + betaUU * xiwUU * (( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )  ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))) * ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU(+1) * FwXU(+1)/psiLXUU ) - ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )   ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU   * FwXU/psiLXUU ); 
 
// eq37 w-plus equation 
 wplusU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )^(lambdawUU*(1+sigmaLXUU)) ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wplusU(-1))^( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) ) ) )^(1/( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) )) ); 

// other stuff...

// this is the 'inefficiency gap' or the labor wedge: marginal product of labor divided by (-ul/lambdaz)
gapU=lambdazU*(pstarU^(lambdafUU/(lambdafUU-1)))*(1-alphaUU)*epsilU*(kU(-1)/muzstarUU )^alphaUU*((wstarU^(lambdawUU/(lambdawUU-1))))^(1-alphaUU)*(hU^(-alphaUU))
             /( psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^sigmaLXUU  );
             
// firm inefficiency gap, marginal product of labor divided by real wage, = s.
gapfirmU-1/sU;

// household inefficiency gap, real wage divided by marginal rate of substitution between consumption and leisure
gaphouseU=wU*lambdazU/ ( psiLXUU*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(sigmaLXUU)  );
 
// nominal wage growth
piwU - wU*muzstarUU*piU/wU(-1);
 
// law of motion of exogenous shock
log(epsilU) = rhoUU*log(epsilU(-1))+ Ux(-12) + epx;
Ux = SIGNAL;
 
end; 
 
 
initval; 
RkXU=RkXUU;
rkU=rkUU;
gapU=lambdafUU*lambdawUU;
gapfirmU=lambdafUU;
gaphouseU=lambdawUU;
wplusU=wplusUU; 
wstarU=wstarUU; 
wU=wUU; 
FwXU=FwXUU; 
qU=qUU; 
iU=iUU; 
lambdazU=lambdazUU; 
sU=sUU; 
piU=piUU; 
pstarU=pstarUU; 
kU=kUU; 
hU=hUU; 
cU=cUU; 
FpXU=FpXUU; 
Util=0; 
Welf=0; 
RXU=RXUU; 
epsilU=epsilUU; 
Ux=0;
piwU=muzstarUU*piUU;
end; 
 
shocks; 
var SIGNAL; 
stderr 1; 
var epx; 
stderr 1; 
end; 
 
steady; 
 
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=100); 
stoch_simul(order=1,irf=24) cU hU piU kU epsilU RXU sU qU iU wU gapU gaphouseU gapfirmU piwU;

cimp=cU_SIGNAL;
himp=hU_SIGNAL;
iimp=iU_SIGNAL;
qimp=qU_SIGNAL;
piimp=piU_SIGNAL;
Rimp=RXU_SIGNAL;
Epsimp=epsilU_SIGNAL;
simp=sU_SIGNAL;
kimp=kU_SIGNAL;
wimp=wU_SIGNAL;
piwimp=piwU_SIGNAL;
gapimp=gapU_SIGNAL;
gapfirmimp=gapfirmU_SIGNAL;
gaphouseimp=gaphouseU_SIGNAL;  
for ii = 13:24 
    cimp(ii)=cimp(ii)-cU_epx(ii-12);
    himp(ii)=himp(ii)-hU_epx(ii-12);
    iimp(ii)=iimp(ii)-iU_epx(ii-12);
    qimp(ii)=qimp(ii)-qU_epx(ii-12);
    piimp(ii)=piimp(ii)-piU_epx(ii-12);
    Rimp(ii)=Rimp(ii)-RXU_epx(ii-12);
    wimp(ii)=wimp(ii)-wU_epx(ii-12);
    simp(ii)=simp(ii)-sU_epx(ii-12);
    piwimp(ii)=piwimp(ii)-piwU_epx(ii-12);
    gapimp(ii)=gapimp(ii)-gapU_epx(ii-12);
    gapfirmimp(ii)=gapfirmimp(ii)-gapfirmU_epx(ii-12);
    gaphouseimp(ii)=gaphouseimp(ii)-gaphouseU_epx(ii-12);
    Epsimp(ii)=Epsimp(ii)-epsilU_epx(ii-12);
end 

bUUU=bUU;
SdouprXUUU=SdouprXUU;
betaUUU=betaUU;
deltaUUU=deltaUU;
alphaUUU=alphaUU;
sigmaLXUUU=sigmaLXUU;
rhoUUU=rhoUU;
muzstarUUU=muzstarUU;
psiLXUUU=psiLXUU;


cram=cimp;
hram=himp;
iram=iimp;
qram=qimp;
piram=piimp;
Rram=Rimp;
wram=wimp;
sram=simp;
gapram=gapimp;
gaphouseram=gaphouseimp;
gapfirmram=gapfirmimp;
Epsram=Epsimp;
piwram=piwimp;

save newkeynesian cram hram iram qram piram Rram wram gapram gaphouseram gapfirmram Epsram piwram sram bUUU SdouprXUUU betaUUU deltaUUU alphaUUU psiLXUUU sigmaLXUUU rhoUUU muzstarUUU;

pltt
str=['\xi_{w} = ',num2str(xiwUU),'  \xi_{p} = ',num2str(xipUU),'  \lambda_{f} = ',num2str(lambdafUU),'  \lambda_{w} = ',num2str(lambdawUU),' \iota_{w,2} = ',num2str(iotaw2UU)];
hout=suptitle(str);

%dr_algo=0, perturbation approach a la Schmitt-Grohe-Uribe 
%order = 2, second order approximation, default 
%irf, # of periods for impulse responses 
%variables next to parentheses means these are the variables you want 
