// Endogenous variables
var R H PI C rr Util Welf Z;
// var R H PI C rr Util Welf;

// Exogenous variables
// var Z ;

// Innovations
varexo tech;

// PARAMETERS
parameters beta theta phi rho alpha nbeta rhopsi psi tau pitarget;

beta = 0.99;
theta = 5;
phi = 100;
rho = 0.9;
alpha = 1.5;
nbeta = 0.99;
tau=1/(theta-1);
tau=0;

// psi is chi in the notes
psi=1;
pitarget=1.0;

[ZU,HU,RU,PIU,CU] = steadys(pitarget,beta,phi,tau,theta,psi);

model;

// Utility
Util = log(C)-psi/2*H^2;

// Welfare
Welf = Util + nbeta*Welf(+1);

//Euler
1/(1+R) = beta*C/(C(+1)*PI(+1));

//new Keynesian Phillips Curve
(1+tau)*(1-theta)+theta*psi*H*C*exp(-Z)-phi*(PI-1)*PI+beta*phi*(PI(+1)-1)*PI(+1);

// resource constraint
C*(1+(phi/2)*(PI-1)^2)-exp(Z)*H;

//Monetary Policy Rule
R = (pitarget/beta)-1+alpha*(PI(+1)-pitarget);

//Technology Shocks

Z = rho*Z(-1)+tech;

// real interest rate

rr-(1+R)/PI(+1);


end;

initval;
R=RU; 
H=HU; 
PI=PIU; 
C=CU;
Z=ZU; 
Util=1;
Welf=1;
rr=(1+RU)/PIU;
end;

shocks;
var tech;
stderr 1;
end;

steady;

// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=30);
stoch_simul(order=1,irf=40) PI H R C rr Z;

// pltt1;

pltt;