// Endogenous variables 
var R H PI C rr Util Welf Z lmult1  lmult2  lmult3  lmult5;  
// var R H PI C rr Util Welf; 
 
// Exogenous variables 
// var Z ; 
 
// Innovations 
varexo tech; 
 
// PARAMETERS 
parameters beta theta phi rho alpha nbeta rhopsi psi tau pitarget; 
 
beta = 0.99; 
theta = 5; 
phi = 100; 
rho = 0.9; 
alpha = 5; 
nbeta = 0.99; 
tau=1/(theta-1); 
 
 
// psi is chi in the notes 
psi=1; 
pitarget=1.0; 
 
  
parameters lmult1U,  lmult2U,  lmult3U,  lmult5U; 
  
newDNK_out_ss
 

model; 
 
// Utility 
Util = log(C)-psi/2*H^2; 
 
// Welfare 
Welf = Util + nbeta*Welf(+1); 
 
//Euler 
1/(1+R) = beta*C/(C(+1)*PI(+1)); 
 
//new Keynesian Phillips Curve 
(1+tau)*(1-theta)+theta*psi*H*C*exp(-Z)-phi*(PI-1)*PI+beta*phi*(PI(+1)-1)*PI(+1); 
 
// resource constraint 
C*(1+(phi/2)*(PI-1)^2)-exp(Z)*H; 
 
// Policymaker's First-Order Conditions 
1/C-lmult1*beta/C(+1)/PI(+1)+1/nbeta*lmult1(-1)*beta*C(-1)/C^2/PI+lmult2*theta*psi*H*exp(-Z)+lmult3*(1+1/2*phi*(PI-1)^2); 
-psi*H+lmult2*theta*psi*C*exp(-Z)-lmult3*exp(Z); 
1/nbeta*lmult1(-1)*beta*C(-1)/C/PI^2+lmult2*(-phi*PI-phi*(PI-1))+1/nbeta*lmult2(-1)*(beta*phi*PI+beta*phi*(PI-1))+lmult3*C*phi*(PI-1)+1/nbeta*lmult5(-1)*(1+R(-1))/PI^2; 
-lmult1/(1+R)^2-lmult5/PI(+1); 
lmult5; 
 
//Technology Shocks 
 
Z = rho*Z(-1)+tech; 
 
// real interest rate 
 
rr-(1+R)/PI(+1); 
 
 
end; 
 
initval; 
R=RU;  
H=HU;  
PI=PIU;  
C=CU; 
Z=ZU;  
Util=1; 
Welf=1; 
rr=(1+RU)/PIU; 
lmult1 = lmult1U; 
lmult2 = lmult2U; 
lmult3 = lmult3U; 
lmult5 = lmult5U; 
end; 
 
shocks; 
var tech; 
stderr 1; 
end; 
 
steady; 
 
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=30); 
stoch_simul(order=1,irf=40) PI H R C rr Z; 
 
pltt1; 
 
// pltt; 
