% Coefficients defining linear system for obtaining steady states of LM variables 
% 
% global C_SS HU PIU RU rrU ZU; 
%   
% global lmult1U lmult2U lmult3U lmult5U; 
%   
lmss_mat = zeros(5,4); 
lmss_vec = zeros(5,1); 
lmss_vec(1) = 1/CU; 
lmss_mat(1,1) = -beta/CU/PIU+1/nbeta*beta*CU/CU^2/PIU; 
lmss_mat(1,2) = theta*psi*HU*exp(-ZU); 
lmss_mat(1,3) = 1+1/2*phi*(PIU-1)^2; 
lmss_mat(1,4) = 0; 
lmss_vec(2) = -psi*HU; 
lmss_mat(2,1) = 0; 
lmss_mat(2,2) = theta*psi*CU*exp(-ZU); 
lmss_mat(2,3) = -exp(ZU); 
lmss_mat(2,4) = 0; 
lmss_vec(3) = 0; 
lmss_mat(3,1) = 1/nbeta*beta*CU/CU/PIU^2; 
lmss_mat(3,2) = -phi*PIU-phi*(PIU-1)+1/nbeta*(beta*phi*PIU+beta*phi*(PIU-1)); 
lmss_mat(3,3) = CU*phi*(PIU-1); 
lmss_mat(3,4) = 1/nbeta*(1+RU)/PIU^2; 
lmss_vec(4) = 0; 
lmss_mat(4,1) = -1/(1+RU)^2; 
lmss_mat(4,2) = 0; 
lmss_mat(4,3) = 0; 
lmss_mat(4,4) = -1/PIU; 
lmss_vec(5) = 0; 
lmss_mat(5,1) = 0; 
lmss_mat(5,2) = 0; 
lmss_mat(5,3) = 0; 
lmss_mat(5,4) = 1; 

lmss_vals = -lmss_mat \ lmss_vec; 
errcheck = max(abs(lmss_mat*lmss_vals + lmss_vec)); 
% if errcheck > 1e-08, 
%   disp('Warning: steady states of lagrange multipliers cannot be accurately determined'); 
%   disp(['         errcheck = ',num2str(errcheck,12)]); 
% end; 

  lmult1U = lmss_vals(1); 
  lmult2U = lmss_vals(2); 
  lmult3U = lmss_vals(3); 
  lmult5U = lmss_vals(4); 
