
// Endogenous variables
var piU, sU, rkU, iU, RkXU, qU, RXU, uzcU, cU, wU, hU, kbarU, pstarU, wstarU, FpXU, FwXU, wplusU, Util, Welf, epsilU, U4, Ux;
// var piU, sU, rkU, iU, RkXU, qU, RXU, uzcU, cU, wU, hU, kbarU, pstarU, wstarU, FpXU, FwXU, wplusU, Util, Welf;

// Exogenous variables
// var epsilU, U4, Ux;

varexo xU SIGNAL PATRIOT;

// Usually, parameters have UU extension, and variables, U. Shocks that are not used have U extension and are parameters
//PARAMETERS
parameters lambdawUU, sigmaLXUU, betaUU, xiwUU, bUU, psiLXUU, iotaw1UU, iotaw2UU, iotamuUU,
      sigmaaUU, SdouprXUU, zetaUU, muzstarUU, upsilUU, alphaUU, psikUU, psilUU, deltaUU, xipUU,
      iota1UU, iota2UU, taukUU, taulUU, taucUU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,    
      xUU,muupUU,lambdafUU,zetacUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,iUU,piUU,gUU,yUU,rkUU,nbeta,
      lambdafU, pitargetU, muupU, gU, muzstarU, zetacU, zetaiU, tauoU, tauoUU, rhoU, zetaU, uU, uUU;

 
// %---Household
lambdawUU     =   1.05;
sigmaLXUU      =   1;
zetaUU        =   1.000; 
betaUU        =   1.01358^(-0.25); 
nbeta         =   1.01358^(-0.25); 
xiwUU         =   0.81;
bUU           =   .63;
psiLXUU        =   109.8157082828666;  
zetacUU       =   1;
iotaw1UU      =   0.0;
iotaw2UU      =   0.13;
iotamuUU      =   0;
tauoUU        =   1;
// %----- Capital Producer
sigmaaUU      =   12.3;
SdouprXUU      =  15.1;
etaiUU        =   2; 
muupUU        =   1; 
zetaiUU       =   1;
// %---- Goods Producers
muzstarUU     =   1.0136^(.25);
upsilUU       =   1.0132^(.25); 
lambdafUU     =   1.2;
alphaUU       =   0.3987246;
psikUU        =   0;
psilUU        =   0;
deltaUU       =   0.025;
epsilUU       =   1;
xipUU         =   0.63;
iota1UU       =   0.0;
iota2UU       =   0.84;
// %---- Taxes and government consumption
etagUU        =   0.2043;
taukUU        =   0.32;
taulUU        =   .241;
taucUU        =   0.047;
// %---- Monetary Policy
xUU           =   0.009152;
// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy
pibarUU       =   (1+xUU)/muzstarUU;
aptilUU       =  1.95 ;
aytilUU       =  0.18 ;
rhotilUU      =  0.81 ;
rhoU          = 0.83;

   
// shock variables not used are set to constants
lambdafU=lambdafUU;
muupU=muupUU;
muzstarU=muzstarUU;
zetacU=zetacUU;
zetaiU=zetaiUU;
tauoU=tauoUU;
zetaU=zetaUU;
pitargetUU=(1+xUU)/muzstarUU;
pitargetU=pitargetUU;
uU=1;


//Steady-state values of Exogenous variables
UxU=0;
U4U=0;

[qUU,piUU,RkXUU,rkUU,RXUU,pstarUU,wstarUU,wplusUU,kbarUU,hUU,lambdazUU,cUU,yUU,gUU,iUU,FpXUU,KpXUU,FwXUU,KwXUU, ... 
            uzcUU,sUU,phiUU,wUU,uUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
        iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
        lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 

gU=gUU;

model;
// Welfare

Util = zetacU*(log(cU*muzstarU-bUU*cU(-1))-zetaU*psiLXUU/(1+sigmaLXUU)*(wstarU/wplusU)^((1+sigmaLXUU)*lambdawUU/(lambdawUU-1))*hU^(1+sigmaLXUU));

Welf = Util + nbeta*Welf(+1);

// Monetary Policy Rule
-log(RXU) = -log(RXUU) - rhotilUU*(log(RXU(-1)) -log(RXUU)) -(1/RXUU)*(1-rhotilUU)*piUU*( log(pitargetU) -log(piUU) ) - (1/RXUU)*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)) - log(pitargetU)) - (1/(4*RXUU))*(1-rhotilUU)*aytilUU*( cUU/yUU*log(cU)+iUU/yUU*log(iU)-iUU/yUU*log(muupU)+gUU/yUU*log(gU)  - (cUU/yUU*log(cUU)+iUU/yUU*log(iUU)+gUU/yUU*log(gUU)) )  - (1/(400*RXUU))*xU;


// Other Equations

// eq2 marginal cost in terms of both factor costs
-sU+((1-alphaUU)^(alphaUU-1)*alphaUU^(-alphaUU))*((rkU*(1+psikUU*RXU))^alphaUU)*((wU*(1+psilUU*RXU))^(1-alphaUU))/epsilU;

// eq3  marginal cost in terms of rental rate of capital
rkU*(1+psikUU*RXU)/( alphaUU*epsilU*( (upsilUU*muzstarU*( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )/(uU*kbarU(-1)))^(1-alphaUU) ) )-sU;

// eq4 investment fonc
( uzcU/(zetacU*(1+taucUU)) )*zetacU*qU*( -( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU)) )*( zetaiU*iU*muzstarU*upsilUU/iU(-1) )+1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ) )-(( uzcU/(zetacU*(1+taucUU)) )/muupU)*zetacU+betaUU*zetacU*( uzcU(+1)/(zetacU*(1+taucUU)) )*qU(+1)*( ( ( sqrt(SdouprXUU/2) )*exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )-muzstarUU*upsilUU))-( sqrt(SdouprXUU/2) )*exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )-muzstarUU*upsilUU)) )*(( zetaiU*iU(+1)*muzstarU*upsilUU/iU )^2) )/(muzstarU*upsilUU);

// eq5 fonc for capital utilization
// rkU - tauoU*rkUU*exp(sigmaaUU*(uU-1));

// eq9 definition of rate of return on capital 
RkXU - ( ( (1-taukUU)*(uU*rkU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU ))+(1-deltaUU)*qU)*piU/(upsilUU*qU(-1)) + taukUU*deltaUU - 1);

// eq14 marginal utility of consumption
 uzcU-(muzstarU*zetacU/(cU*muzstarU-bUU*cU(-1)))+bUU*betaUU*zetacU/(cU(+1)*muzstarU-bUU*cU);
 
//  eq17 money decision 
 (betaUU*zetacU*( uzcU(+1)/(zetacU*(1+taucUU)) )/(piU(+1)*muzstarU))*(1+RXU) - zetacU*( uzcU/(zetacU*(1+taucUU)) );
 
// eq20 (resource constraint)  
( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) )-gU-cU-iU/muupU-tauoU*( rkUU*(exp(sigmaaUU*(uU-1))-1)/sigmaaUU )*kbarU(-1)/(muzstarU*upsilUU);

// eq21 capital accumulation
kbarU-(1-deltaUU)*(kbarU(-1)/(muzstarU*upsilUU))-(1-( exp(( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))+exp(-( sqrt(SdouprXUU/2) )*(( zetaiU*iU*muzstarU*upsilUU/iU(-1) )-muzstarUU*upsilUU))-2 ))*iU;

// eq24 household capital accumulation
-zetacU*( uzcU/(zetacU*(1+taucUU)) )+( uzcU(+1)/(zetacU*(1+taucUU)) )*zetacU*(betaUU/(piU(+1)*muzstarU))*(1+RkXU(+1));

// sticky price equations....

// eq31 p-star equation
 pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) ) ^ lambdafU ) + xipUU*(((( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)*pstarU(-1))^( lambdafU / (1-lambdafU) )) )^(1/( lambdafU / (1-lambdafU) ));
 
// eq32 w-star equation
  wstarU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ lambdawUU ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wstarU(-1))^( lambdawUU/(1-lambdawUU) ) ) )^(1/( lambdawUU/(1-lambdawUU) )) );
  
// eq33  Fp equation
  zetacU*( uzcU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) ) + ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (1/(1-lambdafU)) ) * betaUU * xipUU * FpXU(+1) - FpXU;

// eq34  Kp equation
 zetacU*lambdafU*( uzcU/(zetacU*(1+taucUU)) )*( (pstarU^(lambdafU/(lambdafU-1))) * ( epsilU * (( uU*kbarU(-1)/(muzstarU*upsilUU))^alphaUU ) * ( ( hU*(wstarU ^ (lambdawUU/(lambdawUU-1)) ) )^(1-alphaUU) ) - phiUU) )*sU + betaUU * xipUU *  ( (( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1)) ^ (lambdafU/(1-lambdafU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU(+1))^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) ) - ( FpXU* (( ( (1 - xipUU*(( (pitargetU^iota1UU) * (piU(-1)^iota2UU) * pibarUU^(1-iota1UU-iota2UU) )/piU)^(1/(1-lambdafU)) ) / (1-xipUU) ) )^(1-lambdafU)) );

// eq35 Fw equation
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1)))*hU*(1-taulUU)*( uzcU/(zetacU*(1+taucUU)) )/lambdawUU) + betaUU * xiwUU * (muzstarUU^((1-iotamuUU)/(1-lambdawUU))) * ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )^(1/(1-lambdawUU))) / piU(+1) ) * ( (1/( piU(+1)*muzstarU*wU(+1)/wU )) ^ (lambdawUU/(1-lambdawUU)) ) * (muzstarU^(iotamuUU/(1-lambdawUU)-1)) * FwXU(+1) - FwXU;

// eq36 Kw equation
 zetacU*((wstarU^(lambdawUU/(lambdawUU-1))*hU)^(1+sigmaLXUU))*zetaUU + betaUU * xiwUU * (( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )  ^ (lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))) * ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU(+1)*muzstarU*wU(+1)/wU )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) ) ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU(+1) * FwXU(+1)/psiLXUU ) - ( ( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )   ^ (1-lambdawUU*(1+sigmaLXUU)) ) * wU   * FwXU/psiLXUU );

// eq37 w-plus equation
 wplusU - ( ((1-xiwUU)*( ( (1 - xiwUU * ( ( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) ) ^ (1/(1-lambdawUU)) ) ) / (1-xiwUU) )^(lambdawUU*(1+sigmaLXUU)) ) + xiwUU*( (( (( (pitargetU^iotaw1UU) * (piU(-1)^iotaw2UU) * (pibarUU^(1-iotaw1UU-iotaw2UU)) )/( piU*muzstarU*wU/wU(-1) )) * (muzstarUU^(1-iotamuUU)) * (muzstarU^iotamuUU) )*wplusU(-1))^( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) ) ) )^(1/( lambdawUU*(1+sigmaLXUU)/(1-lambdawUU) )) );

log(epsilU) = rhoU*log(epsilU(-1))+U4+PATRIOT;
Ux = SIGNAL;
U4 = Ux(-12);

end;

initval;
qU=qUU; 
piU=piUU; 
RkXU=RkXUU; 
rkU=rkUU; 
RXU=RXUU;
pstarU=pstarUU;
wstarU=wstarUU;
wplusU=wplusUU;
kbarU=kbarUU;
hU=hUU;
cU=cUU;
iU=iUU;
FpXU=FpXUU;
FwXU=FwXUU;
uzcU=uzcUU;
sU=sUU;
wU=wUU;
Util=0;
Welf=0;
epsilU=epsilUU;
Ux=UxU;
U4=U4U;
end;

shocks;
var SIGNAL;
stderr 1;
var PATRIOT;
stderr 1;
end;

steady;

// options_.loglinear=1; (supposedly, this lets you compute log-linear approximations...but it does not
//    seem to work well, perhaps because some shocks have mean zero and it's doing a log-linear approximation
//    on them.
// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=20);
stoch_simul(order=1,irf=24) cU iU qU hU piU wstarU RXU epsilU;


cimp=cU_SIGNAL;
himp=hU_SIGNAL;
iimp=iU_SIGNAL;
qimp=qU_SIGNAL;
piimp=piU_SIGNAL;
Rimp=RXU_SIGNAL;
Epsimp=epsilU_SIGNAL;
  
for ii = 13:24 
    cimp(ii)=cimp(ii)-cU_PATRIOT(ii-12);
    himp(ii)=himp(ii)-hU_PATRIOT(ii-12);
    iimp(ii)=iimp(ii)-iU_PATRIOT(ii-12);
    qimp(ii)=qimp(ii)-qU_PATRIOT(ii-12);
    piimp(ii)=piimp(ii)-piU_PATRIOT(ii-12);
    Rimp(ii)=Rimp(ii)-RXU_PATRIOT(ii-12);
    Epsimp(ii)=Epsimp(ii)-epsilU_PATRIOT(ii-12);
end 

figure
subplot(331)
plot(piimp/piUU)
title('Inflation')
subplot(332)
plot(himp/hUU)
title('Hours worked')
subplot(333)
plot(Rimp/RXUU)
title('Interest Rate')
subplot(334)
plot(Epsimp)
title('Technology')
subplot(335)
plot(qimp)
title('Price of capital')
subplot(336)
plot(cimp/cUU)
title('consumption')
subplot(337)
plot(iimp/iUU)
title('investment');