
// Endogenous variables
var piU, cU, hU, kU, pstarU, FpXU, sU, RXU, Util, Welf;
// var piU, cU, hU, kU, pstarU, FpXU, sU, Util, Welf, RXU, epsilU;

// Exogenous variables
var epsilU;

varexo xp epx;

//PARAMETERS
parameters sigmaLXUU, betaUU, psiLXUU, zetaUU, alphaUU, deltaUU, xipUU,
      iota1UU, iota2UU, phiUU, pibarUU,aptilUU, aytilUU,  rhotilUU,    
      xUU,lambdafUU,epsilUU,etagUU,pitargetUU,cUU,RXUU,piUU,hUU,kUU,pstarUU,FpXUU,UtilUU,WelfUU,nbeta,
      rhoUU, bet;

 
// %---Household
lambdawUU     =   1;
sigmaLXUU      =   1;
zetaUU        =   1.000; 
betaUU        =   0.99;  
nbeta         =   betaUU; 
xiwUU         =   0;
bUU           =   0; 
psiLXUU        =   109.8157082828666;  
zetacUU       =   1;
iotaw1UU      =   0.0;
iotaw2UU      =   0.13;
iotamuUU      =   0;
tauoUU        =   1;
// %----- Capital Producer
sigmaaUU      =   12.3;
SdouprXUU      =   5.1;
etaiUU        =   2; 
muupUU        =   1; 
zetaiUU       =   1;
// %---- Goods Producers
muzstarUU     =   1;
upsilUU       =   1; 
lambdafUU     =   1.2;
alphaUU       =   0.3987246;
psikUU        =   0;
psilUU        =   0;
deltaUU       =   0.025;
epsilUU       =   1;
xipUU         =   0.75;
iota1UU       =   0.0;
iota2UU       =   0.6;
// %---- Taxes and government consumption
etagUU        =   0;
taukUU        =   0;
taulUU        =   0;
taucUU        =   0;
// %---- Monetary Policy
xUU           =   0.009152;

// %wage/price setting index parameter, automatically set to steady state inflation when not optimizing policy
pibarUU       =   (1+xUU)/muzstarUU;
aptilUU       =  1.95 ;
aytilUU       =  0.18 ;
rhotilUU      =  0.81 ;
rhoUU         =  0.8;



// following is a call to the steady state
[piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ...
    iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ...
    lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU);


model;

// Welfare and utility
Util = log(cU) - psiLXUU/(1+sigmaLXUU)*hU^(1+sigmaLXUU);

Welf = Util + nbeta*Welf(+1);

// Monetary Policy Rule
log(RXU) = (1-rhotilUU)*log(RXUU) + rhotilUU*log(RXU(-1)) + (1/RXUU)*(1-rhotilUU)*aptilUU*piUU*(log(piU(+1)) - log(piUU)) + (1/(400*RXUU))*xp;

// marginal cost, with wage substituted out using labor supply equation
sU - (1/(1-alphaUU))*(1/epsilU)*((hU/kU(-1))^alphaUU)*psiLXUU*(hU^sigmaLXUU)*cU;

// intertemporal Euler equation
-1/cU + (betaUU/cU(+1))*(alphaUU*epsilU(+1)*(hU(+1)/kU)^(1-alphaUU)*sU(+1)+1-deltaUU);

// resource constraint
cU + kU - (1-deltaUU)*kU(-1) - (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1))^alphaUU  * hU^(1-alphaUU)  - phiUU);

// p-star equation
pstarU - ((1-xipUU)*( ( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) ) ^ lambdafUU ) + xipUU*(((( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)*pstarU(-1))^( lambdafUU / (1-lambdafUU) )) )^(1/( lambdafUU / (1-lambdafUU) ));

// Fp equation
(1/cU)*(pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU * ( kU(-1))^alphaUU  * hU^(1-alphaUU)  - phiUU) + (piU^iota2UU*pibarUU^(1-iota2UU)/piU(+1))^(1/(1-lambdafUU))*betaUU*xipUU*FpXU(+1) - FpXU;

// Kp equation (substituted out in terms of Fp)
(1/cU)*lambdafUU* (pstarU^(lambdafUU/(lambdafUU-1))) * ( epsilU* kU(-1)^alphaUU* hU^(1-alphaUU) - phiUU) * sU  + betaUU * xipUU * ( ( piU^iota2UU * pibarUU^(1-iota2UU) /piU(+1)) ^ (lambdafUU/(1-lambdafUU)) ) * ( FpXU(+1)* (( ( (1 - xipUU*(( (piU^iota2UU) * pibarUU^(1-iota2UU) )/piU(+1))^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) ) - ( FpXU* (( ( (1 - xipUU*(( (piU(-1)^iota2UU) * pibarUU^(1-iota2UU) )/piU)^(1/(1-lambdafUU)) ) / (1-xipUU) ) )^(1-lambdafUU)) );

// equation defining the nominal rate of interest
-1/cU + betaUU*(1+RXU)/(piU(+1)*cU(+1));

// law of motion of exogenous shock
log(epsilU) = rhoUU*log(epsilU(-1))+ epx;

end;


initval;
sU=sUU;
piU=piUU;
pstarU=pstarUU;
kU=kUU;
hU=hUU;
cU=cUU;
FpXU=FpXUU;
Util=0;
Welf=0;
RXU=RXUU;
epsilU=epsilUU;
end;

shocks;
var xp;
stderr 1;
var epx;
stderr 1;
end;

steady;

// stoch_simul(dr_algo=0,periods=1000,simul_seed=1,irf=100);
stoch_simul(order=1,irf=100) cU hU piU kU epsilU;

pltt

%dr_algo=0, perturbation approach a la Schmitt-Grohe-Uribe
%order = 2, second order approximation, default
%irf, # of periods for impulse responses
%variables next to parentheses means these are the variables you want