% Coefficients defining linear system for obtaining steady states of LM variables 

% global cUU epsilUU FpXUU hUU kUU piUU pstarUU RXUU ... 
%        sUU; 
%   
% global lmult1U lmult2U lmult3U lmult4U lmult5U lmult6U ... 
%        lmult7U; 
  
lmss_mat = zeros(8,7); 
lmss_vec = zeros(8,1); 
lmss_vec(1) = 1/cUU; 
lmss_mat(1,1) = -1/(1-alphaUU)/epsilUU*(hUU/kUU)^alphaUU*psiLXUU*hUU^sigmaLXUU; 
lmss_mat(1,2) = 1/cUU^2-1/nbeta*betaUU/cUU^2*(alphaUU*epsilUU*(hUU/kUU)^(1-alphaUU)*sUU+1-deltaUU); 
lmss_mat(1,3) = 1; 
lmss_mat(1,4) = 0; 
lmss_mat(1,5) = -1/cUU^2*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU); 
lmss_mat(1,6) = -1/cUU^2*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU)*sUU; 
lmss_mat(1,7) = 1/cUU^2-1/nbeta*betaUU*(1+RXUU)/piUU/cUU^2; 
lmss_vec(2) = 0; 
lmss_mat(2,1) = 0; 
lmss_mat(2,2) = 0; 
lmss_mat(2,3) = 0; 
lmss_mat(2,4) = 0; 
lmss_mat(2,5) = -1+1/nbeta*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*betaUU*xipUU; 
lmss_mat(2,6) = -((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+1/nbeta*betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU); 
lmss_mat(2,7) = 0; 
lmss_vec(3) = -psiLXUU*hUU^(1+sigmaLXUU)/hUU; 
lmss_mat(3,1) = -1/(1-alphaUU)/epsilUU*(hUU/kUU)^alphaUU*alphaUU/hUU*psiLXUU*hUU^sigmaLXUU*cUU-1/(1-alphaUU)/epsilUU*(hUU/kUU)^alphaUU*psiLXUU*hUU^sigmaLXUU*sigmaLXUU/hUU*cUU; 
lmss_mat(3,2) = 1/nbeta*betaUU/cUU*alphaUU*epsilUU*(hUU/kUU)^(1-alphaUU)*(1-alphaUU)/hUU*sUU; 
lmss_mat(3,3) = -pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*hUU^(1-alphaUU)*(1-alphaUU)/hUU; 
lmss_mat(3,4) = 0; 
lmss_mat(3,5) = 1/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*hUU^(1-alphaUU)*(1-alphaUU)/hUU; 
lmss_mat(3,6) = 1/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*hUU^(1-alphaUU)*(1-alphaUU)/hUU*sUU; 
lmss_mat(3,7) = 0; 
lmss_vec(4) = 0; 
lmss_mat(4,1) = nbeta/(1-alphaUU)/epsilUU*(hUU/kUU)^alphaUU*alphaUU/kUU*psiLXUU*hUU^sigmaLXUU*cUU; 
lmss_mat(4,2) = -betaUU/cUU*alphaUU*epsilUU*(hUU/kUU)^(1-alphaUU)*(1-alphaUU)/kUU*sUU; 
lmss_mat(4,3) = 1+nbeta*(-1+deltaUU-pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*hUU^(1-alphaUU)); 
lmss_mat(4,4) = 0; 
lmss_mat(4,5) = nbeta/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*hUU^(1-alphaUU); 
lmss_mat(4,6) = nbeta/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*hUU^(1-alphaUU)*sUU; 
lmss_mat(4,7) = 0; 
lmss_vec(5) = 0; 
lmss_mat(5,1) = 0; 
lmss_mat(5,2) = 0; 
lmss_mat(5,3) = 0; 
lmss_mat(5,4) = -((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piUU)/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))-nbeta*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((-1+xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piUU)/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(5,5) = (piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piUU*betaUU*xipUU*FpXUU-1/nbeta*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)/piUU*betaUU*xipUU*FpXUU; 
lmss_mat(5,6) = betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piUU*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)-betaUU*xipUU^2*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))-FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))+1/nbeta*(-betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piUU*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+betaUU*xipUU^2*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))))+nbeta*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))); 
lmss_mat(5,7) = -1/nbeta*betaUU*(1+RXUU)/piUU^2/cUU; 
lmss_vec(6) = 0; 
lmss_mat(6,1) = 0; 
lmss_mat(6,2) = 0; 
lmss_mat(6,3) = -pstarUU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU); 
lmss_mat(6,4) = 1-nbeta*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))/pstarUU/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(6,5) = 1/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU); 
lmss_mat(6,6) = 1/cUU*lambdafUU^2*pstarUU^(lambdafUU/(lambdafUU-1))/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU)*sUU; 
lmss_mat(6,7) = 0; 
lmss_vec(7) = 0; 
lmss_mat(7,1) = 0; 
lmss_mat(7,2) = 0; 
lmss_mat(7,3) = 0; 
lmss_mat(7,4) = 0; 
lmss_mat(7,5) = 0; 
lmss_mat(7,6) = 0; 
lmss_mat(7,7) = betaUU/piUU/cUU; 
lmss_vec(8) = 0; 
lmss_mat(8,1) = 1; 
lmss_mat(8,2) = 1/nbeta*betaUU/cUU*alphaUU*epsilUU*(hUU/kUU)^(1-alphaUU); 
lmss_mat(8,3) = 0; 
lmss_mat(8,4) = 0; 
lmss_mat(8,5) = 0; 
lmss_mat(8,6) = 1/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*hUU^(1-alphaUU)-phiUU); 
lmss_mat(8,7) = 0; 

lmss_vals = -lmss_mat \ lmss_vec; 
errcheck = max(abs(lmss_mat*lmss_vals + lmss_vec)); 

  lmult1U = lmss_vals(1); 
  lmult2U = lmss_vals(2); 
  lmult3U = lmss_vals(3); 
  lmult4U = lmss_vals(4); 
  lmult5U = lmss_vals(5); 
  lmult6U = lmss_vals(6); 
  lmult7U = lmss_vals(7); 
