
%computes steady state of the equilibrium conditions that constrain the
%Ramsey problem

xxx=betaUU-1.:.00005:.05/4;

xxx=xUU;
xUUin=xUU;

xUU=xxx(1);
[piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
    iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
    lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 

newsimplemodel_out_lmss


if length(xxx) > 1
    
    ff=errcheck;
    dfl=0;
    
    ix=0;
    ixx=0;    
    fff(1)=ff;
    dfff(1)=dfl;
    for ii = 2:length(xxx)
        
        xUU=xxx(ii);
        [piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
            iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
            lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 
        
        newsimplemodel1_out_lmss
        fff(ii)=errcheck;
        
        if errcheck*ff < 0
            ix=ix+1;
            II(ix)=ii;
        end 
        
        df=errcheck-ff;
        ff=errcheck;
        
        if df*dfl < 0
            ixx=ixx+1;
            III(ixx)=ii;
        end
        
        dfl=df;
        dfff(ii)=dfl;
        
        
    end
    
    if ix > 1 ;%this means the criterion crossed the zero line twice..must be two steady states
        error('fatal (ssnew) multiple steady states')
    end
    if ix == 0 & ixx > 1; %this means the criterion never crossed zero and it changed sign twice, suggesting the possibility of two or more steady states
        error('fatal (ssnew) there might be multiple steady states')
    end
    
    if ix == 0 & ixx == 0;%this means the criterion never switched sign and it is monotonic 
        error('fatal (ssnew) there may be no steady state')
    end

    if ix == 0 & ixx == 1;%this is the case we'd normally expect
        if III(1)==1 | III(1) == length(xxx)
            error('fatal (ssnew) change in slope occurs at boundary point')
        end
        x0=xxx(III(1));
    else
        disp(pibarUU)
        error('fatal (ssnew) the optimum seems unexpectedly close to the boundary')
    end
    
    opts =optimset('TolFun',1e-15,'TolX',1e-15,'Maxit',100000);
    
    [xUUnew,fval,exitflag]=fminsearch(@sstatefind,x0,opts,muupUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
        iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
        lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU);
    
    if abs(fval) > 5.6e-10 | abs(imag(xUUnew)) > .1e-10 |exitflag ~= 1
        error('fatal (ssnew) failed to solve for the steady state')
    end
    
    if abs(xUUin-xUUnew) > 0.1e-3
        ('fatal (ssnew) failed to find the right steady-state inflation value')
    end
    
    
    %xUU=xUUin;
    xUU=xUUnew;
    
    [piUU,RXUU,pstarUU,kUU,hUU,cUU,FpXUU,phiUU,sUU] = sstate(muupUU,xUU,muzstarUU,betaUU,taukUU,deltaUU,upsilUU,iota1UU, ... 
        iota2UU,xipUU,lambdafUU,iotaw1UU,iotaw2UU,xiwUU,sigmaLXUU,zetaUU,zetacUU,alphaUU,epsilUU,etagUU,pibarUU, ... 
        lambdawUU,psilUU,psikUU,bUU,taulUU,taucUU,psiLXUU); 
    
    newsimplemodel_out_lmss
    
end


if errcheck > 1e-08, 
    disp('fatal (ssnew) did not find steady state');
end