function [piss,R,pstar,kbar,L,c,Fp,phi,s] = ...
    sstate(muup,x,muzstar,beta,tauk,delta,upsil,iota1,iota2,xip,lambdaf,iotaw1,iotaw2,xiw,sigmaL, ...
    zeta,zetac,alpha,epsil,etag,pibar,lambdaw,psil,psik,b,taul,tauc,psiL) 


%this computes the steady state for the version of the CMR model without
%entrepreneurs and without banks. 

u=1;
q=1/muup; %eqqq4
piss=(1+x)/muzstar; %eqqq22
%pibar=piss;
Rk=piss*muzstar/beta-1; %eqqq24
rk=(Rk-tauk*delta+1)*upsil*q/piss - (1-delta)*q;
rk=rk/(1-tauk);
R=((piss*muzstar/beta) - 1);
pitild=piss^(iota1+iota2)*(pibar^(1-(iota1+iota2)));

aa=  ( 1 - xip * ((pitild/piss)^(1/(1-lambdaf))) )/( 1 - xip );

bb = 1 - xip*((pitild/piss)^(lambdaf/(1-lambdaf)));

pstar=( (1-xip)*(aa^lambdaf) / bb )^((1-lambdaf)/lambdaf);

piw=muzstar*piss;

%pitildw= (piss^(iotaw1+iotaw2)) * (pibar^(1-(iotaw1+iotaw2))) ;
%bb=  ( 1 - xiw * ((pitildw*muzstar/piw)^(1/(1-lambdaw))) )/( 1 - xiw );

wstar=1; %wstar=( (1-xiw)*(bb^lambdaw) / ( 1 - xiw * ( (pitildw*muzstar/piw)^(lambdaw/(1-lambdaw)) ) ) )^((1-lambdaw)/lambdaw);

wplus=1; %wplus=( (1-xiw)*(bb^(lambdaw*(1+sigmaL))) ...
%    / ( 1 - xiw * ( (pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)) ) ) )^((1-lambdaw)/(lambdaw*(1+sigmaL)));

a1 = 1 - ((pitild/piss)^(lambdaf/(1-lambdaf)))*beta*xip;
a2 = 1 - ((pitild/piss)^(1/(1-lambdaf)))*beta*xip;
a3 = 1 - ((pitild/piss)^(1/(1-lambdaf)))*xip;

s = (1/lambdaf) * (a1/a2) * ((a3/(1-xip))^(1-lambdaf));

wtilde=(1/(1+psil*R))*((alpha^alpha)*((1-alpha)^(1-alpha))*s*epsil/( (rk*(1+psik*R))^alpha) )^(1/(1-alpha));

Lk= ((rk/(s*alpha*epsil))^(1/(1-alpha))) / (upsil*muzstar); %l/k

A = (1-etag) * s * epsil * ((upsil*muzstar)^(-alpha)) * ( ( Lk)^(1-alpha) )- (1-(1-delta)/(muzstar*upsil))/muup; %c/k
%A = (1-etag) * s * epsil * ((upsil*muzstar)^(-alpha)) * ( ((wstar^(lambdaw/(lambdaw-1))) * Lk)^(1-alpha) )- (1-(1-delta)/(muzstar*upsil))/muup; %c/k
 
l=Lk; %l=wstar^(lambdaw/(lambdaw-1))*Lk; %l=Lk when no wage rigidities
bb1=1; %bb1=((1-xiw*(pitildw/piss)^(1/(1-lambdaw)))/(1-xiw))^(1-lambdaw*(1+sigmaL));
bb2=1; %bb2=(1-beta*xiw*(pitildw/piss)^(lambdaw*(1+sigmaL)/(1-lambdaw)))/(1-xiw*beta*(pitildw/piss)^(1/(1-lambdaw)));
D=((muzstar-b*beta)/(A*(muzstar-b)))*bb1*bb2*(1-taul)*wtilde/((1+tauc)*lambdaw*psiL*zeta*zetac*(l^sigmaL));
kbar=D^(1/(1+sigmaL));
L=kbar*Lk;
c=A*kbar;
ucz=(muzstar-b*beta)*zetac/(c*(muzstar-b));
lambdaz=ucz/(zetac*(1+tauc));
yz=s*epsil*((1/(upsil*muzstar))^alpha)*(l^(1-alpha))*kbar;

g=etag*yz;
inv=kbar-(1-delta)*kbar/(muzstar*upsil);
Fp=lambdaz*yz/(1-(pitild/piss)^(1/(1-lambdaf))*beta*xip);
Kp=lambdaz*yz*lambdaf*s/(1 - (pitild/piss)^(lambdaf/(1-lambdaf))*beta*xip);

Fw=1; %Fw=zetac*wstar^(lambdaw/(lambdaw-1))*L*(1-taul)*lambdaz/lambdaw;
%Fw=Fw/(1-beta*xiw*(muzstar*pitildw/piw)^(lambdaw/(1-lambdaw))*pitildw/piss);
Kw=1; %Kw=(wstar^(lambdaw/(lambdaw-1))*L)^(1+sigmaL)*zeta*zetac;
%Kw=Kw/(1-beta*xiw*(pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)));
uzc=(1/c)*(muzstar-b*beta)*zetac/(muzstar-b);

aa1 = (1-beta*xip*((pitild/piss)^(lambdaf/(1-lambdaf))))/(1-beta*xip*((pitild/piss)^(1/(1-lambdaf))));
aa2 = ( (1-xip*((pitild/piss)^(1/(1-lambdaf))))/(1-xip) )^(1-lambdaf);
phi = (lambdaf/(aa1*aa2) - pstar^(lambdaf/(1-lambdaf)))*yz; 

%now, check the steady state
%as discussed in the manuscript, there are 21 equations that are set to
%zero in the steady state. One of them, eq5, is used to determine the
%derivative of the utilization cost function, and is not checked below.
%eq2:
err(1)=s-((1/(1-alpha))^(1-alpha))*((1/alpha)^alpha)*((rk*(1+psik*R))^alpha)*((wtilde*(1+psil*R))^(1-alpha))/epsil;
%eq3:
err(2) = s - rk*(1+psik*R)/(alpha*epsil*( ( upsil*muzstar * L/kbar )^(1-alpha) ) );
%err(2) = s - rk*(1+psik*R)/(alpha*epsil*( ( upsil*muzstar*(wstar^(lambdaw/(lambdaw-1))) * L/kbar )^(1-alpha) ) );
%eq4:
err(3) = q - 1/muup;
%eq6:
err(4) = Rk - (((1-tauk)*rk + (1-delta)*q)*piss/(upsil*q)) - tauk*delta + 1;
%eq14:
err(5) = uzc - (1/c)*(muzstar-b*beta)*zetac/(muzstar-b);
%eq17
err(7)=(beta/(piss*muzstar))*(1+R) - 1;

err(8)=uzc - (1+tauc)*zetac*lambdaz;
%eq21
err(9)=kbar-(1-delta)*kbar/(muzstar*upsil)-inv;
%eq22
err(10)=piss-(1+x)/muzstar;
%eq24
err(11)=Rk-piss*muzstar/beta+1;
%eq31
err(13)=pstar-((1-xip)*( (1 - xip * ((pitild/piss)^(1/(1-lambdaf))))/(1-xip))^lambdaf + ...
    xip*(pitild*pstar/piss)^(lambdaf/(1-lambdaf)))^((1-lambdaf)/lambdaf);
%eq32
%www= (1-xiw*(( (pitildw/piw)*muzstar )^(1/(1-lambdaw))))/(1-xiw);
%err(14)=wstar-( (1-xiw)*www^lambdaw + xiw*( (pitildw/piw) * muzstar*wstar)^(lambdaw/(1-lambdaw)) )^((1-lambdaw)/lambdaw);
%eq33
err(15)=lambdaz*yz+(pitild/piss)^(1/(1-lambdaf))*beta*xip*Fp-Fp;
%eq34
err(16)=lambdaz*lambdaf*yz*s+beta*xip*((pitild/piss)^(lambdaf/(1-lambdaf)))*Kp-Kp;
%eq20
err(17)=g+c+inv/muup-yz;
%eq35
err(18)=psiL*L^sigmaL-uzc*wtilde;  %this equation holds only when wage rigidity are nor present
%err(18)=zetac*wstar^(lambdaw/(lambdaw-1))*L*(1-taul)*lambdaz/lambdaw + beta*xiw*muzstar^(lambdaw/(1-lambdaw)) ...
%    *piw^(lambdaw/(lambdaw-1))*pitildw^(1/(1-lambdaw))*Fw/piss - Fw;
%eq36
%err(19)=(wstar^(lambdaw/(lambdaw-1))*L)^(1+sigmaL)*zetac*zeta ...
%    + beta*xiw*(pitildw*muzstar/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw))*Kw-Kw;
%eq37
%wx=(1-xiw*(pitildw*muzstar/piw)^(1/(1-lambdaw)))/(1-xiw);
%err(20)=wplus-((1-xiw)*wx^(lambdaw*(1+sigmaL)) + xiw*(pitildw*muzstar*wplus/piw)^(lambdaw*(1+sigmaL)/(1-lambdaw)))^((1-lambdaw)/(lambdaw*(1+sigmaL)));
%check on phi
err(21)=yz-s*(yz*(pstar^(lambdaf/(1-lambdaf)))+phi);

 
if max(abs(err)) > .1e-8
    error('fatal (nobanknoentrss) failed to compute the steady state for the no banks-no entrepreneur version of the model')
    %disp(max(abs(err)));
end





