% Coefficients defining linear system for obtaining steady states of LM variables 

% global cUU epsilUU FpXUU FwXUU hUU kUU piUU pstarUU ... 
%        RXUU sUU wplusUU wstarUU wUU; 
%   
% global lmult1U lmult2U lmult3U lmult4U lmult5U lmult6U ... 
%        lmult7U lmult8U lmult9U lmult10U lmult11U; 
  
lmss_mat = zeros(12,11); 
lmss_vec = zeros(12,1); 
lmss_vec(1) = 1/cUU; 
lmss_mat(1,1) = 0; 
lmss_mat(1,2) = 1/cUU^2-1/nbeta*betaUU/cUU^2*(alphaUU*epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^(1-alphaUU)*sUU+1-deltaUU); 
lmss_mat(1,3) = 1; 
lmss_mat(1,4) = 0; 
lmss_mat(1,5) = 0; 
lmss_mat(1,6) = -1/cUU^2*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(1,7) = -1/cUU^2*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sUU; 
lmss_mat(1,8) = 1/cUU^2-1/nbeta*betaUU*(1+RXUU)/piUU/cUU^2; 
lmss_mat(1,9) = -hUU*wstarUU^(lambdawUU/(lambdawUU-1))/lambdawUU/cUU^2; 
lmss_mat(1,10) = 0; 
lmss_mat(1,11) = 0; 
lmss_vec(2) = 0; 
lmss_mat(2,1) = 0; 
lmss_mat(2,2) = 0; 
lmss_mat(2,3) = 0; 
lmss_mat(2,4) = 0; 
lmss_mat(2,5) = 0; 
lmss_mat(2,6) = -1+1/nbeta*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*betaUU*xipUU; 
lmss_mat(2,7) = -((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+1/nbeta*betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU); 
lmss_mat(2,8) = 0; 
lmss_mat(2,9) = 0; 
lmss_mat(2,10) = 0; 
lmss_mat(2,11) = 0; 
lmss_vec(3) = 0; 
lmss_mat(3,1) = 0; 
lmss_mat(3,2) = 0; 
lmss_mat(3,3) = 0; 
lmss_mat(3,4) = 0; 
lmss_mat(3,5) = 0; 
lmss_mat(3,6) = 0; 
lmss_mat(3,7) = 0; 
lmss_mat(3,8) = 0; 
lmss_mat(3,9) = -1+1/nbeta*betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))/piUU; 
lmss_mat(3,10) = -((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wUU/psiLXUU+1/nbeta*betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*wUU/psiLXUU; 
lmss_mat(3,11) = 0; 
lmss_vec(4) = -psiLXUU*(wstarUU/wplusUU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*hUU^(1+sigmaLXUU)/hUU; 
lmss_mat(4,1) = -1/(1-alphaUU)/epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^alphaUU*alphaUU/hUU*wUU; 
lmss_mat(4,2) = 1/nbeta*betaUU/cUU*alphaUU*epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^(1-alphaUU)*(1-alphaUU)/hUU*sUU; 
lmss_mat(4,3) = -pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hUU; 
lmss_mat(4,4) = 0; 
lmss_mat(4,5) = 0; 
lmss_mat(4,6) = 1/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hUU; 
lmss_mat(4,7) = 1/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)/hUU*sUU; 
lmss_mat(4,8) = 0; 
lmss_mat(4,9) = wstarUU^(lambdawUU/(lambdawUU-1))/lambdawUU/cUU; 
lmss_mat(4,10) = (hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)/hUU; 
lmss_mat(4,11) = 0; 
lmss_vec(5) = 0; 
lmss_mat(5,1) = nbeta/(1-alphaUU)/epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^alphaUU*alphaUU/kUU*wUU; 
lmss_mat(5,2) = -betaUU/cUU*alphaUU*epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^(1-alphaUU)*(1-alphaUU)/kUU*sUU; 
lmss_mat(5,3) = 1+nbeta*(-1+deltaUU-pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)); 
lmss_mat(5,4) = 0; 
lmss_mat(5,5) = 0; 
lmss_mat(5,6) = nbeta/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU); 
lmss_mat(5,7) = nbeta/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*alphaUU/kUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*sUU; 
lmss_mat(5,8) = 0; 
lmss_mat(5,9) = 0; 
lmss_mat(5,10) = 0; 
lmss_mat(5,11) = 0; 
lmss_vec(6) = 0; 
lmss_mat(6,1) = 0; 
lmss_mat(6,2) = 0; 
lmss_mat(6,3) = 0; 
lmss_mat(6,4) = ((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/piUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))+nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)*iotaw2UU/piUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(6,5) = -((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piUU)/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))-nbeta*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))/lambdafUU*(1-lambdafUU)*((-1+xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU*lambdafUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piUU)/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(6,6) = (piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)*iota2UU/piUU*betaUU*xipUU*FpXUU-1/nbeta*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/(1-lambdafUU)/piUU*betaUU*xipUU*FpXUU; 
lmss_mat(6,7) = betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)*iota2UU/piUU*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)-betaUU*xipUU^2*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))-FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))+1/nbeta*(-betaUU*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*lambdafUU/(1-lambdafUU)/piUU*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)+betaUU*xipUU^2*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(lambdafUU/(1-lambdafUU))*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))))+nbeta*FpXUU*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^(1-lambdafUU)*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))*iota2UU/piUU/(1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU))); 
lmss_mat(6,8) = -1/nbeta*betaUU*(1+RXUU)/piUU^2/cUU; 
lmss_mat(6,9) = betaUU*xiwUU*FwXUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piUU*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))/piUU+1/nbeta*(betaUU*xiwUU*FwXUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/piUU^2-betaUU*xiwUU*FwXUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))/piUU^2); 
lmss_mat(6,10) = betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piUU*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU*wUU/psiLXUU-betaUU*xiwUU^2*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU-((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU+1/nbeta*(-betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piUU*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU*wUU/psiLXUU+betaUU*xiwUU^2*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU)+nbeta*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU; 
lmss_mat(6,11) = -((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))-xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/piUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)*iotaw2UU/piUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*iotaw2UU/piUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
lmss_vec(7) = 0; 
lmss_mat(7,1) = 0; 
lmss_mat(7,2) = 0; 
lmss_mat(7,3) = -pstarUU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(7,4) = 0; 
lmss_mat(7,5) = 1-nbeta*((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU)))^(1/lambdafUU*(1-lambdafUU))*xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))/pstarUU/((1-xipUU)*((1-xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU)^(1/(1-lambdafUU)))/(1-xipUU))^lambdafUU+xipUU*(piUU^iota2UU*pibarUU^(1-iota2UU)/piUU*pstarUU)^(lambdafUU/(1-lambdafUU))); 
lmss_mat(7,6) = 1/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*lambdafUU/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(7,7) = 1/cUU*lambdafUU^2*pstarUU^(lambdafUU/(lambdafUU-1))/(lambdafUU-1)/pstarUU*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU)*sUU; 
lmss_mat(7,8) = 0; 
lmss_mat(7,9) = 0; 
lmss_mat(7,10) = 0; 
lmss_mat(7,11) = 0; 
lmss_vec(8) = 0; 
lmss_mat(8,1) = 0; 
lmss_mat(8,2) = 0; 
lmss_mat(8,3) = 0; 
lmss_mat(8,4) = 0; 
lmss_mat(8,5) = 0; 
lmss_mat(8,6) = 0; 
lmss_mat(8,7) = 0; 
lmss_mat(8,8) = betaUU/piUU/cUU; 
lmss_mat(8,9) = 0; 
lmss_mat(8,10) = 0; 
lmss_mat(8,11) = 0; 
lmss_vec(9) = 0; 
lmss_mat(9,1) = 1; 
lmss_mat(9,2) = 1/nbeta*betaUU/cUU*alphaUU*epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^(1-alphaUU); 
lmss_mat(9,3) = 0; 
lmss_mat(9,4) = 0; 
lmss_mat(9,5) = 0; 
lmss_mat(9,6) = 0; 
lmss_mat(9,7) = 1/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*(epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)-phiUU); 
lmss_mat(9,8) = 0; 
lmss_mat(9,9) = 0; 
lmss_mat(9,10) = 0; 
lmss_mat(9,11) = 0; 
lmss_vec(10) = psiLXUU*(wstarUU/wplusUU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wplusUU*hUU^(1+sigmaLXUU); 
lmss_mat(10,1) = 0; 
lmss_mat(10,2) = 0; 
lmss_mat(10,3) = 0; 
lmss_mat(10,4) = 0; 
lmss_mat(10,5) = 0; 
lmss_mat(10,6) = 0; 
lmss_mat(10,7) = 0; 
lmss_mat(10,8) = 0; 
lmss_mat(10,9) = 0; 
lmss_mat(10,10) = 0; 
lmss_mat(10,11) = 1-nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))/wplusUU/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 
lmss_vec(11) = -psiLXUU*(wstarUU/wplusUU)^(lambdawUU*(1+sigmaLXUU)/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wstarUU*hUU^(1+sigmaLXUU); 
lmss_mat(11,1) = -1/(1-alphaUU)/epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^alphaUU*alphaUU*lambdawUU/(lambdawUU-1)/wstarUU*wUU; 
lmss_mat(11,2) = 1/nbeta*betaUU/cUU*alphaUU*epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarUU*sUU; 
lmss_mat(11,3) = -pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarUU; 
lmss_mat(11,4) = -1+nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))/wstarUU/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(11,5) = 0; 
lmss_mat(11,6) = 1/cUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarUU; 
lmss_mat(11,7) = 1/cUU*lambdafUU*pstarUU^(lambdafUU/(lambdafUU-1))*epsilUU*kUU^alphaUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1-alphaUU)*(1-alphaUU)*lambdawUU/(lambdawUU-1)/wstarUU*sUU; 
lmss_mat(11,8) = 0; 
lmss_mat(11,9) = hUU*wstarUU^(lambdawUU/(lambdawUU-1))/(lambdawUU-1)/wstarUU/cUU; 
lmss_mat(11,10) = (hUU*wstarUU^(lambdawUU/(lambdawUU-1)))^(1+sigmaLXUU)*(1+sigmaLXUU)*lambdawUU/(lambdawUU-1)/wstarUU; 
lmss_mat(11,11) = 0; 
lmss_vec(12) = 0; 
lmss_mat(12,1) = -1/(1-alphaUU)/epsilUU*(hUU*wstarUU^(lambdawUU/(lambdawUU-1))/kUU)^alphaUU; 
lmss_mat(12,2) = 0; 
lmss_mat(12,3) = 0; 
lmss_mat(12,4) = ((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))+nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU)*(1-lambdawUU)/lambdawUU*((-1+xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU*lambdawUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))*lambdawUU/(1-lambdawUU)/wUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^lambdawUU+xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU*wstarUU)^(lambdawUU/(1-lambdawUU))); 
lmss_mat(12,5) = 0; 
lmss_mat(12,6) = 0; 
lmss_mat(12,7) = 0; 
lmss_mat(12,8) = 0; 
lmss_mat(12,9) = -betaUU*xiwUU*FwXUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wUU/piUU+1/nbeta*betaUU*xiwUU*FwXUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU))^(1/(1-lambdawUU))*(piUU*wUU/wUU)^(lambdawUU/(lambdawUU-1))*lambdawUU/(lambdawUU-1)/wUU/piUU; 
lmss_mat(12,10) = betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wUU*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU*wUU/psiLXUU-betaUU*xiwUU^2*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU-((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU/psiLXUU-((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU/psiLXUU+1/nbeta*(-betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU/psiLXUU+betaUU*xiwUU^2*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU/psiLXUU+betaUU*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*FwXUU/psiLXUU)+nbeta*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(1-lambdawUU*(1+sigmaLXUU))*(1-lambdawUU*(1+sigmaLXUU))*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))*FwXUU*wUU/psiLXUU; 
lmss_mat(12,11) = -((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))-xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))-nbeta*((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)))^((1-lambdawUU)/lambdawUU/(1+sigmaLXUU))*(1-lambdawUU)/lambdawUU/(1+sigmaLXUU)*((-1+xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))*lambdawUU*(1+sigmaLXUU)*xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU))/(1-lambdawUU)/wUU/(1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))*lambdawUU*(1+sigmaLXUU)/(1-lambdawUU)/wUU)/((1-xiwUU)*((1-xiwUU*(piUU^iotaw2UU*pibarUU^(1-iotaw2UU)*wUU/piUU/wUU)^(1/(1-lambdawUU)))/(1-xiwUU))^(lambdawUU*(1+sigmaLXUU))+xiwUU*(wplusUU*wUU*piUU^iotaw2UU*pibarUU^(1-iotaw2UU)/piUU/wUU)^(lambdawUU*(1+sigmaLXUU)/(1-lambdawUU))); 

lmss_vals = -lmss_mat \ lmss_vec; 
errcheck = max(abs(lmss_mat*lmss_vals + lmss_vec)); 


  lmult1U = lmss_vals(1); 
  lmult2U = lmss_vals(2); 
  lmult3U = lmss_vals(3); 
  lmult4U = lmss_vals(4); 
  lmult5U = lmss_vals(5); 
  lmult6U = lmss_vals(6); 
  lmult7U = lmss_vals(7); 
  lmult8U = lmss_vals(8); 
  lmult9U = lmss_vals(9); 
  lmult10U = lmss_vals(10); 
  lmult11U = lmss_vals(11); 
